/******************************************************************************
 * App.java - The JavaChess main program
 * by F.D. Larame
 * improved by Clemens Kutz, Michael Schlagmueller
 *
 * Purpose: Entry point, and not much else!
 *
 * History:
 * 07.06.00 Initial build.
 * around 2003 some improvements
 *****************************************************************************/

package javachess;

//import javax.swing.UIManager;
//import java.awt.*;
import javachess.Game;

/*****************************************************************************
 * public class App
 * The application-level class, surrounding everything else.
 *
 * Most of this code has been auto-generated by JBuilder; my role was limited
 * to re-formatting it to make it legible, and to add the Game calls at the
 * end of the main program.
 ****************************************************************************/

public class App
{
  // Constructor
  public App()
  {
    // Make the window, since Java needs one
    // We won't be making much use of it, though; all of the i/o
    // will pass through the console
//    Frame frame = new Frame();
//    frame.validate();
//    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
//    Dimension frameSize = frame.getSize();
//    if ( frameSize.height > screenSize.height )
//    {
//      frameSize.height = screenSize.height;
//    }
//    if ( frameSize.width > screenSize.width )
//    {
//      frameSize.width = screenSize.width;
//    }
//    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
//    frame.setVisible( true );
  }

  // Main method
  // Initialize and launch the Game object
  public static void main( String[] args )
  {
    // Extract the parameters
    String openingBook = "";
    String startingPos = "NONE";
    if ( args.length > 1 )
      startingPos = args[ 1 ];

    // Make the application
//    try
//    {
//      UIManager.setLookAndFeel( UIManager.getSystemLookAndFeelClassName() );
//    }
//    catch( Exception e )
//    {
//      e.printStackTrace();
//    }
//    new App();

    // Initialize the game controller
    Game theGame = new Game();
    try
    {
      theGame.InitializeGame( openingBook, startingPos );
    }
    catch( Exception e )
    {
      e.printStackTrace();
    }

    // Run the game
    try
    {
      Debug.Open("debug.txt");
//	  Debug.EnableOut = true;
	  Debug.EnableOut = false;
      System.out.println("App.main: Debug.EnableOut = " + Debug.EnableOut + "\n");
      theGame.RunGame();
      Debug.Close();
    }
    catch( Exception e )
    {
      e.printStackTrace();
    }

    System.exit( 0 );
  }
}