// CutoffHistory.cpp: Implementierung der Klasse CutoffHistory.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "stdafx.h"
#include "CutoffHistory.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#endif

int* CutoffHistory::pCurrentHistory;

/***************************************************************************
 * Static Class members
 **************************************************************************/
CutoffHistory *CutoffHistory::theInstance = NULL;


/***************************************************************************
 * Constructor / Destructor
 **************************************************************************/
CutoffHistory::CutoffHistory()
{
	Forget();
}



/***************************************************************************
 * Static Operations
 **************************************************************************/
CutoffHistory *CutoffHistory::GetInstance() 
{ 
	if ( theInstance == NULL ) 
		theInstance = new CutoffHistory();
		
	return theInstance;
}

/***************************************************************************
 * Operations
 **************************************************************************/
bool CutoffHistory::AddCount( int whichPlayer, Move *mov, int depth)
{
	History[ whichPlayer ][ mov->SourceSquare ][ mov->DestinationSquare ] += depth * depth;
	return true;
}



bool CutoffHistory::Forget()
{
	for( int i = 0; i < 2; i++ )
		for( int j = 0; j < 64; j++ )
			for( int k = 0; k < 64; k++ )
				History[ i ][ j ][ k ] = 0;
	return true;
}


// Jon L. Bentley and M. Douglas McIlroy's "Engineering a Sort Function", Software-Practice 
// and Experience, Vol. 23( 11 ) P. 1249-1265 ( November 1993 )
bool CutoffHistory::SortMoveList( MoveListGenerator *theListGenerator, int movingPlayer )
{
    // Which history will we use?
    pCurrentHistory = ( int * ) History[ movingPlayer ];

	theListGenerator->Sort();  // uses quicksort

    return true;
}

void CutoffHistory::Print() {
   for ( int side = 0; side < 2; side++ ) {
	   if ( side == Player::SIDE_WHITE ) {
		   *Output::cout << "Table white:" << endl;
	   } else {
		   *Output::cout << "Table black:" << endl;
	   }
	   for ( int y = 0; y < 64; y++ )
		   for ( int x = 0; x < 64; x++ )
			   if ( History[ side ][ x ][ y ] != 0 ) {
				   *Output::cout << "[" << x << " ][ " << y << " " << History[ side ][ x ][ y ] << endl;
			   }
   }
}

istream& CutoffHistory::read( istream &is ) const
{
	is.read( ( char* )this, sizeof( CutoffHistory ) );
	return is;
}


ostream& CutoffHistory::write( ostream &os ) const
{
	os.write( ( char* )this, sizeof( CutoffHistory ) );
	return os;
}
