// Date.cpp: Implementierung der Klasse Date.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Date.h"

/***************************************************************************
 * Constructor / Destructor
 **************************************************************************/

Date::Date()
{
	Day   = 1;
	Month = 1;
	Year  = 1900;
}



Date::Date( time_t *t )
{
	Set( t );
}




Date::~Date()
{

}
	

/***************************************************************************
 * Operations
 **************************************************************************/

bool Date::Set ( unsigned char d, unsigned char m,  unsigned int y )
{
	if ( ( m < 1 ) && ( m > 12 ) )	return false;

	// check day
	if ( d < 1  ) return false;

	switch ( m ) {
		case  1: if ( d > 31 ) return false; break;
		case  2: 
			// year 2000 was a leap year and every 4 years there's a leap year
			if ( ( y % 4 == 0 ) && d > 29 ) return false; 
			if ( ( y % 4 != 0 ) && d > 28 ) return false; 
			break;
		case  3: if ( d > 31 ) return false; break;
		case  4: if ( d > 30 ) return false; break;
		case  5: if ( d > 31 ) return false; break;
		case  6: if ( d > 30 ) return false; break;
		case  7: if ( d > 31 ) return false; break;
		case  8: if ( d > 31 ) return false; break;
		case  9: if ( d > 30 ) return false; break;
		case 10: if ( d > 31 ) return false; break;
		case 11: if ( d > 30 ) return false; break;
		case 12: if ( d > 31 ) return false; break;
	}	

	// This date is valid !!!
	Year  = y;
	Month = m;
	Day   = d;

	return true;
}



bool Date::Set( struct tm *date )
{
	return Set( ( unsigned char ) date->tm_mday, ( unsigned char ) date->tm_mon + 1, ( unsigned int ) date->tm_year + 1900 );
}



bool Date::Set( time_t *date )
{
	return Set( localtime( date ) );
}



string *Date::toStringYYYYMMDD( const char delimiter )
{
	static string S( "" );
	char buff[ 12 ];

	S = "";

	// At first the year ... 
	itoa( Year, buff, 10 );
	S += buff;
	S += delimiter;

	// second the month ...
	itoa( Month, buff, 10 );
	if ( strlen( buff ) == 1 )
		S += ( ( string ) "0" + buff );
		else
		S += buff;
	S += delimiter;

	// at last the day!
	itoa( Day, buff, 10 );
	if ( strlen( buff ) == 1 )
		S += ( ( string ) "0" + buff );
		else
		S += buff;
		
	return &S;
}
