// Game.h: Schnittstelle fr die Klasse Game.
//
//////////////////////////////////////////////////////////////////////

#if !defined( AFX_GAME_H__0C6F4B23_E279_4A5B_8032_4FB39DD513DE__INCLUDED_ )
#define AFX_GAME_H__0C6F4B23_E279_4A5B_8032_4FB39DD513DE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "OpeningBook.h"
#include "Board.h"
#include "Player.h"
#include "PlayerAI.h"
#include "PlayerHuman.h"
#include "WinBoardConnection.h"

class Game  
{
private:
	OpeningBook		*Openings;
	Board			GameBoard;
	PGNExporter		*Exporter;
	WinBoardConnection* myWinBoardConnection;

	bool WinBoard;
	static Game* pthis;
	static const string LastMoveFilename;
	fstream LastMove;

public:
	bool save( string FileName );
	bool load( string FileName );
	bool restoreLastMove();
	bool storeLastMove();
	static const int HUMAN;
	static const int AI;
	static const int HUMANWINBOARD;
	static const int AIWINBOARD;
	static const string Version;
	
	Game( string openingBook );
	Game( string openingBook, char *logfilename );
	virtual ~Game();

	Player			*Players[ 2 ];
	string GetPlayerName( const int which );
	bool SetPlayer( int which, int type, char *name );
	bool SetPlayerWhite( int type, char *name );
	bool SetPlayerBlack( int type, char *name );
	bool SetupGameBoard( char *filename );
	bool RunGame();
	static Game* GetInstance();

	static bool CheckProgramConsistency();
};

#endif // !defined( AFX_GAME_H__0C6F4B23_E279_4A5B_8032_4FB39DD513DE__INCLUDED_ )
