// PGNExporter.h: Schnittstelle fr die Klasse PGNExporter.
//
//////////////////////////////////////////////////////////////////////

#if !defined( AFX_PGNFILE_H__ED788C8C_3478_42E2_8FD2_C2001F4EAD7D__INCLUDED_ )
#define AFX_PGNFILE_H__ED788C8C_3478_42E2_8FD2_C2001F4EAD7D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "date.h"

class PGNExporter 
{
private:
	char GameEvent[ 255 ];
	char GameSite [ 255 ];
	Date GameDate;
	int GameRound;
	char PlayerWhite[ 255 ];
	char PlayerBlack[ 255 ];
	char GameResult [ 255 ];
	string FileName;
	int  CurrentPlayer;

	/** 
	  * This Class can be used to load or write a PGN File
	  */
	int  MoveCounter;

	vector<Move> Moves;

	FILE *FileHandler;

	bool WriteGameTerminationMarker();
	bool WriteTagPairs();
	bool WriteMoves();

protected:


public:
	static const int RESULT_WHITE_WINS;
	static const int RESULT_BLACK_WINS;
	static const int RESULT_DRAW_GAME;
	static const int RESULT_UNKNOWN;

	
	PGNExporter();
	virtual ~PGNExporter();

	bool Create( char *filename );
	bool Open( char *filename );
	bool AppendMove( Move *mov );
	bool Close();
		
	/** Accessors */
	bool SetGameEvent( const char *s )	{ strcpy( GameEvent, s );	return true; }
	bool SetGameSite( const char *s )	{ strcpy( GameSite, s );	return true; }
	bool SetGameDate( time_t *t )		{ GameDate.Set( t );		return true; }
	bool SetGameRound( const int i )	{ GameRound = i;			return true; }
	
	bool SetCurrentPlayer ( const int which );
	bool SetWhitePlayer( const char *s )	{ strcpy( PlayerWhite, s ); return true; }
	bool SetBlackPlayer( const char *s )	{ strcpy( PlayerBlack, s ); return true; }
	
	bool SetGameResult( int result );

	void GetFileName( string *s ) { *s = FileName; } ;

};

#endif // !defined( AFX_PGNFILE_H__ED788C8C_3478_42E2_8FD2_C2001F4EAD7D__INCLUDED_ )
