// PGNParser.h: Schnittstelle fr die Klasse PGNParser.
//
//////////////////////////////////////////////////////////////////////

#if !defined( AFX_PGNPARSER_H__11DFF58A_4E77_4F47_A48F_A7911EDF3255__INCLUDED_ )
#define AFX_PGNPARSER_H__11DFF58A_4E77_4F47_A48F_A7911EDF3255__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class PGNParser  
{
private:
	istream* PGNFile;
	void PGNtoCoordMove( const char *pgn, char *coord, int *rating );
	int CoordToSqr( const char *coord );
	void SqrToCoord( int sqr, char *coord );
	Board PGNBoard;
	int brackets;
	int brackets2;
	bool comment;
	bool takenext;
	MoveListGenerator Moves;
	
public:
	static const int WINNER_DRAW;
	static const int WINNER_WHITE;
	static const int WINNER_BLACK;
	static const int WINNER_UNKNOWN;
	static const int SIDE_WHITE;
	static const int SIDE_BLACK;
	PGNParser( istream& PGNFile );
	bool nextMatch();
	bool getNextMove( Move** PGNMove, int *rating );
	int winner;
	int matchNo;
	int moveNo;
	virtual ~PGNParser();
	static int getPromotionType( const char c );
	string PlayerWhite;
	string PlayerBlack;
};

#endif // !defined( AFX_PGNPARSER_H__11DFF58A_4E77_4F47_A48F_A7911EDF3255__INCLUDED_ )
