// PlayerAI.h: Schnittstelle fr die Klasse PlayerAI.
//
//////////////////////////////////////////////////////////////////////

#if !defined( AFX_PLAYERAI_H__AFE44926_8E88_480F_987C_CAEB5C7CD7E8__INCLUDED_ )
#define AFX_PLAYERAI_H__AFE44926_8E88_480F_987C_CAEB5C7CD7E8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Player.h"
#include "AISearchAgent.h"
#include "OpeningBook.h"

class PlayerAI : public Player
{
/***************************************************************************
 * Data Members
 **************************************************************************/
private:
	// The search agent in charge of the moves
	AISearchAgent* Agent;
public:
/***************************************************************************
 * Constructor / Destructor
 **************************************************************************/
	PlayerAI( int whichPlayer, int whichType, OpeningBook* ref );
	virtual ~PlayerAI();


/***************************************************************************
 * Operations
 **************************************************************************/
	// Attach a search agent to the AI player
	bool AttachSearchAgent( AISearchAgent* theAgent );
  
	// Getting a move from the machine
	bool GetMove( Board* theBoard, Move* mov );
	istream& read ( istream& is ) const;
	ostream& write( ostream& os ) const;
	void ShowStats();
};

#endif // !defined( AFX_PLAYERAI_H__AFE44926_8E88_480F_987C_CAEB5C7CD7E8__INCLUDED_ )
