// MoveListGenerator.cpp: Implementierung der Klasse MoveListGenerator.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MoveListGenerator.h"

/***************************************************************************
 * Static Class members
 **************************************************************************/
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#endif

vector<int> MoveListGenerator::KnightMoves[ 64 ];
vector<int> MoveListGenerator::KingMoves[ 64 ];
vector<intvector> MoveListGenerator::BishopMoves[ 64 ];
vector<intvector> MoveListGenerator::RookMoves[ 64 ];


/***************************************************************************
 * Constructor / Destructor
 **************************************************************************/

MoveListGenerator::MoveListGenerator()
{
    Moves.reserve( 10 );
    ResetIterator();
}



MoveListGenerator::~MoveListGenerator()
{


}

/***************************************************************************
 * Operations
 **************************************************************************/

void MoveListGenerator::InitStatics()
{
	// Define the KnightMoves data structure;
    KnightMoves[ 0 ].push_back( 10 );
    KnightMoves[ 0 ].push_back( 17 );
    KnightMoves[ 1 ].push_back( 16 );
    KnightMoves[ 1 ].push_back( 18 );
    KnightMoves[ 1 ].push_back( 11 );
    KnightMoves[ 2 ].push_back( 8 );
    KnightMoves[ 2 ].push_back( 12 );
    KnightMoves[ 2 ].push_back( 17 );
    KnightMoves[ 2 ].push_back( 19 );
    KnightMoves[ 3 ].push_back( 9 );
    KnightMoves[ 3 ].push_back( 13 );
    KnightMoves[ 3 ].push_back( 18 );
    KnightMoves[ 3 ].push_back( 20 );
    KnightMoves[ 4 ].push_back( 10 );
    KnightMoves[ 4 ].push_back( 14 );
    KnightMoves[ 4 ].push_back( 21 );
    KnightMoves[ 4 ].push_back( 19 );
    KnightMoves[ 5 ].push_back( 11 );
    KnightMoves[ 5 ].push_back( 15 );
    KnightMoves[ 5 ].push_back( 22 );
    KnightMoves[ 5 ].push_back( 20 );
    KnightMoves[ 6 ].push_back( 12 );
    KnightMoves[ 6 ].push_back( 21 );
    KnightMoves[ 6 ].push_back( 23 );
    KnightMoves[ 7 ].push_back( 13 );
    KnightMoves[ 7 ].push_back( 22 );

    KnightMoves[ 8 ].push_back( 2 );
    KnightMoves[ 8 ].push_back( 18 );
    KnightMoves[ 8 ].push_back( 25 );
    KnightMoves[ 9 ].push_back( 3 );
    KnightMoves[ 9 ].push_back( 19 );
    KnightMoves[ 9 ].push_back( 24 );
    KnightMoves[ 9 ].push_back( 26 );
    KnightMoves[ 10 ].push_back( 0 );
    KnightMoves[ 10 ].push_back( 4 );
    KnightMoves[ 10 ].push_back( 20 );
    KnightMoves[ 10 ].push_back( 27 );
    KnightMoves[ 10 ].push_back( 25 );
    KnightMoves[ 10 ].push_back( 16 );
    KnightMoves[ 11 ].push_back( 1 );
    KnightMoves[ 11 ].push_back( 5 );
    KnightMoves[ 11 ].push_back( 21 );
    KnightMoves[ 11 ].push_back( 28 );
    KnightMoves[ 11 ].push_back( 26 );
    KnightMoves[ 11 ].push_back( 17 );
    KnightMoves[ 12 ].push_back( 2 );
    KnightMoves[ 12 ].push_back( 6 );
    KnightMoves[ 12 ].push_back( 22 );
    KnightMoves[ 12 ].push_back( 29 );
    KnightMoves[ 12 ].push_back( 27 );
    KnightMoves[ 12 ].push_back( 18 );
    KnightMoves[ 13 ].push_back( 3 );
    KnightMoves[ 13 ].push_back( 7 );
    KnightMoves[ 13 ].push_back( 23 );
    KnightMoves[ 13 ].push_back( 30 );
    KnightMoves[ 13 ].push_back( 28 );
    KnightMoves[ 13 ].push_back( 19 );
    KnightMoves[ 14 ].push_back( 31 );
    KnightMoves[ 14 ].push_back( 29 );
    KnightMoves[ 14 ].push_back( 20 );
    KnightMoves[ 14 ].push_back( 4 );
    KnightMoves[ 15 ].push_back( 5 );
    KnightMoves[ 15 ].push_back( 21 );
    KnightMoves[ 15 ].push_back( 30 );

    KnightMoves[ 16 ].push_back( 1 );
    KnightMoves[ 16 ].push_back( 10 );
    KnightMoves[ 16 ].push_back( 26 );
    KnightMoves[ 16 ].push_back( 33 );
    KnightMoves[ 17 ].push_back( 0 );
    KnightMoves[ 17 ].push_back( 2 );
    KnightMoves[ 17 ].push_back( 11 );
    KnightMoves[ 17 ].push_back( 27 );
    KnightMoves[ 17 ].push_back( 34 );
    KnightMoves[ 17 ].push_back( 32 );
    KnightMoves[ 18 ].push_back( 1 );
    KnightMoves[ 18 ].push_back( 3 );
    KnightMoves[ 18 ].push_back( 12 );
    KnightMoves[ 18 ].push_back( 28 );
    KnightMoves[ 18 ].push_back( 35 );
    KnightMoves[ 18 ].push_back( 33 );
    KnightMoves[ 18 ].push_back( 24 );
    KnightMoves[ 18 ].push_back( 8 );
    KnightMoves[ 19 ].push_back( 2 );
    KnightMoves[ 19 ].push_back( 4 );
    KnightMoves[ 19 ].push_back( 13 );
    KnightMoves[ 19 ].push_back( 29 );
    KnightMoves[ 19 ].push_back( 36 );
    KnightMoves[ 19 ].push_back( 34 );
    KnightMoves[ 19 ].push_back( 25 );
    KnightMoves[ 19 ].push_back( 9 );
    KnightMoves[ 20 ].push_back( 3 );
    KnightMoves[ 20 ].push_back( 5 );
    KnightMoves[ 20 ].push_back( 14 );
    KnightMoves[ 20 ].push_back( 30 );
    KnightMoves[ 20 ].push_back( 37 );
    KnightMoves[ 20 ].push_back( 35 );
    KnightMoves[ 20 ].push_back( 26 );
    KnightMoves[ 20 ].push_back( 10 );
    KnightMoves[ 21 ].push_back( 4 );
    KnightMoves[ 21 ].push_back( 6 );
    KnightMoves[ 21 ].push_back( 15 );
    KnightMoves[ 21 ].push_back( 31 );
    KnightMoves[ 21 ].push_back( 38 );
    KnightMoves[ 21 ].push_back( 36 );
    KnightMoves[ 21 ].push_back( 27 );
    KnightMoves[ 21 ].push_back( 11 );
    KnightMoves[ 22 ].push_back( 5 );
    KnightMoves[ 22 ].push_back( 7 );
    KnightMoves[ 22 ].push_back( 39 );
    KnightMoves[ 22 ].push_back( 37 );
    KnightMoves[ 22 ].push_back( 28 );
    KnightMoves[ 22 ].push_back( 12 );
    KnightMoves[ 23 ].push_back( 6 );
    KnightMoves[ 23 ].push_back( 38 );
    KnightMoves[ 23 ].push_back( 29 );
    KnightMoves[ 23 ].push_back( 13 );

    KnightMoves[ 24 ].push_back( 9 );
    KnightMoves[ 24 ].push_back( 18 );
    KnightMoves[ 24 ].push_back( 34 );
    KnightMoves[ 24 ].push_back( 41 );
    KnightMoves[ 25 ].push_back( 8 );
    KnightMoves[ 25 ].push_back( 10 );
    KnightMoves[ 25 ].push_back( 19 );
    KnightMoves[ 25 ].push_back( 35 );
    KnightMoves[ 25 ].push_back( 42 );
    KnightMoves[ 25 ].push_back( 40 );
    KnightMoves[ 26 ].push_back( 9 );
    KnightMoves[ 26 ].push_back( 11 );
    KnightMoves[ 26 ].push_back( 20 );
    KnightMoves[ 26 ].push_back( 36 );
    KnightMoves[ 26 ].push_back( 43 );
    KnightMoves[ 26 ].push_back( 41 );
    KnightMoves[ 26 ].push_back( 32 );
    KnightMoves[ 26 ].push_back( 16 );
    KnightMoves[ 27 ].push_back( 10 );
    KnightMoves[ 27 ].push_back( 12 );
    KnightMoves[ 27 ].push_back( 21 );
    KnightMoves[ 27 ].push_back( 37 );
    KnightMoves[ 27 ].push_back( 44 );
    KnightMoves[ 27 ].push_back( 42 );
    KnightMoves[ 27 ].push_back( 33 );
    KnightMoves[ 27 ].push_back( 17 );
    KnightMoves[ 28 ].push_back( 11 );
    KnightMoves[ 28 ].push_back( 13 );
    KnightMoves[ 28 ].push_back( 22 );
    KnightMoves[ 28 ].push_back( 38 );
    KnightMoves[ 28 ].push_back( 45 );
    KnightMoves[ 28 ].push_back( 43 );
    KnightMoves[ 28 ].push_back( 34 );
    KnightMoves[ 28 ].push_back( 18 );
    KnightMoves[ 29 ].push_back( 12 );
    KnightMoves[ 29 ].push_back( 14 );
    KnightMoves[ 29 ].push_back( 23 );
    KnightMoves[ 29 ].push_back( 39 );
    KnightMoves[ 29 ].push_back( 46 );
    KnightMoves[ 29 ].push_back( 44 );
    KnightMoves[ 29 ].push_back( 35 );
    KnightMoves[ 29 ].push_back( 19 );
    KnightMoves[ 30 ].push_back( 13 );
    KnightMoves[ 30 ].push_back( 15 );
    KnightMoves[ 30 ].push_back( 47 );
    KnightMoves[ 30 ].push_back( 45 );
    KnightMoves[ 30 ].push_back( 36 );
    KnightMoves[ 30 ].push_back( 20 );
    KnightMoves[ 31 ].push_back( 14 );
    KnightMoves[ 31 ].push_back( 46 );
    KnightMoves[ 31 ].push_back( 37 );
    KnightMoves[ 31 ].push_back( 21 );

    KnightMoves[ 32 ].push_back( 17 );
    KnightMoves[ 32 ].push_back( 26 );
    KnightMoves[ 32 ].push_back( 42 );
    KnightMoves[ 32 ].push_back( 49 );
    KnightMoves[ 33 ].push_back( 16 );
    KnightMoves[ 33 ].push_back( 18 );
    KnightMoves[ 33 ].push_back( 27 );
    KnightMoves[ 33 ].push_back( 43 );
    KnightMoves[ 33 ].push_back( 50 );
    KnightMoves[ 33 ].push_back( 48 );
    KnightMoves[ 34 ].push_back( 17 );
    KnightMoves[ 34 ].push_back( 19 );
    KnightMoves[ 34 ].push_back( 28 );
    KnightMoves[ 34 ].push_back( 44 );
    KnightMoves[ 34 ].push_back( 51 );
    KnightMoves[ 34 ].push_back( 49 );
    KnightMoves[ 34 ].push_back( 40 );
    KnightMoves[ 34 ].push_back( 24 );
    KnightMoves[ 35 ].push_back( 18 );
    KnightMoves[ 35 ].push_back( 20 );
    KnightMoves[ 35 ].push_back( 29 );
    KnightMoves[ 35 ].push_back( 45 );
    KnightMoves[ 35 ].push_back( 52 );
    KnightMoves[ 35 ].push_back( 50 );
    KnightMoves[ 35 ].push_back( 41 );
    KnightMoves[ 35 ].push_back( 25 );
    KnightMoves[ 36 ].push_back( 19 );
    KnightMoves[ 36 ].push_back( 21 );
    KnightMoves[ 36 ].push_back( 30 );
    KnightMoves[ 36 ].push_back( 46 );
    KnightMoves[ 36 ].push_back( 53 );
    KnightMoves[ 36 ].push_back( 51 );
    KnightMoves[ 36 ].push_back( 42 );
    KnightMoves[ 36 ].push_back( 26 );
    KnightMoves[ 37 ].push_back( 20 );
    KnightMoves[ 37 ].push_back( 22 );
    KnightMoves[ 37 ].push_back( 31 );
    KnightMoves[ 37 ].push_back( 47 );
    KnightMoves[ 37 ].push_back( 54 );
    KnightMoves[ 37 ].push_back( 52 );
    KnightMoves[ 37 ].push_back( 43 );
    KnightMoves[ 37 ].push_back( 27 );
    KnightMoves[ 38 ].push_back( 21 );
    KnightMoves[ 38 ].push_back( 23 );
    KnightMoves[ 38 ].push_back( 55 );
    KnightMoves[ 38 ].push_back( 53 );
    KnightMoves[ 38 ].push_back( 44 );
    KnightMoves[ 38 ].push_back( 28 );
    KnightMoves[ 39 ].push_back( 22 );
    KnightMoves[ 39 ].push_back( 54 );
    KnightMoves[ 39 ].push_back( 45 );
    KnightMoves[ 39 ].push_back( 29 );

    KnightMoves[ 40 ].push_back( 25 );
    KnightMoves[ 40 ].push_back( 34 );
    KnightMoves[ 40 ].push_back( 50 );
    KnightMoves[ 40 ].push_back( 57 );
    KnightMoves[ 41 ].push_back( 26 );
    KnightMoves[ 41 ].push_back( 24 );
    KnightMoves[ 41 ].push_back( 35 );
    KnightMoves[ 41 ].push_back( 51 );
    KnightMoves[ 41 ].push_back( 58 );
    KnightMoves[ 41 ].push_back( 56 );
    KnightMoves[ 42 ].push_back( 25 );
    KnightMoves[ 42 ].push_back( 27 );
    KnightMoves[ 42 ].push_back( 36 );
    KnightMoves[ 42 ].push_back( 52 );
    KnightMoves[ 42 ].push_back( 59 );
    KnightMoves[ 42 ].push_back( 57 );
    KnightMoves[ 42 ].push_back( 48 );
    KnightMoves[ 42 ].push_back( 32 );
    KnightMoves[ 43 ].push_back( 26 );
    KnightMoves[ 43 ].push_back( 28 );
    KnightMoves[ 43 ].push_back( 37 );
    KnightMoves[ 43 ].push_back( 53 );
    KnightMoves[ 43 ].push_back( 60 );
    KnightMoves[ 43 ].push_back( 58 );
    KnightMoves[ 43 ].push_back( 49 );
    KnightMoves[ 43 ].push_back( 33 );
    KnightMoves[ 44 ].push_back( 27 );
    KnightMoves[ 44 ].push_back( 29 );
    KnightMoves[ 44 ].push_back( 38 );
    KnightMoves[ 44 ].push_back( 54 );
    KnightMoves[ 44 ].push_back( 61 );
    KnightMoves[ 44 ].push_back( 59 );
    KnightMoves[ 44 ].push_back( 50 );
    KnightMoves[ 44 ].push_back( 34 );
    KnightMoves[ 45 ].push_back( 28 );
    KnightMoves[ 45 ].push_back( 30 );
    KnightMoves[ 45 ].push_back( 39 );
    KnightMoves[ 45 ].push_back( 55 );
    KnightMoves[ 45 ].push_back( 62 );
    KnightMoves[ 45 ].push_back( 60 );
    KnightMoves[ 45 ].push_back( 51 );
    KnightMoves[ 45 ].push_back( 35 );
    KnightMoves[ 46 ].push_back( 29 );
    KnightMoves[ 46 ].push_back( 31 );
    KnightMoves[ 46 ].push_back( 63 );
    KnightMoves[ 46 ].push_back( 61 );
    KnightMoves[ 46 ].push_back( 52 );
    KnightMoves[ 46 ].push_back( 36 );
    KnightMoves[ 47 ].push_back( 30 );
    KnightMoves[ 47 ].push_back( 62 );
    KnightMoves[ 47 ].push_back( 53 );
    KnightMoves[ 47 ].push_back( 37 );

    KnightMoves[ 48 ].push_back( 33 );
    KnightMoves[ 48 ].push_back( 42 );
    KnightMoves[ 48 ].push_back( 58 );
    KnightMoves[ 49 ].push_back( 32 );
    KnightMoves[ 49 ].push_back( 34 );
    KnightMoves[ 49 ].push_back( 43 );
    KnightMoves[ 49 ].push_back( 59 );
    KnightMoves[ 50 ].push_back( 40 );
    KnightMoves[ 50 ].push_back( 33 );
    KnightMoves[ 50 ].push_back( 35 );
    KnightMoves[ 50 ].push_back( 44 );
    KnightMoves[ 50 ].push_back( 60 );
    KnightMoves[ 50 ].push_back( 56 );
    KnightMoves[ 51 ].push_back( 41 );
    KnightMoves[ 51 ].push_back( 34 );
    KnightMoves[ 51 ].push_back( 36 );
    KnightMoves[ 51 ].push_back( 45 );
    KnightMoves[ 51 ].push_back( 61 );
    KnightMoves[ 51 ].push_back( 57 );
    KnightMoves[ 52 ].push_back( 42 );
    KnightMoves[ 52 ].push_back( 35 );
    KnightMoves[ 52 ].push_back( 37 );
    KnightMoves[ 52 ].push_back( 46 );
    KnightMoves[ 52 ].push_back( 62 );
    KnightMoves[ 52 ].push_back( 58 );
    KnightMoves[ 53 ].push_back( 43 );
    KnightMoves[ 53 ].push_back( 36 );
    KnightMoves[ 53 ].push_back( 38 );
    KnightMoves[ 53 ].push_back( 47 );
    KnightMoves[ 53 ].push_back( 63 );
    KnightMoves[ 53 ].push_back( 59 );
    KnightMoves[ 54 ].push_back( 39 );
    KnightMoves[ 54 ].push_back( 60 );
    KnightMoves[ 54 ].push_back( 44 );
    KnightMoves[ 54 ].push_back( 37 );
    KnightMoves[ 55 ].push_back( 38 );
    KnightMoves[ 55 ].push_back( 45 );
    KnightMoves[ 55 ].push_back( 61 );

    KnightMoves[ 56 ].push_back( 41 );
    KnightMoves[ 56 ].push_back( 50 );
    KnightMoves[ 57 ].push_back( 40 );
    KnightMoves[ 57 ].push_back( 42 );
    KnightMoves[ 57 ].push_back( 51 );
    KnightMoves[ 58 ].push_back( 48 );
    KnightMoves[ 58 ].push_back( 41 );
    KnightMoves[ 58 ].push_back( 43 );
    KnightMoves[ 58 ].push_back( 52 );
    KnightMoves[ 59 ].push_back( 49 );
    KnightMoves[ 59 ].push_back( 42 );
    KnightMoves[ 59 ].push_back( 44 );
    KnightMoves[ 59 ].push_back( 53 );
    KnightMoves[ 60 ].push_back( 50 );
    KnightMoves[ 60 ].push_back( 43 );
    KnightMoves[ 60 ].push_back( 45 );
    KnightMoves[ 60 ].push_back( 54 );
    KnightMoves[ 61 ].push_back( 51 );
    KnightMoves[ 61 ].push_back( 44 );
    KnightMoves[ 61 ].push_back( 46 );
    KnightMoves[ 61 ].push_back( 55 );
    KnightMoves[ 62 ].push_back( 52 );
    KnightMoves[ 62 ].push_back( 45 );
    KnightMoves[ 62 ].push_back( 47 );
    KnightMoves[ 63 ].push_back( 53 );
    KnightMoves[ 63 ].push_back( 46 );

    KingMoves[ 0 ].push_back( 1 );
    KingMoves[ 0 ].push_back( 8 );
    KingMoves[ 0 ].push_back( 9 );
    KingMoves[ 1 ].push_back( 0 );
    KingMoves[ 1 ].push_back( 2 );
    KingMoves[ 1 ].push_back( 8 );
    KingMoves[ 1 ].push_back( 9 );
    KingMoves[ 1 ].push_back( 10 );
    KingMoves[ 2 ].push_back( 1 );
    KingMoves[ 2 ].push_back( 3 );
    KingMoves[ 2 ].push_back( 9 );
    KingMoves[ 2 ].push_back( 10 );
    KingMoves[ 2 ].push_back( 11 );
    KingMoves[ 3 ].push_back( 2 );
    KingMoves[ 3 ].push_back( 4 );
    KingMoves[ 3 ].push_back( 10 );
    KingMoves[ 3 ].push_back( 11 );
    KingMoves[ 3 ].push_back( 12 );
	KingMoves[ 4 ].push_back( 3 );
    KingMoves[ 4 ].push_back( 5 );
    KingMoves[ 4 ].push_back( 11 );
    KingMoves[ 4 ].push_back( 12 );
    KingMoves[ 4 ].push_back( 13 );
    KingMoves[ 5 ].push_back( 4 );
    KingMoves[ 5 ].push_back( 6 );
    KingMoves[ 5 ].push_back( 12 );
    KingMoves[ 5 ].push_back( 13 );
    KingMoves[ 5 ].push_back( 14 );
    KingMoves[ 6 ].push_back( 5 );
    KingMoves[ 6 ].push_back( 7 );
    KingMoves[ 6 ].push_back( 13 );
    KingMoves[ 6 ].push_back( 14 );
    KingMoves[ 6 ].push_back( 15 );
    KingMoves[ 7 ].push_back( 6 );
    KingMoves[ 7 ].push_back( 14 );
    KingMoves[ 7 ].push_back( 15 );

    KingMoves[ 8 ].push_back( 0 );
    KingMoves[ 8 ].push_back( 1 );
    KingMoves[ 8 ].push_back( 9 );
    KingMoves[ 8 ].push_back( 17 );
    KingMoves[ 8 ].push_back( 16 );
    KingMoves[ 9 ].push_back( 0 );
    KingMoves[ 9 ].push_back( 1 );
    KingMoves[ 9 ].push_back( 2 );
    KingMoves[ 9 ].push_back( 8 );
    KingMoves[ 9 ].push_back( 10 );
    KingMoves[ 9 ].push_back( 16 );
    KingMoves[ 9 ].push_back( 17 );
    KingMoves[ 9 ].push_back( 18 );
    KingMoves[ 10 ].push_back( 1 );
    KingMoves[ 10 ].push_back( 2 );
    KingMoves[ 10 ].push_back( 3 );
    KingMoves[ 10 ].push_back( 9 );
    KingMoves[ 10 ].push_back( 11 );
    KingMoves[ 10 ].push_back( 17 );
    KingMoves[ 10 ].push_back( 18 );
    KingMoves[ 10 ].push_back( 19 );
    KingMoves[ 11 ].push_back( 2 );
    KingMoves[ 11 ].push_back( 3 );
    KingMoves[ 11 ].push_back( 4 );
    KingMoves[ 11 ].push_back( 10 );
    KingMoves[ 11 ].push_back( 12 );
    KingMoves[ 11 ].push_back( 18 );
    KingMoves[ 11 ].push_back( 19 );
    KingMoves[ 11 ].push_back( 20 );
    KingMoves[ 12 ].push_back( 3 );
    KingMoves[ 12 ].push_back( 4 );
    KingMoves[ 12 ].push_back( 5 );
    KingMoves[ 12 ].push_back( 11 );
    KingMoves[ 12 ].push_back( 13 );
    KingMoves[ 12 ].push_back( 19 );
    KingMoves[ 12 ].push_back( 20 );
    KingMoves[ 12 ].push_back( 21 );
    KingMoves[ 13 ].push_back( 4 );
    KingMoves[ 13 ].push_back( 5 );
    KingMoves[ 13 ].push_back( 6 );
    KingMoves[ 13 ].push_back( 12 );
    KingMoves[ 13 ].push_back( 14 );
    KingMoves[ 13 ].push_back( 20 );
    KingMoves[ 13 ].push_back( 21 );
    KingMoves[ 13 ].push_back( 22 );
    KingMoves[ 14 ].push_back( 5 );
    KingMoves[ 14 ].push_back( 6 );
    KingMoves[ 14 ].push_back( 7 );
    KingMoves[ 14 ].push_back( 13 );
    KingMoves[ 14 ].push_back( 15 );
    KingMoves[ 14 ].push_back( 21 );
    KingMoves[ 14 ].push_back( 22 );
    KingMoves[ 14 ].push_back( 23 );
    KingMoves[ 15 ].push_back( 6 );
    KingMoves[ 15 ].push_back( 7 );
    KingMoves[ 15 ].push_back( 14 );
    KingMoves[ 15 ].push_back( 22 );
    KingMoves[ 15 ].push_back( 23 );

    KingMoves[ 16 ].push_back( 9 );
    KingMoves[ 16 ].push_back( 8 );
    KingMoves[ 16 ].push_back( 17 );
    KingMoves[ 16 ].push_back( 24 );
    KingMoves[ 16 ].push_back( 25 );
    KingMoves[ 17 ].push_back( 8 );
    KingMoves[ 17 ].push_back( 9 );
    KingMoves[ 17 ].push_back( 10 );
    KingMoves[ 17 ].push_back( 16 );
    KingMoves[ 17 ].push_back( 18 );
    KingMoves[ 17 ].push_back( 24 );
    KingMoves[ 17 ].push_back( 25 );
    KingMoves[ 17 ].push_back( 26 );
    KingMoves[ 18 ].push_back( 9 );
    KingMoves[ 18 ].push_back( 10 );
    KingMoves[ 18 ].push_back( 11 );
    KingMoves[ 18 ].push_back( 17 );
    KingMoves[ 18 ].push_back( 19 );
    KingMoves[ 18 ].push_back( 25 );
    KingMoves[ 18 ].push_back( 26 );
    KingMoves[ 18 ].push_back( 27 );
    KingMoves[ 19 ].push_back( 10 );
    KingMoves[ 19 ].push_back( 11 );
    KingMoves[ 19 ].push_back( 12 );
    KingMoves[ 19 ].push_back( 18 );
    KingMoves[ 19 ].push_back( 20 );
    KingMoves[ 19 ].push_back( 26 );
    KingMoves[ 19 ].push_back( 27 );
    KingMoves[ 19 ].push_back( 28 );
    KingMoves[ 20 ].push_back( 11 );
    KingMoves[ 20 ].push_back( 12 );
    KingMoves[ 20 ].push_back( 13 );
    KingMoves[ 20 ].push_back( 19 );
    KingMoves[ 20 ].push_back( 21 );
    KingMoves[ 20 ].push_back( 27 );
    KingMoves[ 20 ].push_back( 28 );
    KingMoves[ 20 ].push_back( 29 );
    KingMoves[ 21 ].push_back( 12 );
    KingMoves[ 21 ].push_back( 13 );
    KingMoves[ 21 ].push_back( 14 );
    KingMoves[ 21 ].push_back( 20 );
    KingMoves[ 21 ].push_back( 22 );
    KingMoves[ 21 ].push_back( 28 );
    KingMoves[ 21 ].push_back( 29 );
    KingMoves[ 21 ].push_back( 30 );
    KingMoves[ 22 ].push_back( 13 );
    KingMoves[ 22 ].push_back( 14 );
    KingMoves[ 22 ].push_back( 15 );
    KingMoves[ 22 ].push_back( 21 );
    KingMoves[ 22 ].push_back( 23 );
    KingMoves[ 22 ].push_back( 29 );
    KingMoves[ 22 ].push_back( 30 );
    KingMoves[ 22 ].push_back( 31 );
    KingMoves[ 23 ].push_back( 14 );
    KingMoves[ 23 ].push_back( 15 );
    KingMoves[ 23 ].push_back( 22 );
    KingMoves[ 23 ].push_back( 30 );
    KingMoves[ 23 ].push_back( 31 );

    KingMoves[ 24 ].push_back( 16 );
    KingMoves[ 24 ].push_back( 17 );
    KingMoves[ 24 ].push_back( 25 );
    KingMoves[ 24 ].push_back( 32 );
    KingMoves[ 24 ].push_back( 33 );
    KingMoves[ 25 ].push_back( 16 );
    KingMoves[ 25 ].push_back( 17 );
    KingMoves[ 25 ].push_back( 18 );
    KingMoves[ 25 ].push_back( 24 );
    KingMoves[ 25 ].push_back( 26 );
    KingMoves[ 25 ].push_back( 32 );
    KingMoves[ 25 ].push_back( 33 );
    KingMoves[ 25 ].push_back( 34 );
    KingMoves[ 26 ].push_back( 17 );
    KingMoves[ 26 ].push_back( 18 );
    KingMoves[ 26 ].push_back( 19 );
    KingMoves[ 26 ].push_back( 25 );
    KingMoves[ 26 ].push_back( 27 );
    KingMoves[ 26 ].push_back( 33 );
    KingMoves[ 26 ].push_back( 34 );
    KingMoves[ 26 ].push_back( 35 );
    KingMoves[ 27 ].push_back( 18 );
    KingMoves[ 27 ].push_back( 19 );
    KingMoves[ 27 ].push_back( 20 );
    KingMoves[ 27 ].push_back( 26 );
    KingMoves[ 27 ].push_back( 28 );
    KingMoves[ 27 ].push_back( 34 );
    KingMoves[ 27 ].push_back( 35 );
    KingMoves[ 27 ].push_back( 36 );
    KingMoves[ 28 ].push_back( 19 );
    KingMoves[ 28 ].push_back( 20 );
    KingMoves[ 28 ].push_back( 21 );
    KingMoves[ 28 ].push_back( 27 );
    KingMoves[ 28 ].push_back( 29 );
    KingMoves[ 28 ].push_back( 35 );
    KingMoves[ 28 ].push_back( 36 );
    KingMoves[ 28 ].push_back( 37 );
    KingMoves[ 29 ].push_back( 20 );
    KingMoves[ 29 ].push_back( 21 );
    KingMoves[ 29 ].push_back( 22 );
    KingMoves[ 29 ].push_back( 28 );
    KingMoves[ 29 ].push_back( 30 );
    KingMoves[ 29 ].push_back( 36 );
    KingMoves[ 29 ].push_back( 37 );
    KingMoves[ 29 ].push_back( 38 );
    KingMoves[ 30 ].push_back( 21 );
    KingMoves[ 30 ].push_back( 22 );
    KingMoves[ 30 ].push_back( 23 );
    KingMoves[ 30 ].push_back( 29 );
    KingMoves[ 30 ].push_back( 31 );
    KingMoves[ 30 ].push_back( 37 );
    KingMoves[ 30 ].push_back( 38 );
    KingMoves[ 30 ].push_back( 39 );
    KingMoves[ 31 ].push_back( 22 );
    KingMoves[ 31 ].push_back( 23 );
    KingMoves[ 31 ].push_back( 30 );
    KingMoves[ 31 ].push_back( 38 );
    KingMoves[ 31 ].push_back( 39 );

    KingMoves[ 32 ].push_back( 24 );
    KingMoves[ 32 ].push_back( 25 );
    KingMoves[ 32 ].push_back( 33 );
    KingMoves[ 32 ].push_back( 41 );
    KingMoves[ 32 ].push_back( 40 );
    KingMoves[ 33 ].push_back( 24 );
    KingMoves[ 33 ].push_back( 25 );
    KingMoves[ 33 ].push_back( 26 );
    KingMoves[ 33 ].push_back( 32 );
    KingMoves[ 33 ].push_back( 34 );
    KingMoves[ 33 ].push_back( 40 );
    KingMoves[ 33 ].push_back( 41 );
    KingMoves[ 33 ].push_back( 42 );
    KingMoves[ 34 ].push_back( 25 );
    KingMoves[ 34 ].push_back( 26 );
    KingMoves[ 34 ].push_back( 27 );
    KingMoves[ 34 ].push_back( 33 );
    KingMoves[ 34 ].push_back( 35 );
    KingMoves[ 34 ].push_back( 41 );
    KingMoves[ 34 ].push_back( 42 );
    KingMoves[ 34 ].push_back( 43 );
    KingMoves[ 35 ].push_back( 26 );
    KingMoves[ 35 ].push_back( 27 );
    KingMoves[ 35 ].push_back( 28 );
    KingMoves[ 35 ].push_back( 34 );
    KingMoves[ 35 ].push_back( 36 );
    KingMoves[ 35 ].push_back( 42 );
    KingMoves[ 35 ].push_back( 43 );
    KingMoves[ 35 ].push_back( 44 );
    KingMoves[ 36 ].push_back( 27 );
    KingMoves[ 36 ].push_back( 28 );
    KingMoves[ 36 ].push_back( 29 );
    KingMoves[ 36 ].push_back( 35 );
    KingMoves[ 36 ].push_back( 37 );
    KingMoves[ 36 ].push_back( 43 );
    KingMoves[ 36 ].push_back( 44 );
    KingMoves[ 36 ].push_back( 45 );
    KingMoves[ 37 ].push_back( 28 );
    KingMoves[ 37 ].push_back( 29 );
    KingMoves[ 37 ].push_back( 30 );
    KingMoves[ 37 ].push_back( 36 );
    KingMoves[ 37 ].push_back( 38 );
    KingMoves[ 37 ].push_back( 44 );
    KingMoves[ 37 ].push_back( 45 );
    KingMoves[ 37 ].push_back( 46 );
    KingMoves[ 38 ].push_back( 29 );
    KingMoves[ 38 ].push_back( 30 );
    KingMoves[ 38 ].push_back( 31 );
    KingMoves[ 38 ].push_back( 37 );
    KingMoves[ 38 ].push_back( 39 );
    KingMoves[ 38 ].push_back( 45 );
    KingMoves[ 38 ].push_back( 46 );
    KingMoves[ 38 ].push_back( 47 );
    KingMoves[ 39 ].push_back( 30 );
    KingMoves[ 39 ].push_back( 31 );
    KingMoves[ 39 ].push_back( 38 );
    KingMoves[ 39 ].push_back( 46 );
    KingMoves[ 39 ].push_back( 47 );

    KingMoves[ 40 ].push_back( 32 );
    KingMoves[ 40 ].push_back( 33 );
    KingMoves[ 40 ].push_back( 41 );
    KingMoves[ 40 ].push_back( 48 );
    KingMoves[ 40 ].push_back( 49 );
    KingMoves[ 41 ].push_back( 32 );
    KingMoves[ 41 ].push_back( 33 );
    KingMoves[ 41 ].push_back( 34 );
    KingMoves[ 41 ].push_back( 40 );
    KingMoves[ 41 ].push_back( 42 );
    KingMoves[ 41 ].push_back( 48 );
    KingMoves[ 41 ].push_back( 49 );
    KingMoves[ 41 ].push_back( 50 );
    KingMoves[ 42 ].push_back( 33 );
    KingMoves[ 42 ].push_back( 34 );
    KingMoves[ 42 ].push_back( 35 );
    KingMoves[ 42 ].push_back( 41 );
    KingMoves[ 42 ].push_back( 43 );
    KingMoves[ 42 ].push_back( 49 );
    KingMoves[ 42 ].push_back( 50 );
    KingMoves[ 42 ].push_back( 51 );
    KingMoves[ 43 ].push_back( 34 );
    KingMoves[ 43 ].push_back( 35 );
    KingMoves[ 43 ].push_back( 36 );
    KingMoves[ 43 ].push_back( 42 );
    KingMoves[ 43 ].push_back( 44 );
    KingMoves[ 43 ].push_back( 50 );
    KingMoves[ 43 ].push_back( 51 );
    KingMoves[ 43 ].push_back( 52 );
    KingMoves[ 44 ].push_back( 35 );
    KingMoves[ 44 ].push_back( 36 );
    KingMoves[ 44 ].push_back( 37 );
    KingMoves[ 44 ].push_back( 43 );
    KingMoves[ 44 ].push_back( 45 );
    KingMoves[ 44 ].push_back( 51 );
    KingMoves[ 44 ].push_back( 52 );
    KingMoves[ 44 ].push_back( 53 );
    KingMoves[ 45 ].push_back( 36 );
    KingMoves[ 45 ].push_back( 37 );
    KingMoves[ 45 ].push_back( 38 );
    KingMoves[ 45 ].push_back( 44 );
    KingMoves[ 45 ].push_back( 46 );
    KingMoves[ 45 ].push_back( 52 );
    KingMoves[ 45 ].push_back( 53 );
    KingMoves[ 45 ].push_back( 54 );
    KingMoves[ 46 ].push_back( 37 );
    KingMoves[ 46 ].push_back( 38 );
    KingMoves[ 46 ].push_back( 39 );
    KingMoves[ 46 ].push_back( 45 );
    KingMoves[ 46 ].push_back( 47 );
    KingMoves[ 46 ].push_back( 53 );
    KingMoves[ 46 ].push_back( 54 );
    KingMoves[ 46 ].push_back( 55 );
    KingMoves[ 47 ].push_back( 38 );
    KingMoves[ 47 ].push_back( 39 );
    KingMoves[ 47 ].push_back( 46 );
    KingMoves[ 47 ].push_back( 54 );
    KingMoves[ 47 ].push_back( 55 );

    KingMoves[ 48 ].push_back( 40 );
    KingMoves[ 48 ].push_back( 41 );
    KingMoves[ 48 ].push_back( 49 );
    KingMoves[ 48 ].push_back( 56 );
    KingMoves[ 48 ].push_back( 57 );
    KingMoves[ 49 ].push_back( 40 );
    KingMoves[ 49 ].push_back( 41 );
    KingMoves[ 49 ].push_back( 42 );
    KingMoves[ 49 ].push_back( 48 );
    KingMoves[ 49 ].push_back( 50 );
    KingMoves[ 49 ].push_back( 56 );
    KingMoves[ 49 ].push_back( 57 );
    KingMoves[ 49 ].push_back( 58 );
    KingMoves[ 50 ].push_back( 41 );
    KingMoves[ 50 ].push_back( 42 );
    KingMoves[ 50 ].push_back( 43 );
    KingMoves[ 50 ].push_back( 49 );
    KingMoves[ 50 ].push_back( 51 );
    KingMoves[ 50 ].push_back( 57 );
    KingMoves[ 50 ].push_back( 58 );
    KingMoves[ 50 ].push_back( 59 );
    KingMoves[ 51 ].push_back( 42 );
    KingMoves[ 51 ].push_back( 43 );
    KingMoves[ 51 ].push_back( 44 );
    KingMoves[ 51 ].push_back( 50 );
    KingMoves[ 51 ].push_back( 52 );
    KingMoves[ 51 ].push_back( 58 );
    KingMoves[ 51 ].push_back( 59 );
    KingMoves[ 51 ].push_back( 60 );
    KingMoves[ 52 ].push_back( 43 );
    KingMoves[ 52 ].push_back( 44 );
    KingMoves[ 52 ].push_back( 45 );
    KingMoves[ 52 ].push_back( 51 );
    KingMoves[ 52 ].push_back( 53 );
    KingMoves[ 52 ].push_back( 59 );
    KingMoves[ 52 ].push_back( 60 );
    KingMoves[ 52 ].push_back( 61 );
    KingMoves[ 53 ].push_back( 44 );
    KingMoves[ 53 ].push_back( 45 );
    KingMoves[ 53 ].push_back( 46 );
    KingMoves[ 53 ].push_back( 52 );
    KingMoves[ 53 ].push_back( 54 );
    KingMoves[ 53 ].push_back( 60 );
    KingMoves[ 53 ].push_back( 61 );
    KingMoves[ 53 ].push_back( 62 );
    KingMoves[ 54 ].push_back( 45 );
    KingMoves[ 54 ].push_back( 46 );
    KingMoves[ 54 ].push_back( 47 );
    KingMoves[ 54 ].push_back( 53 );
    KingMoves[ 54 ].push_back( 55 );
    KingMoves[ 54 ].push_back( 61 );
    KingMoves[ 54 ].push_back( 62 );
    KingMoves[ 54 ].push_back( 63 );
    KingMoves[ 55 ].push_back( 46 );
    KingMoves[ 55 ].push_back( 47 );
    KingMoves[ 55 ].push_back( 54 );
    KingMoves[ 55 ].push_back( 62 );
    KingMoves[ 55 ].push_back( 63 );

    KingMoves[ 56 ].push_back( 48 );
    KingMoves[ 56 ].push_back( 49 );
    KingMoves[ 56 ].push_back( 57 );
    KingMoves[ 57 ].push_back( 48 );
    KingMoves[ 57 ].push_back( 49 );
    KingMoves[ 57 ].push_back( 50 );
    KingMoves[ 57 ].push_back( 56 );
    KingMoves[ 57 ].push_back( 58 );
    KingMoves[ 58 ].push_back( 49 );
    KingMoves[ 58 ].push_back( 50 );
    KingMoves[ 58 ].push_back( 51 );
    KingMoves[ 58 ].push_back( 57 );
    KingMoves[ 58 ].push_back( 59 );
    KingMoves[ 59 ].push_back( 50 );
    KingMoves[ 59 ].push_back( 51 );
    KingMoves[ 59 ].push_back( 52 );
    KingMoves[ 59 ].push_back( 58 );
    KingMoves[ 59 ].push_back( 60 );
    KingMoves[ 60 ].push_back( 51 );
    KingMoves[ 60 ].push_back( 52 );
    KingMoves[ 60 ].push_back( 53 );
    KingMoves[ 60 ].push_back( 59 );
    KingMoves[ 60 ].push_back( 61 );
    KingMoves[ 61 ].push_back( 52 );
    KingMoves[ 61 ].push_back( 53 );
    KingMoves[ 61 ].push_back( 54 );
    KingMoves[ 61 ].push_back( 60 );
    KingMoves[ 61 ].push_back( 62 );
    KingMoves[ 62 ].push_back( 53 );
    KingMoves[ 62 ].push_back( 54 );
    KingMoves[ 62 ].push_back( 55 );
    KingMoves[ 62 ].push_back( 61 );
    KingMoves[ 62 ].push_back( 63 );
    KingMoves[ 63 ].push_back( 54 );
    KingMoves[ 63 ].push_back( 55 );
    KingMoves[ 63 ].push_back( 62 );

	BishopMoves[ 0 ].resize( 1 );
	BishopMoves[ 0 ][ 0 ].push_back( 9 );
	BishopMoves[ 0 ][ 0 ].push_back( 18 );
	BishopMoves[ 0 ][ 0 ].push_back( 27 );
	BishopMoves[ 0 ][ 0 ].push_back( 36 );
	BishopMoves[ 0 ][ 0 ].push_back( 45 );
	BishopMoves[ 0 ][ 0 ].push_back( 54 );
	BishopMoves[ 0 ][ 0 ].push_back( 63 );
	BishopMoves[ 1 ].resize( 2 );
    BishopMoves[ 1 ][ 0 ].push_back( 8 );
	BishopMoves[ 1 ][ 1 ].push_back( 10 );
    BishopMoves[ 1 ][ 1 ].push_back( 19 );
    BishopMoves[ 1 ][ 1 ].push_back( 28 );
    BishopMoves[ 1 ][ 1 ].push_back( 37 );
    BishopMoves[ 1 ][ 1 ].push_back( 46 );
    BishopMoves[ 1 ][ 1 ].push_back( 55 );
	BishopMoves[ 2 ].resize( 2 );
    BishopMoves[ 2 ][ 0 ].push_back( 9 );
    BishopMoves[ 2 ][ 0 ].push_back( 16 );
    BishopMoves[ 2 ][ 1 ].push_back( 11 );
    BishopMoves[ 2 ][ 1 ].push_back( 20 );
    BishopMoves[ 2 ][ 1 ].push_back( 29 );
    BishopMoves[ 2 ][ 1 ].push_back( 38 );
    BishopMoves[ 2 ][ 1 ].push_back( 47 );
	BishopMoves[ 3 ].resize( 2 );
    BishopMoves[ 3 ][ 0 ].push_back( 10 );
    BishopMoves[ 3 ][ 0 ].push_back( 17 );
    BishopMoves[ 3 ][ 0 ].push_back( 24 );
    BishopMoves[ 3 ][ 1 ].push_back( 12 );
    BishopMoves[ 3 ][ 1 ].push_back( 21 );
    BishopMoves[ 3 ][ 1 ].push_back( 30 );
    BishopMoves[ 3 ][ 1 ].push_back( 39 );
	BishopMoves[ 4 ].resize( 2 );
    BishopMoves[ 4 ][ 0 ].push_back( 11 );
    BishopMoves[ 4 ][ 0 ].push_back( 18 );
    BishopMoves[ 4 ][ 0 ].push_back( 25 );
    BishopMoves[ 4 ][ 0 ].push_back( 32 );
    BishopMoves[ 4 ][ 1 ].push_back( 13 );
    BishopMoves[ 4 ][ 1 ].push_back( 22 );
    BishopMoves[ 4 ][ 1 ].push_back( 31 );
	BishopMoves[ 5 ].resize( 2 );
    BishopMoves[ 5 ][ 0 ].push_back( 12 );
    BishopMoves[ 5 ][ 0 ].push_back( 19 );
    BishopMoves[ 5 ][ 0 ].push_back( 26 );
    BishopMoves[ 5 ][ 0 ].push_back( 33 );
    BishopMoves[ 5 ][ 0 ].push_back( 40 );
    BishopMoves[ 5 ][ 1 ].push_back( 14 );
    BishopMoves[ 5 ][ 1 ].push_back( 23 );
	BishopMoves[ 6 ].resize( 2 );
    BishopMoves[ 6 ][ 0 ].push_back( 13 );
    BishopMoves[ 6 ][ 0 ].push_back( 20 );
    BishopMoves[ 6 ][ 0 ].push_back( 27 );
    BishopMoves[ 6 ][ 0 ].push_back( 34 );
    BishopMoves[ 6 ][ 0 ].push_back( 41 );
    BishopMoves[ 6 ][ 0 ].push_back( 48 );
    BishopMoves[ 6 ][ 1 ].push_back( 15 );
	BishopMoves[ 7 ].resize( 1 );
    BishopMoves[ 7 ][ 0 ].push_back( 14 );
    BishopMoves[ 7 ][ 0 ].push_back( 21 );
    BishopMoves[ 7 ][ 0 ].push_back( 28 );
    BishopMoves[ 7 ][ 0 ].push_back( 35 );
    BishopMoves[ 7 ][ 0 ].push_back( 42 );
    BishopMoves[ 7 ][ 0 ].push_back( 49 );
    BishopMoves[ 7 ][ 0 ].push_back( 56 );

    BishopMoves[ 8 ].resize( 2 );
	BishopMoves[ 8 ][ 0 ].push_back( 1 );
    BishopMoves[ 8 ][ 1 ].push_back( 17 );
    BishopMoves[ 8 ][ 1 ].push_back( 26 );
    BishopMoves[ 8 ][ 1 ].push_back( 35 );
    BishopMoves[ 8 ][ 1 ].push_back( 44 );
    BishopMoves[ 8 ][ 1 ].push_back( 53 );
    BishopMoves[ 8 ][ 1 ].push_back( 62 );
    BishopMoves[ 9 ].resize( 4 );
    BishopMoves[ 9 ][ 0 ].push_back( 0 );
    BishopMoves[ 9 ][ 1 ].push_back( 2 );
    BishopMoves[ 9 ][ 2 ].push_back( 16 );
    BishopMoves[ 9 ][ 3 ].push_back( 18 );
    BishopMoves[ 9 ][ 3 ].push_back( 27 );
    BishopMoves[ 9 ][ 3 ].push_back( 36 );
    BishopMoves[ 9 ][ 3 ].push_back( 45 );
    BishopMoves[ 9 ][ 3 ].push_back( 54 );
    BishopMoves[ 9 ][ 3 ].push_back( 63 );
    BishopMoves[ 10 ].resize( 4 );
    BishopMoves[ 10 ][ 0 ].push_back( 1 );
    BishopMoves[ 10 ][ 1 ].push_back( 3 );
    BishopMoves[ 10 ][ 2 ].push_back( 17 );
    BishopMoves[ 10 ][ 2 ].push_back( 24 );
    BishopMoves[ 10 ][ 3 ].push_back( 19 );
    BishopMoves[ 10 ][ 3 ].push_back( 28 );
    BishopMoves[ 10 ][ 3 ].push_back( 37 );
    BishopMoves[ 10 ][ 3 ].push_back( 46 );
    BishopMoves[ 10 ][ 3 ].push_back( 55 );
    BishopMoves[ 11 ].resize( 4 );
    BishopMoves[ 11 ][ 0 ].push_back( 2 );
    BishopMoves[ 11 ][ 1 ].push_back( 4 );
    BishopMoves[ 11 ][ 2 ].push_back( 18 );
    BishopMoves[ 11 ][ 2 ].push_back( 25 );
    BishopMoves[ 11 ][ 2 ].push_back( 32 );
    BishopMoves[ 11 ][ 3 ].push_back( 20 );
    BishopMoves[ 11 ][ 3 ].push_back( 29 );
    BishopMoves[ 11 ][ 3 ].push_back( 38 );
    BishopMoves[ 11 ][ 3 ].push_back( 47 );
    BishopMoves[ 12 ].resize( 4 );
    BishopMoves[ 12 ][ 0 ].push_back( 3 );
    BishopMoves[ 12 ][ 1 ].push_back( 5 );
    BishopMoves[ 12 ][ 2 ].push_back( 19 );
    BishopMoves[ 12 ][ 2 ].push_back( 26 );
    BishopMoves[ 12 ][ 2 ].push_back( 33 );
    BishopMoves[ 12 ][ 2 ].push_back( 40 );
    BishopMoves[ 12 ][ 3 ].push_back( 21 );
    BishopMoves[ 12 ][ 3 ].push_back( 30 );
    BishopMoves[ 12 ][ 3 ].push_back( 39 );
    BishopMoves[ 13 ].resize( 4 );
    BishopMoves[ 13 ][ 0 ].push_back( 4 );
    BishopMoves[ 13 ][ 1 ].push_back( 6 );
    BishopMoves[ 13 ][ 2 ].push_back( 20 );
    BishopMoves[ 13 ][ 2 ].push_back( 27 );
    BishopMoves[ 13 ][ 2 ].push_back( 34 );
    BishopMoves[ 13 ][ 2 ].push_back( 41 );
    BishopMoves[ 13 ][ 2 ].push_back( 48 );
    BishopMoves[ 13 ][ 3 ].push_back( 22 );
    BishopMoves[ 13 ][ 3 ].push_back( 31 );
    BishopMoves[ 14 ].resize( 4 );
    BishopMoves[ 14 ][ 0 ].push_back( 5 );
    BishopMoves[ 14 ][ 1 ].push_back( 7 );
    BishopMoves[ 14 ][ 2 ].push_back( 21 );
    BishopMoves[ 14 ][ 2 ].push_back( 28 );
    BishopMoves[ 14 ][ 2 ].push_back( 35 );
    BishopMoves[ 14 ][ 2 ].push_back( 42 );
    BishopMoves[ 14 ][ 2 ].push_back( 49 );
    BishopMoves[ 14 ][ 2 ].push_back( 56 );
    BishopMoves[ 14 ][ 3 ].push_back( 23 );
    BishopMoves[ 15 ].resize( 2 );
    BishopMoves[ 15 ][ 0 ].push_back( 6 );
    BishopMoves[ 15 ][ 1 ].push_back( 22 );
    BishopMoves[ 15 ][ 1 ].push_back( 29 );
    BishopMoves[ 15 ][ 1 ].push_back( 36 );
    BishopMoves[ 15 ][ 1 ].push_back( 43 );
    BishopMoves[ 15 ][ 1 ].push_back( 50 );
    BishopMoves[ 15 ][ 1 ].push_back( 57 );

    BishopMoves[ 16 ].resize( 2 );
    BishopMoves[ 16 ][ 0 ].push_back( 9 );
    BishopMoves[ 16 ][ 0 ].push_back( 2 );
    BishopMoves[ 16 ][ 1 ].push_back( 25 );
    BishopMoves[ 16 ][ 1 ].push_back( 34 );
    BishopMoves[ 16 ][ 1 ].push_back( 43 );
    BishopMoves[ 16 ][ 1 ].push_back( 52 );
    BishopMoves[ 16 ][ 1 ].push_back( 61 );
    BishopMoves[ 17 ].resize( 4 );
    BishopMoves[ 17 ][ 0 ].push_back( 8 );
    BishopMoves[ 17 ][ 1 ].push_back( 10 );
    BishopMoves[ 17 ][ 1 ].push_back( 3 );
    BishopMoves[ 17 ][ 2 ].push_back( 24 );
    BishopMoves[ 17 ][ 3 ].push_back( 26 );
    BishopMoves[ 17 ][ 3 ].push_back( 35 );
    BishopMoves[ 17 ][ 3 ].push_back( 44 );
    BishopMoves[ 17 ][ 3 ].push_back( 53 );
    BishopMoves[ 17 ][ 3 ].push_back( 62 );
    BishopMoves[ 18 ].resize( 4 );
    BishopMoves[ 18 ][ 0 ].push_back( 9 );
    BishopMoves[ 18 ][ 0 ].push_back( 0 );
    BishopMoves[ 18 ][ 1 ].push_back( 11 );
    BishopMoves[ 18 ][ 1 ].push_back( 4 );
    BishopMoves[ 18 ][ 2 ].push_back( 25 );
    BishopMoves[ 18 ][ 2 ].push_back( 32 );
    BishopMoves[ 18 ][ 3 ].push_back( 27 );
    BishopMoves[ 18 ][ 3 ].push_back( 36 );
    BishopMoves[ 18 ][ 3 ].push_back( 45 );
    BishopMoves[ 18 ][ 3 ].push_back( 54 );
    BishopMoves[ 18 ][ 3 ].push_back( 63 );
    BishopMoves[ 19 ].resize( 4 );
    BishopMoves[ 19 ][ 0 ].push_back( 10 );
    BishopMoves[ 19 ][ 0 ].push_back( 1 );
    BishopMoves[ 19 ][ 1 ].push_back( 12 );
    BishopMoves[ 19 ][ 1 ].push_back( 5 );
    BishopMoves[ 19 ][ 2 ].push_back( 26 );
    BishopMoves[ 19 ][ 2 ].push_back( 33 );
    BishopMoves[ 19 ][ 2 ].push_back( 40 );
    BishopMoves[ 19 ][ 3 ].push_back( 28 );
    BishopMoves[ 19 ][ 3 ].push_back( 37 );
    BishopMoves[ 19 ][ 3 ].push_back( 46 );
    BishopMoves[ 19 ][ 3 ].push_back( 55 );
    BishopMoves[ 20 ].resize( 4 );
    BishopMoves[ 20 ][ 0 ].push_back( 11 );
    BishopMoves[ 20 ][ 0 ].push_back( 2 );
    BishopMoves[ 20 ][ 1 ].push_back( 13 );
    BishopMoves[ 20 ][ 1 ].push_back( 6 );
    BishopMoves[ 20 ][ 2 ].push_back( 27 );
    BishopMoves[ 20 ][ 2 ].push_back( 34 );
    BishopMoves[ 20 ][ 2 ].push_back( 41 );
    BishopMoves[ 20 ][ 2 ].push_back( 48 );
    BishopMoves[ 20 ][ 3 ].push_back( 29 );
    BishopMoves[ 20 ][ 3 ].push_back( 38 );
    BishopMoves[ 20 ][ 3 ].push_back( 47 );
    BishopMoves[ 21 ].resize( 4 );
    BishopMoves[ 21 ][ 0 ].push_back( 12 );
    BishopMoves[ 21 ][ 0 ].push_back( 3 );
    BishopMoves[ 21 ][ 1 ].push_back( 14 );
    BishopMoves[ 21 ][ 1 ].push_back( 7 );
    BishopMoves[ 21 ][ 2 ].push_back( 28 );
    BishopMoves[ 21 ][ 2 ].push_back( 35 );
    BishopMoves[ 21 ][ 2 ].push_back( 42 );
    BishopMoves[ 21 ][ 2 ].push_back( 49 );
    BishopMoves[ 21 ][ 2 ].push_back( 56 );
    BishopMoves[ 21 ][ 3 ].push_back( 30 );
    BishopMoves[ 21 ][ 3 ].push_back( 39 );
    BishopMoves[ 22 ].resize( 4 );
    BishopMoves[ 22 ][ 0 ].push_back( 13 );
    BishopMoves[ 22 ][ 0 ].push_back( 4 );
    BishopMoves[ 22 ][ 1 ].push_back( 15 );
    BishopMoves[ 22 ][ 2 ].push_back( 29 );
    BishopMoves[ 22 ][ 2 ].push_back( 36 );
    BishopMoves[ 22 ][ 2 ].push_back( 43 );
    BishopMoves[ 22 ][ 2 ].push_back( 50 );
    BishopMoves[ 22 ][ 2 ].push_back( 57 );
    BishopMoves[ 22 ][ 3 ].push_back( 31 );
    BishopMoves[ 23 ].resize( 2 );
    BishopMoves[ 23 ][ 0 ].push_back( 14 );
    BishopMoves[ 23 ][ 0 ].push_back( 5 );
    BishopMoves[ 23 ][ 1 ].push_back( 30 );
    BishopMoves[ 23 ][ 1 ].push_back( 37 );
    BishopMoves[ 23 ][ 1 ].push_back( 44 );
    BishopMoves[ 23 ][ 1 ].push_back( 51 );
    BishopMoves[ 23 ][ 1 ].push_back( 58 );

    BishopMoves[ 24 ].resize( 2 );
    BishopMoves[ 24 ][ 0 ].push_back( 17 );
    BishopMoves[ 24 ][ 0 ].push_back( 10 );
    BishopMoves[ 24 ][ 0 ].push_back( 3 );
    BishopMoves[ 24 ][ 1 ].push_back( 33 );
    BishopMoves[ 24 ][ 1 ].push_back( 42 );
    BishopMoves[ 24 ][ 1 ].push_back( 51 );
    BishopMoves[ 24 ][ 1 ].push_back( 60 );
    BishopMoves[ 25 ].resize( 4 );
    BishopMoves[ 25 ][ 0 ].push_back( 16 );
    BishopMoves[ 25 ][ 1 ].push_back( 18 );
    BishopMoves[ 25 ][ 1 ].push_back( 11 );
    BishopMoves[ 25 ][ 1 ].push_back( 4 );
    BishopMoves[ 25 ][ 2 ].push_back( 32 );
    BishopMoves[ 25 ][ 3 ].push_back( 34 );
    BishopMoves[ 25 ][ 3 ].push_back( 43 );
    BishopMoves[ 25 ][ 3 ].push_back( 52 );
    BishopMoves[ 25 ][ 3 ].push_back( 61 );
    BishopMoves[ 26 ].resize( 4 );
    BishopMoves[ 26 ][ 0 ].push_back( 17 );
    BishopMoves[ 26 ][ 0 ].push_back( 8 );
    BishopMoves[ 26 ][ 1 ].push_back( 19 );
    BishopMoves[ 26 ][ 1 ].push_back( 12 );
    BishopMoves[ 26 ][ 1 ].push_back( 5 );
    BishopMoves[ 26 ][ 2 ].push_back( 33 );
    BishopMoves[ 26 ][ 2 ].push_back( 40 );
    BishopMoves[ 26 ][ 3 ].push_back( 35 );
    BishopMoves[ 26 ][ 3 ].push_back( 44 );
    BishopMoves[ 26 ][ 3 ].push_back( 53 );
    BishopMoves[ 26 ][ 3 ].push_back( 62 );
    BishopMoves[ 27 ].resize( 4 );
    BishopMoves[ 27 ][ 0 ].push_back( 18 );
    BishopMoves[ 27 ][ 0 ].push_back( 9 );
    BishopMoves[ 27 ][ 0 ].push_back( 0 );
    BishopMoves[ 27 ][ 1 ].push_back( 20 );
    BishopMoves[ 27 ][ 1 ].push_back( 13 );
    BishopMoves[ 27 ][ 1 ].push_back( 6 );
    BishopMoves[ 27 ][ 2 ].push_back( 34 );
    BishopMoves[ 27 ][ 2 ].push_back( 41 );
    BishopMoves[ 27 ][ 2 ].push_back( 48 );
    BishopMoves[ 27 ][ 3 ].push_back( 36 );
    BishopMoves[ 27 ][ 3 ].push_back( 45 );
    BishopMoves[ 27 ][ 3 ].push_back( 54 );
    BishopMoves[ 27 ][ 3 ].push_back( 63 );
    BishopMoves[ 28 ].resize( 4 );
    BishopMoves[ 28 ][ 0 ].push_back( 19 );
    BishopMoves[ 28 ][ 0 ].push_back( 10 );
    BishopMoves[ 28 ][ 0 ].push_back( 1 );
    BishopMoves[ 28 ][ 1 ].push_back( 21 );
    BishopMoves[ 28 ][ 1 ].push_back( 14 );
    BishopMoves[ 28 ][ 1 ].push_back( 7 );
    BishopMoves[ 28 ][ 2 ].push_back( 35 );
    BishopMoves[ 28 ][ 2 ].push_back( 42 );
    BishopMoves[ 28 ][ 2 ].push_back( 49 );
    BishopMoves[ 28 ][ 2 ].push_back( 56 );
    BishopMoves[ 28 ][ 3 ].push_back( 37 );
    BishopMoves[ 28 ][ 3 ].push_back( 46 );
    BishopMoves[ 28 ][ 3 ].push_back( 55 );
    BishopMoves[ 29 ].resize( 4 );
    BishopMoves[ 29 ][ 0 ].push_back( 20 );
    BishopMoves[ 29 ][ 0 ].push_back( 11 );
    BishopMoves[ 29 ][ 0 ].push_back( 2 );
    BishopMoves[ 29 ][ 1 ].push_back( 22 );
    BishopMoves[ 29 ][ 1 ].push_back( 15 );
    BishopMoves[ 29 ][ 2 ].push_back( 36 );
    BishopMoves[ 29 ][ 2 ].push_back( 43 );
    BishopMoves[ 29 ][ 2 ].push_back( 50 );
    BishopMoves[ 29 ][ 2 ].push_back( 57 );
    BishopMoves[ 29 ][ 3 ].push_back( 38 );
    BishopMoves[ 29 ][ 3 ].push_back( 47 );
    BishopMoves[ 30 ].resize( 4 );
    BishopMoves[ 30 ][ 0 ].push_back( 21 );
    BishopMoves[ 30 ][ 0 ].push_back( 12 );
    BishopMoves[ 30 ][ 0 ].push_back( 3 );
    BishopMoves[ 30 ][ 1 ].push_back( 23 );
    BishopMoves[ 30 ][ 2 ].push_back( 37 );
    BishopMoves[ 30 ][ 2 ].push_back( 44 );
    BishopMoves[ 30 ][ 2 ].push_back( 51 );
    BishopMoves[ 30 ][ 2 ].push_back( 58 );
    BishopMoves[ 30 ][ 3 ].push_back( 39 );
    BishopMoves[ 31 ].resize( 2 );
    BishopMoves[ 31 ][ 0 ].push_back( 22 );
    BishopMoves[ 31 ][ 0 ].push_back( 13 );
    BishopMoves[ 31 ][ 0 ].push_back( 4 );
    BishopMoves[ 31 ][ 1 ].push_back( 38 );
    BishopMoves[ 31 ][ 1 ].push_back( 45 );
    BishopMoves[ 31 ][ 1 ].push_back( 52 );
    BishopMoves[ 31 ][ 1 ].push_back( 59 );

    BishopMoves[ 32 ].resize( 2 );
    BishopMoves[ 32 ][ 0 ].push_back( 25 );
    BishopMoves[ 32 ][ 0 ].push_back( 18 );
    BishopMoves[ 32 ][ 0 ].push_back( 11 );
    BishopMoves[ 32 ][ 0 ].push_back( 4 );
    BishopMoves[ 32 ][ 1 ].push_back( 41 );
    BishopMoves[ 32 ][ 1 ].push_back( 50 );
    BishopMoves[ 32 ][ 1 ].push_back( 59 );
    BishopMoves[ 33 ].resize( 4 );
    BishopMoves[ 33 ][ 0 ].push_back( 24 );
    BishopMoves[ 33 ][ 1 ].push_back( 26 );
    BishopMoves[ 33 ][ 1 ].push_back( 19 );
    BishopMoves[ 33 ][ 1 ].push_back( 12 );
    BishopMoves[ 33 ][ 1 ].push_back( 5 );
    BishopMoves[ 33 ][ 2 ].push_back( 40 );
    BishopMoves[ 33 ][ 3 ].push_back( 42 );
    BishopMoves[ 33 ][ 3 ].push_back( 51 );
    BishopMoves[ 33 ][ 3 ].push_back( 60 );
    BishopMoves[ 34 ].resize( 4 );
    BishopMoves[ 34 ][ 0 ].push_back( 25 );
    BishopMoves[ 34 ][ 0 ].push_back( 16 );
    BishopMoves[ 34 ][ 1 ].push_back( 27 );
    BishopMoves[ 34 ][ 1 ].push_back( 20 );
    BishopMoves[ 34 ][ 1 ].push_back( 13 );
    BishopMoves[ 34 ][ 1 ].push_back( 6 );
    BishopMoves[ 34 ][ 2 ].push_back( 41 );
    BishopMoves[ 34 ][ 2 ].push_back( 48 );
    BishopMoves[ 34 ][ 3 ].push_back( 43 );
    BishopMoves[ 34 ][ 3 ].push_back( 52 );
    BishopMoves[ 34 ][ 3 ].push_back( 61 );
    BishopMoves[ 35 ].resize( 4 );
    BishopMoves[ 35 ][ 0 ].push_back( 26 );
    BishopMoves[ 35 ][ 0 ].push_back( 17 );
    BishopMoves[ 35 ][ 0 ].push_back( 8 );
    BishopMoves[ 35 ][ 1 ].push_back( 28 );
    BishopMoves[ 35 ][ 1 ].push_back( 21 );
    BishopMoves[ 35 ][ 1 ].push_back( 14 );
    BishopMoves[ 35 ][ 1 ].push_back( 7 );
    BishopMoves[ 35 ][ 2 ].push_back( 42 );
    BishopMoves[ 35 ][ 2 ].push_back( 49 );
    BishopMoves[ 35 ][ 2 ].push_back( 56 );
    BishopMoves[ 35 ][ 3 ].push_back( 44 );
    BishopMoves[ 35 ][ 3 ].push_back( 53 );
    BishopMoves[ 35 ][ 3 ].push_back( 62 );
    BishopMoves[ 36 ].resize( 4 );
    BishopMoves[ 36 ][ 0 ].push_back( 27 );
    BishopMoves[ 36 ][ 0 ].push_back( 18 );
    BishopMoves[ 36 ][ 0 ].push_back( 9 );
    BishopMoves[ 36 ][ 0 ].push_back( 0 );
    BishopMoves[ 36 ][ 1 ].push_back( 29 );
    BishopMoves[ 36 ][ 1 ].push_back( 22 );
    BishopMoves[ 36 ][ 1 ].push_back( 15 );
    BishopMoves[ 36 ][ 2 ].push_back( 43 );
    BishopMoves[ 36 ][ 2 ].push_back( 50 );
    BishopMoves[ 36 ][ 2 ].push_back( 57 );
    BishopMoves[ 36 ][ 3 ].push_back( 45 );
    BishopMoves[ 36 ][ 3 ].push_back( 54 );
    BishopMoves[ 36 ][ 3 ].push_back( 63 );
    BishopMoves[ 37 ].resize( 4 );
    BishopMoves[ 37 ][ 0 ].push_back( 28 );
    BishopMoves[ 37 ][ 0 ].push_back( 19 );
    BishopMoves[ 37 ][ 0 ].push_back( 10 );
    BishopMoves[ 37 ][ 0 ].push_back( 1 );
    BishopMoves[ 37 ][ 1 ].push_back( 30 );
    BishopMoves[ 37 ][ 1 ].push_back( 23 );
    BishopMoves[ 37 ][ 2 ].push_back( 44 );
    BishopMoves[ 37 ][ 2 ].push_back( 51 );
    BishopMoves[ 37 ][ 2 ].push_back( 58 );
    BishopMoves[ 37 ][ 3 ].push_back( 46 );
    BishopMoves[ 37 ][ 3 ].push_back( 55 );
    BishopMoves[ 38 ].resize( 4 );
    BishopMoves[ 38 ][ 0 ].push_back( 29 );
    BishopMoves[ 38 ][ 0 ].push_back( 20 );
    BishopMoves[ 38 ][ 0 ].push_back( 11 );
    BishopMoves[ 38 ][ 0 ].push_back( 2 );
    BishopMoves[ 38 ][ 1 ].push_back( 31 );
    BishopMoves[ 38 ][ 2 ].push_back( 45 );
    BishopMoves[ 38 ][ 2 ].push_back( 52 );
    BishopMoves[ 38 ][ 2 ].push_back( 59 );
    BishopMoves[ 38 ][ 3 ].push_back( 47 );
    BishopMoves[ 39 ].resize( 2 );
    BishopMoves[ 39 ][ 0 ].push_back( 30 );
    BishopMoves[ 39 ][ 0 ].push_back( 21 );
    BishopMoves[ 39 ][ 0 ].push_back( 12 );
    BishopMoves[ 39 ][ 0 ].push_back( 3 );
    BishopMoves[ 39 ][ 1 ].push_back( 46 );
    BishopMoves[ 39 ][ 1 ].push_back( 53 );
    BishopMoves[ 39 ][ 1 ].push_back( 60 );

    BishopMoves[ 40 ].resize( 2 );
    BishopMoves[ 40 ][ 0 ].push_back( 33 );
    BishopMoves[ 40 ][ 0 ].push_back( 26 );
    BishopMoves[ 40 ][ 0 ].push_back( 19 );
    BishopMoves[ 40 ][ 0 ].push_back( 12 );
    BishopMoves[ 40 ][ 0 ].push_back( 5 );
    BishopMoves[ 40 ][ 1 ].push_back( 49 );
    BishopMoves[ 40 ][ 1 ].push_back( 58 );
    BishopMoves[ 41 ].resize( 4 );
    BishopMoves[ 41 ][ 0 ].push_back( 32 );
    BishopMoves[ 41 ][ 1 ].push_back( 34 );
    BishopMoves[ 41 ][ 1 ].push_back( 27 );
    BishopMoves[ 41 ][ 1 ].push_back( 20 );
    BishopMoves[ 41 ][ 1 ].push_back( 13 );
    BishopMoves[ 41 ][ 1 ].push_back( 6 );
    BishopMoves[ 41 ][ 2 ].push_back( 48 );
    BishopMoves[ 41 ][ 3 ].push_back( 50 );
    BishopMoves[ 41 ][ 3 ].push_back( 59 );
    BishopMoves[ 42 ].resize( 4 );
    BishopMoves[ 42 ][ 0 ].push_back( 33 );
    BishopMoves[ 42 ][ 0 ].push_back( 24 );
    BishopMoves[ 42 ][ 1 ].push_back( 35 );
    BishopMoves[ 42 ][ 1 ].push_back( 28 );
    BishopMoves[ 42 ][ 1 ].push_back( 21 );
    BishopMoves[ 42 ][ 1 ].push_back( 14 );
    BishopMoves[ 42 ][ 1 ].push_back( 7 );
    BishopMoves[ 42 ][ 2 ].push_back( 49 );
    BishopMoves[ 42 ][ 2 ].push_back( 56 );
    BishopMoves[ 42 ][ 3 ].push_back( 51 );
    BishopMoves[ 42 ][ 3 ].push_back( 60 );
    BishopMoves[ 43 ].resize( 4 );
    BishopMoves[ 43 ][ 0 ].push_back( 34 );
    BishopMoves[ 43 ][ 0 ].push_back( 25 );
    BishopMoves[ 43 ][ 0 ].push_back( 16 );
    BishopMoves[ 43 ][ 1 ].push_back( 36 );
    BishopMoves[ 43 ][ 1 ].push_back( 29 );
    BishopMoves[ 43 ][ 1 ].push_back( 22 );
    BishopMoves[ 43 ][ 1 ].push_back( 15 );
    BishopMoves[ 43 ][ 2 ].push_back( 50 );
    BishopMoves[ 43 ][ 2 ].push_back( 57 );
    BishopMoves[ 43 ][ 3 ].push_back( 52 );
    BishopMoves[ 43 ][ 3 ].push_back( 61 );
    BishopMoves[ 44 ].resize( 4 );
    BishopMoves[ 44 ][ 0 ].push_back( 35 );
    BishopMoves[ 44 ][ 0 ].push_back( 26 );
    BishopMoves[ 44 ][ 0 ].push_back( 17 );
    BishopMoves[ 44 ][ 0 ].push_back( 8 );
    BishopMoves[ 44 ][ 1 ].push_back( 37 );
    BishopMoves[ 44 ][ 1 ].push_back( 30 );
    BishopMoves[ 44 ][ 1 ].push_back( 23 );
    BishopMoves[ 44 ][ 2 ].push_back( 51 );
    BishopMoves[ 44 ][ 2 ].push_back( 58 );
    BishopMoves[ 44 ][ 3 ].push_back( 53 );
    BishopMoves[ 44 ][ 3 ].push_back( 62 );
    BishopMoves[ 45 ].resize( 4 );
    BishopMoves[ 45 ][ 0 ].push_back( 36 );
    BishopMoves[ 45 ][ 0 ].push_back( 27 );
    BishopMoves[ 45 ][ 0 ].push_back( 18 );
    BishopMoves[ 45 ][ 0 ].push_back( 9 );
    BishopMoves[ 45 ][ 0 ].push_back( 0 );
    BishopMoves[ 45 ][ 1 ].push_back( 38 );
    BishopMoves[ 45 ][ 1 ].push_back( 31 );
    BishopMoves[ 45 ][ 2 ].push_back( 52 );
    BishopMoves[ 45 ][ 2 ].push_back( 59 );
    BishopMoves[ 45 ][ 3 ].push_back( 54 );
    BishopMoves[ 45 ][ 3 ].push_back( 63 );
    BishopMoves[ 46 ].resize( 4 );
    BishopMoves[ 46 ][ 0 ].push_back( 37 );
    BishopMoves[ 46 ][ 0 ].push_back( 28 );
    BishopMoves[ 46 ][ 0 ].push_back( 19 );
    BishopMoves[ 46 ][ 0 ].push_back( 10 );
    BishopMoves[ 46 ][ 0 ].push_back( 1 );
    BishopMoves[ 46 ][ 1 ].push_back( 39 );
    BishopMoves[ 46 ][ 2 ].push_back( 53 );
    BishopMoves[ 46 ][ 2 ].push_back( 60 );
    BishopMoves[ 46 ][ 3 ].push_back( 55 );
    BishopMoves[ 47 ].resize( 2 );
    BishopMoves[ 47 ][ 0 ].push_back( 38 );
    BishopMoves[ 47 ][ 0 ].push_back( 29 );
    BishopMoves[ 47 ][ 0 ].push_back( 20 );
    BishopMoves[ 47 ][ 0 ].push_back( 11 );
    BishopMoves[ 47 ][ 0 ].push_back( 2 );
    BishopMoves[ 47 ][ 1 ].push_back( 54 );
    BishopMoves[ 47 ][ 1 ].push_back( 61 );

    BishopMoves[ 48 ].resize( 2 );
    BishopMoves[ 48 ][ 0 ].push_back( 41 );
    BishopMoves[ 48 ][ 0 ].push_back( 34 );
    BishopMoves[ 48 ][ 0 ].push_back( 27 );
    BishopMoves[ 48 ][ 0 ].push_back( 20 );
    BishopMoves[ 48 ][ 0 ].push_back( 13 );
    BishopMoves[ 48 ][ 0 ].push_back( 6 );
    BishopMoves[ 48 ][ 1 ].push_back( 57 );
    BishopMoves[ 49 ].resize( 4 );
    BishopMoves[ 49 ][ 0 ].push_back( 40 );
    BishopMoves[ 49 ][ 1 ].push_back( 42 );
    BishopMoves[ 49 ][ 1 ].push_back( 35 );
    BishopMoves[ 49 ][ 1 ].push_back( 28 );
    BishopMoves[ 49 ][ 1 ].push_back( 21 );
    BishopMoves[ 49 ][ 1 ].push_back( 14 );
    BishopMoves[ 49 ][ 1 ].push_back( 7 );
    BishopMoves[ 49 ][ 2 ].push_back( 56 );
    BishopMoves[ 49 ][ 3 ].push_back( 58 );
    BishopMoves[ 50 ].resize( 4 );
    BishopMoves[ 50 ][ 0 ].push_back( 41 );
    BishopMoves[ 50 ][ 0 ].push_back( 32 );
    BishopMoves[ 50 ][ 1 ].push_back( 43 );
    BishopMoves[ 50 ][ 1 ].push_back( 36 );
    BishopMoves[ 50 ][ 1 ].push_back( 29 );
    BishopMoves[ 50 ][ 1 ].push_back( 22 );
    BishopMoves[ 50 ][ 1 ].push_back( 15 );
    BishopMoves[ 50 ][ 2 ].push_back( 57 );
    BishopMoves[ 50 ][ 3 ].push_back( 59 );
    BishopMoves[ 51 ].resize( 4 );
    BishopMoves[ 51 ][ 0 ].push_back( 42 );
    BishopMoves[ 51 ][ 0 ].push_back( 33 );
    BishopMoves[ 51 ][ 0 ].push_back( 24 );
    BishopMoves[ 51 ][ 1 ].push_back( 44 );
    BishopMoves[ 51 ][ 1 ].push_back( 37 );
    BishopMoves[ 51 ][ 1 ].push_back( 30 );
    BishopMoves[ 51 ][ 1 ].push_back( 23 );
    BishopMoves[ 51 ][ 2 ].push_back( 58 );
    BishopMoves[ 51 ][ 3 ].push_back( 60 );
    BishopMoves[ 52 ].resize( 4 );
    BishopMoves[ 52 ][ 0 ].push_back( 43 );
    BishopMoves[ 52 ][ 0 ].push_back( 34 );
    BishopMoves[ 52 ][ 0 ].push_back( 25 );
    BishopMoves[ 52 ][ 0 ].push_back( 16 );
    BishopMoves[ 52 ][ 1 ].push_back( 45 );
    BishopMoves[ 52 ][ 1 ].push_back( 38 );
    BishopMoves[ 52 ][ 1 ].push_back( 31 );
    BishopMoves[ 52 ][ 2 ].push_back( 59 );
    BishopMoves[ 52 ][ 3 ].push_back( 61 );
    BishopMoves[ 53 ].resize( 4 );
    BishopMoves[ 53 ][ 0 ].push_back( 44 );
    BishopMoves[ 53 ][ 0 ].push_back( 35 );
    BishopMoves[ 53 ][ 0 ].push_back( 26 );
    BishopMoves[ 53 ][ 0 ].push_back( 17 );
    BishopMoves[ 53 ][ 0 ].push_back( 8 );
    BishopMoves[ 53 ][ 1 ].push_back( 46 );
    BishopMoves[ 53 ][ 1 ].push_back( 39 );
    BishopMoves[ 53 ][ 2 ].push_back( 60 );
    BishopMoves[ 53 ][ 3 ].push_back( 62 );
    BishopMoves[ 54 ].resize( 4 );
    BishopMoves[ 54 ][ 0 ].push_back( 45 );
    BishopMoves[ 54 ][ 0 ].push_back( 36 );
    BishopMoves[ 54 ][ 0 ].push_back( 27 );
    BishopMoves[ 54 ][ 0 ].push_back( 18 );
    BishopMoves[ 54 ][ 0 ].push_back( 9 );
    BishopMoves[ 54 ][ 0 ].push_back( 0 );
    BishopMoves[ 54 ][ 1 ].push_back( 47 );
    BishopMoves[ 54 ][ 2 ].push_back( 61 );
    BishopMoves[ 54 ][ 3 ].push_back( 63 );
    BishopMoves[ 55 ].resize( 2 );
    BishopMoves[ 55 ][ 0 ].push_back( 46 );
    BishopMoves[ 55 ][ 0 ].push_back( 37 );
    BishopMoves[ 55 ][ 0 ].push_back( 28 );
    BishopMoves[ 55 ][ 0 ].push_back( 19 );
    BishopMoves[ 55 ][ 0 ].push_back( 10 );
    BishopMoves[ 55 ][ 0 ].push_back( 1 );
    BishopMoves[ 55 ][ 1 ].push_back( 62 );

    BishopMoves[ 56 ].resize( 1 );
    BishopMoves[ 56 ][ 0 ].push_back( 49 );
    BishopMoves[ 56 ][ 0 ].push_back( 42 );
    BishopMoves[ 56 ][ 0 ].push_back( 35 );
    BishopMoves[ 56 ][ 0 ].push_back( 28 );
    BishopMoves[ 56 ][ 0 ].push_back( 21 );
    BishopMoves[ 56 ][ 0 ].push_back( 14 );
    BishopMoves[ 56 ][ 0 ].push_back( 7 );
    BishopMoves[ 57 ].resize( 2 );
    BishopMoves[ 57 ][ 0 ].push_back( 48 );
    BishopMoves[ 57 ][ 1 ].push_back( 50 );
    BishopMoves[ 57 ][ 1 ].push_back( 43 );
    BishopMoves[ 57 ][ 1 ].push_back( 36 );
    BishopMoves[ 57 ][ 1 ].push_back( 29 );
    BishopMoves[ 57 ][ 1 ].push_back( 22 );
    BishopMoves[ 57 ][ 1 ].push_back( 15 );
    BishopMoves[ 58 ].resize( 2 );
    BishopMoves[ 58 ][ 0 ].push_back( 49 );
    BishopMoves[ 58 ][ 0 ].push_back( 40 );
    BishopMoves[ 58 ][ 1 ].push_back( 51 );
    BishopMoves[ 58 ][ 1 ].push_back( 44 );
    BishopMoves[ 58 ][ 1 ].push_back( 37 );
    BishopMoves[ 58 ][ 1 ].push_back( 30 );
    BishopMoves[ 58 ][ 1 ].push_back( 23 );
    BishopMoves[ 59 ].resize( 2 );
    BishopMoves[ 59 ][ 0 ].push_back( 50 );
    BishopMoves[ 59 ][ 0 ].push_back( 41 );
    BishopMoves[ 59 ][ 0 ].push_back( 32 );
    BishopMoves[ 59 ][ 1 ].push_back( 52 );
    BishopMoves[ 59 ][ 1 ].push_back( 45 );
    BishopMoves[ 59 ][ 1 ].push_back( 38 );
    BishopMoves[ 59 ][ 1 ].push_back( 31 );
    BishopMoves[ 60 ].resize( 2 );
    BishopMoves[ 60 ][ 0 ].push_back( 51 );
    BishopMoves[ 60 ][ 0 ].push_back( 42 );
    BishopMoves[ 60 ][ 0 ].push_back( 33 );
    BishopMoves[ 60 ][ 0 ].push_back( 24 );
    BishopMoves[ 60 ][ 1 ].push_back( 53 );
    BishopMoves[ 60 ][ 1 ].push_back( 46 );
    BishopMoves[ 60 ][ 1 ].push_back( 39 );
    BishopMoves[ 61 ].resize( 2 );
    BishopMoves[ 61 ][ 0 ].push_back( 52 );
    BishopMoves[ 61 ][ 0 ].push_back( 43 );
    BishopMoves[ 61 ][ 0 ].push_back( 34 );
    BishopMoves[ 61 ][ 0 ].push_back( 25 );
    BishopMoves[ 61 ][ 0 ].push_back( 16 );
    BishopMoves[ 61 ][ 1 ].push_back( 54 );
    BishopMoves[ 61 ][ 1 ].push_back( 47 );
    BishopMoves[ 62 ].resize( 2 );
    BishopMoves[ 62 ][ 0 ].push_back( 53 );
    BishopMoves[ 62 ][ 0 ].push_back( 44 );
    BishopMoves[ 62 ][ 0 ].push_back( 35 );
    BishopMoves[ 62 ][ 0 ].push_back( 26 );
    BishopMoves[ 62 ][ 0 ].push_back( 17 );
    BishopMoves[ 62 ][ 0 ].push_back( 8 );
    BishopMoves[ 62 ][ 1 ].push_back( 55 );
    BishopMoves[ 63 ].resize( 1 );
    BishopMoves[ 63 ][ 0 ].push_back( 54 );
    BishopMoves[ 63 ][ 0 ].push_back( 45 );
    BishopMoves[ 63 ][ 0 ].push_back( 36 );
    BishopMoves[ 63 ][ 0 ].push_back( 27 );
    BishopMoves[ 63 ][ 0 ].push_back( 18 );
    BishopMoves[ 63 ][ 0 ].push_back( 9 );
    BishopMoves[ 63 ][ 0 ].push_back( 0 );

    RookMoves[ 0 ].resize( 2 );
	RookMoves[ 0 ][ 0 ].push_back( 1 );
    RookMoves[ 0 ][ 0 ].push_back( 2 );
    RookMoves[ 0 ][ 0 ].push_back( 3 );
    RookMoves[ 0 ][ 0 ].push_back( 4 );
    RookMoves[ 0 ][ 0 ].push_back( 5 );
    RookMoves[ 0 ][ 0 ].push_back( 6 );
    RookMoves[ 0 ][ 0 ].push_back( 7 );
    RookMoves[ 0 ][ 1 ].push_back( 8 );
    RookMoves[ 0 ][ 1 ].push_back( 16 );
    RookMoves[ 0 ][ 1 ].push_back( 24 );
    RookMoves[ 0 ][ 1 ].push_back( 32 );
    RookMoves[ 0 ][ 1 ].push_back( 40 );
    RookMoves[ 0 ][ 1 ].push_back( 48 );
    RookMoves[ 0 ][ 1 ].push_back( 56 );
    RookMoves[ 1 ].resize( 3 );
	RookMoves[ 1 ][ 0 ].push_back( 0 );
    RookMoves[ 1 ][ 1 ].push_back( 2 );
    RookMoves[ 1 ][ 1 ].push_back( 3 );
    RookMoves[ 1 ][ 1 ].push_back( 4 );
    RookMoves[ 1 ][ 1 ].push_back( 5 );
    RookMoves[ 1 ][ 1 ].push_back( 6 );
    RookMoves[ 1 ][ 1 ].push_back( 7 );
    RookMoves[ 1 ][ 2 ].push_back( 9 );
    RookMoves[ 1 ][ 2 ].push_back( 17 );
    RookMoves[ 1 ][ 2 ].push_back( 25 );
    RookMoves[ 1 ][ 2 ].push_back( 33 );
    RookMoves[ 1 ][ 2 ].push_back( 41 );
    RookMoves[ 1 ][ 2 ].push_back( 49 );
    RookMoves[ 1 ][ 2 ].push_back( 57 );
    RookMoves[ 2 ].resize( 3 );
    RookMoves[ 2 ][ 0 ].push_back( 1 );
    RookMoves[ 2 ][ 0 ].push_back( 0 );
    RookMoves[ 2 ][ 1 ].push_back( 3 );
    RookMoves[ 2 ][ 1 ].push_back( 4 );
    RookMoves[ 2 ][ 1 ].push_back( 5 );
    RookMoves[ 2 ][ 1 ].push_back( 6 );
    RookMoves[ 2 ][ 1 ].push_back( 7 );
    RookMoves[ 2 ][ 2 ].push_back( 10 );
    RookMoves[ 2 ][ 2 ].push_back( 18 );
    RookMoves[ 2 ][ 2 ].push_back( 26 );
    RookMoves[ 2 ][ 2 ].push_back( 34 );
    RookMoves[ 2 ][ 2 ].push_back( 42 );
    RookMoves[ 2 ][ 2 ].push_back( 50 );
    RookMoves[ 2 ][ 2 ].push_back( 58 );
    RookMoves[ 3 ].resize( 3 );
    RookMoves[ 3 ][ 0 ].push_back( 2 );
    RookMoves[ 3 ][ 0 ].push_back( 1 );
    RookMoves[ 3 ][ 0 ].push_back( 0 );
    RookMoves[ 3 ][ 1 ].push_back( 4 );
    RookMoves[ 3 ][ 1 ].push_back( 5 );
    RookMoves[ 3 ][ 1 ].push_back( 6 );
    RookMoves[ 3 ][ 1 ].push_back( 7 );
    RookMoves[ 3 ][ 2 ].push_back( 11 );
    RookMoves[ 3 ][ 2 ].push_back( 19 );
    RookMoves[ 3 ][ 2 ].push_back( 27 );
    RookMoves[ 3 ][ 2 ].push_back( 35 );
    RookMoves[ 3 ][ 2 ].push_back( 43 );
    RookMoves[ 3 ][ 2 ].push_back( 51 );
    RookMoves[ 3 ][ 2 ].push_back( 59 );
    RookMoves[ 4 ].resize( 3 );
    RookMoves[ 4 ][ 0 ].push_back( 3 );
    RookMoves[ 4 ][ 0 ].push_back( 2 );
    RookMoves[ 4 ][ 0 ].push_back( 1 );
    RookMoves[ 4 ][ 0 ].push_back( 0 );
    RookMoves[ 4 ][ 1 ].push_back( 5 );
    RookMoves[ 4 ][ 1 ].push_back( 6 );
    RookMoves[ 4 ][ 1 ].push_back( 7 );
    RookMoves[ 4 ][ 2 ].push_back( 12 );
    RookMoves[ 4 ][ 2 ].push_back( 20 );
    RookMoves[ 4 ][ 2 ].push_back( 28 );
    RookMoves[ 4 ][ 2 ].push_back( 36 );
    RookMoves[ 4 ][ 2 ].push_back( 44 );
    RookMoves[ 4 ][ 2 ].push_back( 52 );
    RookMoves[ 4 ][ 2 ].push_back( 60 );
    RookMoves[ 5 ].resize( 3 );
    RookMoves[ 5 ][ 0 ].push_back( 4 );
    RookMoves[ 5 ][ 0 ].push_back( 3 );
    RookMoves[ 5 ][ 0 ].push_back( 2 );
    RookMoves[ 5 ][ 0 ].push_back( 1 );
    RookMoves[ 5 ][ 0 ].push_back( 0 );
    RookMoves[ 5 ][ 1 ].push_back( 6 );
    RookMoves[ 5 ][ 1 ].push_back( 7 );
    RookMoves[ 5 ][ 2 ].push_back( 13 );
    RookMoves[ 5 ][ 2 ].push_back( 21 );
    RookMoves[ 5 ][ 2 ].push_back( 29 );
    RookMoves[ 5 ][ 2 ].push_back( 37 );
    RookMoves[ 5 ][ 2 ].push_back( 45 );
    RookMoves[ 5 ][ 2 ].push_back( 53 );
    RookMoves[ 5 ][ 2 ].push_back( 61 );
    RookMoves[ 6 ].resize( 3 );
    RookMoves[ 6 ][ 0 ].push_back( 5 );
    RookMoves[ 6 ][ 0 ].push_back( 4 );
    RookMoves[ 6 ][ 0 ].push_back( 3 );
    RookMoves[ 6 ][ 0 ].push_back( 2 );
    RookMoves[ 6 ][ 0 ].push_back( 1 );
    RookMoves[ 6 ][ 0 ].push_back( 0 );
    RookMoves[ 6 ][ 1 ].push_back( 7 );
    RookMoves[ 6 ][ 2 ].push_back( 14 );
    RookMoves[ 6 ][ 2 ].push_back( 22 );
    RookMoves[ 6 ][ 2 ].push_back( 30 );
    RookMoves[ 6 ][ 2 ].push_back( 38 );
    RookMoves[ 6 ][ 2 ].push_back( 46 );
    RookMoves[ 6 ][ 2 ].push_back( 54 );
    RookMoves[ 6 ][ 2 ].push_back( 62 );
    RookMoves[ 7 ].resize( 2 );
    RookMoves[ 7 ][ 0 ].push_back( 6 );
    RookMoves[ 7 ][ 0 ].push_back( 5 );
    RookMoves[ 7 ][ 0 ].push_back( 4 );
    RookMoves[ 7 ][ 0 ].push_back( 3 );
    RookMoves[ 7 ][ 0 ].push_back( 2 );
    RookMoves[ 7 ][ 0 ].push_back( 1 );
    RookMoves[ 7 ][ 0 ].push_back( 0 );
    RookMoves[ 7 ][ 1 ].push_back( 15 );
    RookMoves[ 7 ][ 1 ].push_back( 23 );
    RookMoves[ 7 ][ 1 ].push_back( 31 );
    RookMoves[ 7 ][ 1 ].push_back( 39 );
    RookMoves[ 7 ][ 1 ].push_back( 47 );
    RookMoves[ 7 ][ 1 ].push_back( 55 );
    RookMoves[ 7 ][ 1 ].push_back( 63 );

    RookMoves[ 8 ].resize( 3 );
    RookMoves[ 8 ][ 0 ].push_back( 9 );
    RookMoves[ 8 ][ 0 ].push_back( 10 );
    RookMoves[ 8 ][ 0 ].push_back( 11 );
    RookMoves[ 8 ][ 0 ].push_back( 12 );
    RookMoves[ 8 ][ 0 ].push_back( 13 );
    RookMoves[ 8 ][ 0 ].push_back( 14 );
    RookMoves[ 8 ][ 0 ].push_back( 15 );
    RookMoves[ 8 ][ 1 ].push_back( 0 );
    RookMoves[ 8 ][ 2 ].push_back( 16 );
    RookMoves[ 8 ][ 2 ].push_back( 24 );
    RookMoves[ 8 ][ 2 ].push_back( 32 );
    RookMoves[ 8 ][ 2 ].push_back( 40 );
    RookMoves[ 8 ][ 2 ].push_back( 48 );
    RookMoves[ 8 ][ 2 ].push_back( 56 );
    RookMoves[ 9 ].resize( 4 );
    RookMoves[ 9 ][ 0 ].push_back( 8 );
    RookMoves[ 9 ][ 1 ].push_back( 10 );
    RookMoves[ 9 ][ 1 ].push_back( 11 );
    RookMoves[ 9 ][ 1 ].push_back( 12 );
    RookMoves[ 9 ][ 1 ].push_back( 13 );
    RookMoves[ 9 ][ 1 ].push_back( 14 );
    RookMoves[ 9 ][ 1 ].push_back( 15 );
    RookMoves[ 9 ][ 2 ].push_back( 1 );
    RookMoves[ 9 ][ 3 ].push_back( 17 );
    RookMoves[ 9 ][ 3 ].push_back( 25 );
    RookMoves[ 9 ][ 3 ].push_back( 33 );
    RookMoves[ 9 ][ 3 ].push_back( 41 );
    RookMoves[ 9 ][ 3 ].push_back( 49 );
    RookMoves[ 9 ][ 3 ].push_back( 57 );
    RookMoves[ 10 ].resize( 4 );
    RookMoves[ 10 ][ 0 ].push_back( 9 );
    RookMoves[ 10 ][ 0 ].push_back( 8 );
    RookMoves[ 10 ][ 1 ].push_back( 11 );
    RookMoves[ 10 ][ 1 ].push_back( 12 );
    RookMoves[ 10 ][ 1 ].push_back( 13 );
    RookMoves[ 10 ][ 1 ].push_back( 14 );
    RookMoves[ 10 ][ 1 ].push_back( 15 );
    RookMoves[ 10 ][ 2 ].push_back( 2 );
    RookMoves[ 10 ][ 3 ].push_back( 18 );
    RookMoves[ 10 ][ 3 ].push_back( 26 );
    RookMoves[ 10 ][ 3 ].push_back( 34 );
    RookMoves[ 10 ][ 3 ].push_back( 42 );
    RookMoves[ 10 ][ 3 ].push_back( 50 );
    RookMoves[ 10 ][ 3 ].push_back( 58 );
    RookMoves[ 11 ].resize( 4 );
    RookMoves[ 11 ][ 0 ].push_back( 10 );
    RookMoves[ 11 ][ 0 ].push_back( 9 );
    RookMoves[ 11 ][ 0 ].push_back( 8 );
    RookMoves[ 11 ][ 1 ].push_back( 12 );
    RookMoves[ 11 ][ 1 ].push_back( 13 );
    RookMoves[ 11 ][ 1 ].push_back( 14 );
    RookMoves[ 11 ][ 1 ].push_back( 15 );
    RookMoves[ 11 ][ 2 ].push_back( 3 );
    RookMoves[ 11 ][ 3 ].push_back( 19 );
    RookMoves[ 11 ][ 3 ].push_back( 27 );
    RookMoves[ 11 ][ 3 ].push_back( 35 );
    RookMoves[ 11 ][ 3 ].push_back( 43 );
    RookMoves[ 11 ][ 3 ].push_back( 51 );
    RookMoves[ 11 ][ 3 ].push_back( 59 );
    RookMoves[ 12 ].resize( 4 );
    RookMoves[ 12 ][ 0 ].push_back( 11 );
    RookMoves[ 12 ][ 0 ].push_back( 10 );
    RookMoves[ 12 ][ 0 ].push_back( 9 );
    RookMoves[ 12 ][ 0 ].push_back( 8 );
    RookMoves[ 12 ][ 1 ].push_back( 13 );
    RookMoves[ 12 ][ 1 ].push_back( 14 );
    RookMoves[ 12 ][ 1 ].push_back( 15 );
    RookMoves[ 12 ][ 2 ].push_back( 4 );
    RookMoves[ 12 ][ 3 ].push_back( 20 );
    RookMoves[ 12 ][ 3 ].push_back( 28 );
    RookMoves[ 12 ][ 3 ].push_back( 36 );
    RookMoves[ 12 ][ 3 ].push_back( 44 );
    RookMoves[ 12 ][ 3 ].push_back( 52 );
    RookMoves[ 12 ][ 3 ].push_back( 60 );
    RookMoves[ 13 ].resize( 4 );
    RookMoves[ 13 ][ 0 ].push_back( 12 );
    RookMoves[ 13 ][ 0 ].push_back( 11 );
    RookMoves[ 13 ][ 0 ].push_back( 10 );
    RookMoves[ 13 ][ 0 ].push_back( 9 );
    RookMoves[ 13 ][ 0 ].push_back( 8 );
    RookMoves[ 13 ][ 1 ].push_back( 14 );
    RookMoves[ 13 ][ 1 ].push_back( 15 );
    RookMoves[ 13 ][ 2 ].push_back( 5 );
    RookMoves[ 13 ][ 3 ].push_back( 21 );
    RookMoves[ 13 ][ 3 ].push_back( 29 );
    RookMoves[ 13 ][ 3 ].push_back( 37 );
    RookMoves[ 13 ][ 3 ].push_back( 45 );
    RookMoves[ 13 ][ 3 ].push_back( 53 );
    RookMoves[ 13 ][ 3 ].push_back( 61 );
    RookMoves[ 14 ].resize( 4 );
    RookMoves[ 14 ][ 0 ].push_back( 13 );
    RookMoves[ 14 ][ 0 ].push_back( 12 );
    RookMoves[ 14 ][ 0 ].push_back( 11 );
    RookMoves[ 14 ][ 0 ].push_back( 10 );
    RookMoves[ 14 ][ 0 ].push_back( 9 );
    RookMoves[ 14 ][ 0 ].push_back( 8 );
    RookMoves[ 14 ][ 1 ].push_back( 15 );
    RookMoves[ 14 ][ 2 ].push_back( 6 );
    RookMoves[ 14 ][ 3 ].push_back( 22 );
    RookMoves[ 14 ][ 3 ].push_back( 30 );
    RookMoves[ 14 ][ 3 ].push_back( 38 );
    RookMoves[ 14 ][ 3 ].push_back( 46 );
    RookMoves[ 14 ][ 3 ].push_back( 54 );
    RookMoves[ 14 ][ 3 ].push_back( 62 );
    RookMoves[ 15 ].resize( 3 );
    RookMoves[ 15 ][ 0 ].push_back( 14 );
    RookMoves[ 15 ][ 0 ].push_back( 13 );
    RookMoves[ 15 ][ 0 ].push_back( 12 );
    RookMoves[ 15 ][ 0 ].push_back( 11 );
    RookMoves[ 15 ][ 0 ].push_back( 10 );
    RookMoves[ 15 ][ 0 ].push_back( 9 );
    RookMoves[ 15 ][ 0 ].push_back( 8 );
    RookMoves[ 15 ][ 1 ].push_back( 7 );
    RookMoves[ 15 ][ 2 ].push_back( 23 );
    RookMoves[ 15 ][ 2 ].push_back( 31 );
    RookMoves[ 15 ][ 2 ].push_back( 39 );
    RookMoves[ 15 ][ 2 ].push_back( 47 );
    RookMoves[ 15 ][ 2 ].push_back( 55 );
    RookMoves[ 15 ][ 2 ].push_back( 63 );

    RookMoves[ 16 ].resize( 3 );
    RookMoves[ 16 ][ 0 ].push_back( 8 );
    RookMoves[ 16 ][ 0 ].push_back( 0 );
    RookMoves[ 16 ][ 1 ].push_back( 24 );
    RookMoves[ 16 ][ 1 ].push_back( 32 );
    RookMoves[ 16 ][ 1 ].push_back( 40 );
    RookMoves[ 16 ][ 1 ].push_back( 48 );
    RookMoves[ 16 ][ 1 ].push_back( 56 );
    RookMoves[ 16 ][ 2 ].push_back( 17 );
    RookMoves[ 16 ][ 2 ].push_back( 18 );
    RookMoves[ 16 ][ 2 ].push_back( 19 );
    RookMoves[ 16 ][ 2 ].push_back( 20 );
    RookMoves[ 16 ][ 2 ].push_back( 21 );
    RookMoves[ 16 ][ 2 ].push_back( 22 );
    RookMoves[ 16 ][ 2 ].push_back( 23 );
    RookMoves[ 17 ].resize( 4 );
    RookMoves[ 17 ][ 0 ].push_back( 16 );
    RookMoves[ 17 ][ 1 ].push_back( 18 );
    RookMoves[ 17 ][ 1 ].push_back( 19 );
    RookMoves[ 17 ][ 1 ].push_back( 20 );
    RookMoves[ 17 ][ 1 ].push_back( 21 );
    RookMoves[ 17 ][ 1 ].push_back( 22 );
    RookMoves[ 17 ][ 1 ].push_back( 23 );
    RookMoves[ 17 ][ 2 ].push_back( 9 );
    RookMoves[ 17 ][ 2 ].push_back( 1 );
    RookMoves[ 17 ][ 3 ].push_back( 25 );
    RookMoves[ 17 ][ 3 ].push_back( 33 );
    RookMoves[ 17 ][ 3 ].push_back( 41 );
    RookMoves[ 17 ][ 3 ].push_back( 49 );
    RookMoves[ 17 ][ 3 ].push_back( 57 );
    RookMoves[ 18 ].resize( 4 );
    RookMoves[ 18 ][ 0 ].push_back( 17 );
    RookMoves[ 18 ][ 0 ].push_back( 16 );
    RookMoves[ 18 ][ 1 ].push_back( 19 );
    RookMoves[ 18 ][ 1 ].push_back( 20 );
    RookMoves[ 18 ][ 1 ].push_back( 21 );
    RookMoves[ 18 ][ 1 ].push_back( 22 );
    RookMoves[ 18 ][ 1 ].push_back( 23 );
    RookMoves[ 18 ][ 2 ].push_back( 10 );
    RookMoves[ 18 ][ 2 ].push_back( 2 );
    RookMoves[ 18 ][ 3 ].push_back( 26 );
    RookMoves[ 18 ][ 3 ].push_back( 34 );
    RookMoves[ 18 ][ 3 ].push_back( 42 );
    RookMoves[ 18 ][ 3 ].push_back( 50 );
    RookMoves[ 18 ][ 3 ].push_back( 58 );
    RookMoves[ 19 ].resize( 4 );
    RookMoves[ 19 ][ 0 ].push_back( 18 );
    RookMoves[ 19 ][ 0 ].push_back( 17 );
    RookMoves[ 19 ][ 0 ].push_back( 16 );
    RookMoves[ 19 ][ 1 ].push_back( 20 );
    RookMoves[ 19 ][ 1 ].push_back( 21 );
    RookMoves[ 19 ][ 1 ].push_back( 22 );
    RookMoves[ 19 ][ 1 ].push_back( 23 );
    RookMoves[ 19 ][ 2 ].push_back( 11 );
    RookMoves[ 19 ][ 2 ].push_back( 3 );
    RookMoves[ 19 ][ 3 ].push_back( 27 );
    RookMoves[ 19 ][ 3 ].push_back( 35 );
    RookMoves[ 19 ][ 3 ].push_back( 43 );
    RookMoves[ 19 ][ 3 ].push_back( 51 );
    RookMoves[ 19 ][ 3 ].push_back( 59 );
    RookMoves[ 20 ].resize( 4 );
    RookMoves[ 20 ][ 0 ].push_back( 19 );
    RookMoves[ 20 ][ 0 ].push_back( 18 );
    RookMoves[ 20 ][ 0 ].push_back( 17 );
    RookMoves[ 20 ][ 0 ].push_back( 16 );
    RookMoves[ 20 ][ 1 ].push_back( 21 );
    RookMoves[ 20 ][ 1 ].push_back( 22 );
    RookMoves[ 20 ][ 1 ].push_back( 23 );
    RookMoves[ 20 ][ 2 ].push_back( 12 );
    RookMoves[ 20 ][ 2 ].push_back( 4 );
    RookMoves[ 20 ][ 3 ].push_back( 28 );
    RookMoves[ 20 ][ 3 ].push_back( 36 );
    RookMoves[ 20 ][ 3 ].push_back( 44 );
    RookMoves[ 20 ][ 3 ].push_back( 52 );
    RookMoves[ 20 ][ 3 ].push_back( 60 );
    RookMoves[ 21 ].resize( 4 );
    RookMoves[ 21 ][ 0 ].push_back( 20 );
    RookMoves[ 21 ][ 0 ].push_back( 19 );
    RookMoves[ 21 ][ 0 ].push_back( 18 );
    RookMoves[ 21 ][ 0 ].push_back( 17 );
    RookMoves[ 21 ][ 0 ].push_back( 16 );
    RookMoves[ 21 ][ 1 ].push_back( 22 );
    RookMoves[ 21 ][ 1 ].push_back( 23 );
    RookMoves[ 21 ][ 2 ].push_back( 13 );
    RookMoves[ 21 ][ 2 ].push_back( 5 );
    RookMoves[ 21 ][ 3 ].push_back( 29 );
    RookMoves[ 21 ][ 3 ].push_back( 37 );
    RookMoves[ 21 ][ 3 ].push_back( 45 );
    RookMoves[ 21 ][ 3 ].push_back( 53 );
    RookMoves[ 21 ][ 3 ].push_back( 61 );
    RookMoves[ 22 ].resize( 4 );
    RookMoves[ 22 ][ 0 ].push_back( 21 );
    RookMoves[ 22 ][ 0 ].push_back( 20 );
    RookMoves[ 22 ][ 0 ].push_back( 19 );
    RookMoves[ 22 ][ 0 ].push_back( 18 );
    RookMoves[ 22 ][ 0 ].push_back( 17 );
    RookMoves[ 22 ][ 0 ].push_back( 16 );
    RookMoves[ 22 ][ 1 ].push_back( 23 );
    RookMoves[ 22 ][ 2 ].push_back( 14 );
    RookMoves[ 22 ][ 2 ].push_back( 6 );
    RookMoves[ 22 ][ 3 ].push_back( 30 );
    RookMoves[ 22 ][ 3 ].push_back( 38 );
    RookMoves[ 22 ][ 3 ].push_back( 46 );
    RookMoves[ 22 ][ 3 ].push_back( 54 );
    RookMoves[ 22 ][ 3 ].push_back( 62 );
    RookMoves[ 23 ].resize( 3 );
    RookMoves[ 23 ][ 0 ].push_back( 22 );
    RookMoves[ 23 ][ 0 ].push_back( 21 );
    RookMoves[ 23 ][ 0 ].push_back( 20 );
    RookMoves[ 23 ][ 0 ].push_back( 19 );
    RookMoves[ 23 ][ 0 ].push_back( 18 );
    RookMoves[ 23 ][ 0 ].push_back( 17 );
    RookMoves[ 23 ][ 0 ].push_back( 16 );
    RookMoves[ 23 ][ 1 ].push_back( 15 );
    RookMoves[ 23 ][ 1 ].push_back( 7 );
    RookMoves[ 23 ][ 2 ].push_back( 31 );
    RookMoves[ 23 ][ 2 ].push_back( 39 );
    RookMoves[ 23 ][ 2 ].push_back( 47 );
    RookMoves[ 23 ][ 2 ].push_back( 55 );
    RookMoves[ 23 ][ 2 ].push_back( 63 );

    RookMoves[ 24 ].resize( 3 );
    RookMoves[ 24 ][ 0 ].push_back( 16 );
    RookMoves[ 24 ][ 0 ].push_back( 8 );
    RookMoves[ 24 ][ 0 ].push_back( 0 );
    RookMoves[ 24 ][ 1 ].push_back( 32 );
    RookMoves[ 24 ][ 1 ].push_back( 40 );
    RookMoves[ 24 ][ 1 ].push_back( 48 );
    RookMoves[ 24 ][ 1 ].push_back( 56 );
    RookMoves[ 24 ][ 2 ].push_back( 25 );
    RookMoves[ 24 ][ 2 ].push_back( 26 );
    RookMoves[ 24 ][ 2 ].push_back( 27 );
    RookMoves[ 24 ][ 2 ].push_back( 28 );
    RookMoves[ 24 ][ 2 ].push_back( 29 );
    RookMoves[ 24 ][ 2 ].push_back( 30 );
    RookMoves[ 24 ][ 2 ].push_back( 31 );
    RookMoves[ 25 ].resize( 4 );
    RookMoves[ 25 ][ 0 ].push_back( 24 );
    RookMoves[ 25 ][ 1 ].push_back( 26 );
    RookMoves[ 25 ][ 1 ].push_back( 27 );
    RookMoves[ 25 ][ 1 ].push_back( 28 );
    RookMoves[ 25 ][ 1 ].push_back( 29 );
    RookMoves[ 25 ][ 1 ].push_back( 30 );
    RookMoves[ 25 ][ 1 ].push_back( 31 );
    RookMoves[ 25 ][ 2 ].push_back( 17 );
    RookMoves[ 25 ][ 2 ].push_back( 9 );
    RookMoves[ 25 ][ 2 ].push_back( 1 );
    RookMoves[ 25 ][ 3 ].push_back( 33 );
    RookMoves[ 25 ][ 3 ].push_back( 41 );
    RookMoves[ 25 ][ 3 ].push_back( 49 );
    RookMoves[ 25 ][ 3 ].push_back( 57 );
    RookMoves[ 26 ].resize( 4 );
    RookMoves[ 26 ][ 0 ].push_back( 25 );
    RookMoves[ 26 ][ 0 ].push_back( 24 );
    RookMoves[ 26 ][ 1 ].push_back( 27 );
    RookMoves[ 26 ][ 1 ].push_back( 28 );
    RookMoves[ 26 ][ 1 ].push_back( 29 );
    RookMoves[ 26 ][ 1 ].push_back( 30 );
    RookMoves[ 26 ][ 1 ].push_back( 31 );
    RookMoves[ 26 ][ 2 ].push_back( 18 );
    RookMoves[ 26 ][ 2 ].push_back( 10 );
    RookMoves[ 26 ][ 2 ].push_back( 2 );
    RookMoves[ 26 ][ 3 ].push_back( 34 );
    RookMoves[ 26 ][ 3 ].push_back( 42 );
    RookMoves[ 26 ][ 3 ].push_back( 50 );
    RookMoves[ 26 ][ 3 ].push_back( 58 );
    RookMoves[ 27 ].resize( 4 );
    RookMoves[ 27 ][ 0 ].push_back( 26 );
    RookMoves[ 27 ][ 0 ].push_back( 25 );
    RookMoves[ 27 ][ 0 ].push_back( 24 );
    RookMoves[ 27 ][ 1 ].push_back( 28 );
    RookMoves[ 27 ][ 1 ].push_back( 29 );
    RookMoves[ 27 ][ 1 ].push_back( 30 );
    RookMoves[ 27 ][ 1 ].push_back( 31 );
    RookMoves[ 27 ][ 2 ].push_back( 19 );
    RookMoves[ 27 ][ 2 ].push_back( 11 );
    RookMoves[ 27 ][ 2 ].push_back( 3 );
    RookMoves[ 27 ][ 3 ].push_back( 35 );
    RookMoves[ 27 ][ 3 ].push_back( 43 );
    RookMoves[ 27 ][ 3 ].push_back( 51 );
    RookMoves[ 27 ][ 3 ].push_back( 59 );
    RookMoves[ 28 ].resize( 4 );
    RookMoves[ 28 ][ 0 ].push_back( 27 );
    RookMoves[ 28 ][ 0 ].push_back( 26 );
    RookMoves[ 28 ][ 0 ].push_back( 25 );
    RookMoves[ 28 ][ 0 ].push_back( 24 );
    RookMoves[ 28 ][ 1 ].push_back( 29 );
    RookMoves[ 28 ][ 1 ].push_back( 30 );
    RookMoves[ 28 ][ 1 ].push_back( 31 );
    RookMoves[ 28 ][ 2 ].push_back( 20 );
    RookMoves[ 28 ][ 2 ].push_back( 12 );
    RookMoves[ 28 ][ 2 ].push_back( 4 );
    RookMoves[ 28 ][ 3 ].push_back( 36 );
    RookMoves[ 28 ][ 3 ].push_back( 44 );
    RookMoves[ 28 ][ 3 ].push_back( 52 );
    RookMoves[ 28 ][ 3 ].push_back( 60 );
    RookMoves[ 29 ].resize( 4 );
    RookMoves[ 29 ][ 0 ].push_back( 28 );
    RookMoves[ 29 ][ 0 ].push_back( 27 );
    RookMoves[ 29 ][ 0 ].push_back( 26 );
    RookMoves[ 29 ][ 0 ].push_back( 25 );
    RookMoves[ 29 ][ 0 ].push_back( 24 );
    RookMoves[ 29 ][ 1 ].push_back( 30 );
    RookMoves[ 29 ][ 1 ].push_back( 31 );
    RookMoves[ 29 ][ 2 ].push_back( 21 );
    RookMoves[ 29 ][ 2 ].push_back( 13 );
    RookMoves[ 29 ][ 2 ].push_back( 5 );
    RookMoves[ 29 ][ 3 ].push_back( 37 );
    RookMoves[ 29 ][ 3 ].push_back( 45 );
    RookMoves[ 29 ][ 3 ].push_back( 53 );
    RookMoves[ 29 ][ 3 ].push_back( 61 );
    RookMoves[ 30 ].resize( 4 );
    RookMoves[ 30 ][ 0 ].push_back( 29 );
    RookMoves[ 30 ][ 0 ].push_back( 28 );
    RookMoves[ 30 ][ 0 ].push_back( 27 );
    RookMoves[ 30 ][ 0 ].push_back( 26 );
    RookMoves[ 30 ][ 0 ].push_back( 25 );
    RookMoves[ 30 ][ 0 ].push_back( 24 );
    RookMoves[ 30 ][ 1 ].push_back( 31 );
    RookMoves[ 30 ][ 2 ].push_back( 22 );
    RookMoves[ 30 ][ 2 ].push_back( 14 );
    RookMoves[ 30 ][ 2 ].push_back( 6 );
    RookMoves[ 30 ][ 3 ].push_back( 38 );
    RookMoves[ 30 ][ 3 ].push_back( 46 );
    RookMoves[ 30 ][ 3 ].push_back( 54 );
    RookMoves[ 30 ][ 3 ].push_back( 62 );
    RookMoves[ 31 ].resize( 3 );
    RookMoves[ 31 ][ 0 ].push_back( 30 );
    RookMoves[ 31 ][ 0 ].push_back( 29 );
    RookMoves[ 31 ][ 0 ].push_back( 28 );
    RookMoves[ 31 ][ 0 ].push_back( 27 );
    RookMoves[ 31 ][ 0 ].push_back( 26 );
    RookMoves[ 31 ][ 0 ].push_back( 25 );
    RookMoves[ 31 ][ 0 ].push_back( 24 );
    RookMoves[ 31 ][ 1 ].push_back( 23 );
    RookMoves[ 31 ][ 1 ].push_back( 15 );
    RookMoves[ 31 ][ 1 ].push_back( 7 );
    RookMoves[ 31 ][ 2 ].push_back( 39 );
    RookMoves[ 31 ][ 2 ].push_back( 47 );
    RookMoves[ 31 ][ 2 ].push_back( 55 );
    RookMoves[ 31 ][ 2 ].push_back( 63 );

    RookMoves[ 32 ].resize( 3 );
    RookMoves[ 32 ][ 0 ].push_back( 33 );
    RookMoves[ 32 ][ 0 ].push_back( 34 );
    RookMoves[ 32 ][ 0 ].push_back( 35 );
    RookMoves[ 32 ][ 0 ].push_back( 36 );
    RookMoves[ 32 ][ 0 ].push_back( 37 );
    RookMoves[ 32 ][ 0 ].push_back( 38 );
    RookMoves[ 32 ][ 0 ].push_back( 39 );
    RookMoves[ 32 ][ 1 ].push_back( 40 );
    RookMoves[ 32 ][ 1 ].push_back( 48 );
    RookMoves[ 32 ][ 1 ].push_back( 56 );
    RookMoves[ 32 ][ 2 ].push_back( 24 );
    RookMoves[ 32 ][ 2 ].push_back( 16 );
    RookMoves[ 32 ][ 2 ].push_back( 8 );
    RookMoves[ 32 ][ 2 ].push_back( 0 );
    RookMoves[ 33 ].resize( 4 );
    RookMoves[ 33 ][ 0 ].push_back( 32 );
    RookMoves[ 33 ][ 1 ].push_back( 34 );
    RookMoves[ 33 ][ 1 ].push_back( 35 );
    RookMoves[ 33 ][ 1 ].push_back( 36 );
    RookMoves[ 33 ][ 1 ].push_back( 37 );
    RookMoves[ 33 ][ 1 ].push_back( 38 );
    RookMoves[ 33 ][ 1 ].push_back( 39 );
    RookMoves[ 33 ][ 2 ].push_back( 25 );
    RookMoves[ 33 ][ 2 ].push_back( 17 );
    RookMoves[ 33 ][ 2 ].push_back( 9 );
    RookMoves[ 33 ][ 2 ].push_back( 1 );
    RookMoves[ 33 ][ 3 ].push_back( 41 );
    RookMoves[ 33 ][ 3 ].push_back( 49 );
    RookMoves[ 33 ][ 3 ].push_back( 57 );
    RookMoves[ 34 ].resize( 4 );
    RookMoves[ 34 ][ 0 ].push_back( 33 );
    RookMoves[ 34 ][ 0 ].push_back( 32 );
    RookMoves[ 34 ][ 1 ].push_back( 35 );
    RookMoves[ 34 ][ 1 ].push_back( 36 );
    RookMoves[ 34 ][ 1 ].push_back( 37 );
    RookMoves[ 34 ][ 1 ].push_back( 38 );
    RookMoves[ 34 ][ 1 ].push_back( 39 );
    RookMoves[ 34 ][ 2 ].push_back( 26 );
    RookMoves[ 34 ][ 2 ].push_back( 18 );
    RookMoves[ 34 ][ 2 ].push_back( 10 );
    RookMoves[ 34 ][ 2 ].push_back( 2 );
    RookMoves[ 34 ][ 3 ].push_back( 42 );
    RookMoves[ 34 ][ 3 ].push_back( 50 );
    RookMoves[ 34 ][ 3 ].push_back( 58 );
    RookMoves[ 35 ].resize( 4 );
    RookMoves[ 35 ][ 0 ].push_back( 34 );
    RookMoves[ 35 ][ 0 ].push_back( 33 );
    RookMoves[ 35 ][ 0 ].push_back( 32 );
    RookMoves[ 35 ][ 1 ].push_back( 36 );
    RookMoves[ 35 ][ 1 ].push_back( 37 );
    RookMoves[ 35 ][ 1 ].push_back( 38 );
    RookMoves[ 35 ][ 1 ].push_back( 39 );
    RookMoves[ 35 ][ 2 ].push_back( 27 );
    RookMoves[ 35 ][ 2 ].push_back( 19 );
    RookMoves[ 35 ][ 2 ].push_back( 11 );
    RookMoves[ 35 ][ 2 ].push_back( 3 );
    RookMoves[ 35 ][ 3 ].push_back( 43 );
    RookMoves[ 35 ][ 3 ].push_back( 51 );
    RookMoves[ 35 ][ 3 ].push_back( 59 );
    RookMoves[ 36 ].resize( 4 );
    RookMoves[ 36 ][ 0 ].push_back( 35 );
    RookMoves[ 36 ][ 0 ].push_back( 34 );
    RookMoves[ 36 ][ 0 ].push_back( 33 );
    RookMoves[ 36 ][ 0 ].push_back( 32 );
    RookMoves[ 36 ][ 1 ].push_back( 37 );
    RookMoves[ 36 ][ 1 ].push_back( 38 );
    RookMoves[ 36 ][ 1 ].push_back( 39 );
    RookMoves[ 36 ][ 2 ].push_back( 28 );
    RookMoves[ 36 ][ 2 ].push_back( 20 );
    RookMoves[ 36 ][ 2 ].push_back( 12 );
    RookMoves[ 36 ][ 2 ].push_back( 4 );
    RookMoves[ 36 ][ 3 ].push_back( 44 );
    RookMoves[ 36 ][ 3 ].push_back( 52 );
    RookMoves[ 36 ][ 3 ].push_back( 60 );
    RookMoves[ 37 ].resize( 4 );
    RookMoves[ 37 ][ 0 ].push_back( 36 );
    RookMoves[ 37 ][ 0 ].push_back( 35 );
    RookMoves[ 37 ][ 0 ].push_back( 34 );
    RookMoves[ 37 ][ 0 ].push_back( 33 );
    RookMoves[ 37 ][ 0 ].push_back( 32 );
    RookMoves[ 37 ][ 1 ].push_back( 38 );
    RookMoves[ 37 ][ 1 ].push_back( 39 );
    RookMoves[ 37 ][ 2 ].push_back( 29 );
    RookMoves[ 37 ][ 2 ].push_back( 21 );
    RookMoves[ 37 ][ 2 ].push_back( 13 );
    RookMoves[ 37 ][ 2 ].push_back( 5 );
    RookMoves[ 37 ][ 3 ].push_back( 45 );
    RookMoves[ 37 ][ 3 ].push_back( 53 );
    RookMoves[ 37 ][ 3 ].push_back( 61 );
    RookMoves[ 38 ].resize( 4 );
    RookMoves[ 38 ][ 0 ].push_back( 37 );
    RookMoves[ 38 ][ 0 ].push_back( 36 );
    RookMoves[ 38 ][ 0 ].push_back( 35 );
    RookMoves[ 38 ][ 0 ].push_back( 34 );
    RookMoves[ 38 ][ 0 ].push_back( 33 );
    RookMoves[ 38 ][ 0 ].push_back( 32 );
    RookMoves[ 38 ][ 1 ].push_back( 39 );
    RookMoves[ 38 ][ 2 ].push_back( 30 );
    RookMoves[ 38 ][ 2 ].push_back( 22 );
    RookMoves[ 38 ][ 2 ].push_back( 14 );
    RookMoves[ 38 ][ 2 ].push_back( 6 );
    RookMoves[ 38 ][ 3 ].push_back( 46 );
    RookMoves[ 38 ][ 3 ].push_back( 54 );
    RookMoves[ 38 ][ 3 ].push_back( 62 );
    RookMoves[ 39 ].resize( 3 );
    RookMoves[ 39 ][ 0 ].push_back( 38 );
    RookMoves[ 39 ][ 0 ].push_back( 37 );
    RookMoves[ 39 ][ 0 ].push_back( 36 );
    RookMoves[ 39 ][ 0 ].push_back( 35 );
    RookMoves[ 39 ][ 0 ].push_back( 34 );
    RookMoves[ 39 ][ 0 ].push_back( 33 );
    RookMoves[ 39 ][ 0 ].push_back( 32 );
    RookMoves[ 39 ][ 1 ].push_back( 31 );
    RookMoves[ 39 ][ 1 ].push_back( 23 );
    RookMoves[ 39 ][ 1 ].push_back( 15 );
    RookMoves[ 39 ][ 1 ].push_back( 7 );
    RookMoves[ 39 ][ 2 ].push_back( 47 );
    RookMoves[ 39 ][ 2 ].push_back( 55 );
    RookMoves[ 39 ][ 2 ].push_back( 63 );

    RookMoves[ 40 ].resize( 3 );
    RookMoves[ 40 ][ 0 ].push_back( 41 );
    RookMoves[ 40 ][ 0 ].push_back( 42 );
    RookMoves[ 40 ][ 0 ].push_back( 43 );
    RookMoves[ 40 ][ 0 ].push_back( 44 );
    RookMoves[ 40 ][ 0 ].push_back( 45 );
    RookMoves[ 40 ][ 0 ].push_back( 46 );
    RookMoves[ 40 ][ 0 ].push_back( 47 );
    RookMoves[ 40 ][ 1 ].push_back( 32 );
    RookMoves[ 40 ][ 1 ].push_back( 24 );
    RookMoves[ 40 ][ 1 ].push_back( 16 );
    RookMoves[ 40 ][ 1 ].push_back( 8 );
    RookMoves[ 40 ][ 1 ].push_back( 0 );
    RookMoves[ 40 ][ 2 ].push_back( 48 );
    RookMoves[ 40 ][ 2 ].push_back( 56 );
    RookMoves[ 41 ].resize( 4 );
    RookMoves[ 41 ][ 0 ].push_back( 40 );
    RookMoves[ 41 ][ 1 ].push_back( 42 );
    RookMoves[ 41 ][ 1 ].push_back( 43 );
    RookMoves[ 41 ][ 1 ].push_back( 44 );
    RookMoves[ 41 ][ 1 ].push_back( 45 );
    RookMoves[ 41 ][ 1 ].push_back( 46 );
    RookMoves[ 41 ][ 1 ].push_back( 47 );
    RookMoves[ 41 ][ 2 ].push_back( 33 );
    RookMoves[ 41 ][ 2 ].push_back( 25 );
    RookMoves[ 41 ][ 2 ].push_back( 17 );
    RookMoves[ 41 ][ 2 ].push_back( 9 );
    RookMoves[ 41 ][ 2 ].push_back( 1 );
    RookMoves[ 41 ][ 3 ].push_back( 49 );
    RookMoves[ 41 ][ 3 ].push_back( 57 );
    RookMoves[ 42 ].resize( 4 );
    RookMoves[ 42 ][ 0 ].push_back( 41 );
    RookMoves[ 42 ][ 0 ].push_back( 40 );
    RookMoves[ 42 ][ 1 ].push_back( 43 );
    RookMoves[ 42 ][ 1 ].push_back( 44 );
    RookMoves[ 42 ][ 1 ].push_back( 45 );
    RookMoves[ 42 ][ 1 ].push_back( 46 );
    RookMoves[ 42 ][ 1 ].push_back( 47 );
    RookMoves[ 42 ][ 2 ].push_back( 34 );
    RookMoves[ 42 ][ 2 ].push_back( 26 );
    RookMoves[ 42 ][ 2 ].push_back( 18 );
    RookMoves[ 42 ][ 2 ].push_back( 10 );
    RookMoves[ 42 ][ 2 ].push_back( 2 );
    RookMoves[ 42 ][ 3 ].push_back( 50 );
    RookMoves[ 42 ][ 3 ].push_back( 58 );
    RookMoves[ 43 ].resize( 4 );
    RookMoves[ 43 ][ 0 ].push_back( 42 );
    RookMoves[ 43 ][ 0 ].push_back( 41 );
    RookMoves[ 43 ][ 0 ].push_back( 40 );
    RookMoves[ 43 ][ 1 ].push_back( 44 );
    RookMoves[ 43 ][ 1 ].push_back( 45 );
    RookMoves[ 43 ][ 1 ].push_back( 46 );
    RookMoves[ 43 ][ 1 ].push_back( 47 );
    RookMoves[ 43 ][ 2 ].push_back( 35 );
    RookMoves[ 43 ][ 2 ].push_back( 27 );
    RookMoves[ 43 ][ 2 ].push_back( 19 );
    RookMoves[ 43 ][ 2 ].push_back( 11 );
    RookMoves[ 43 ][ 2 ].push_back( 3 );
    RookMoves[ 43 ][ 3 ].push_back( 51 );
    RookMoves[ 43 ][ 3 ].push_back( 59 );
    RookMoves[ 44 ].resize( 4 );
    RookMoves[ 44 ][ 0 ].push_back( 43 );
    RookMoves[ 44 ][ 0 ].push_back( 42 );
    RookMoves[ 44 ][ 0 ].push_back( 41 );
    RookMoves[ 44 ][ 0 ].push_back( 40 );
    RookMoves[ 44 ][ 1 ].push_back( 45 );
    RookMoves[ 44 ][ 1 ].push_back( 46 );
    RookMoves[ 44 ][ 1 ].push_back( 47 );
    RookMoves[ 44 ][ 2 ].push_back( 36 );
    RookMoves[ 44 ][ 2 ].push_back( 28 );
    RookMoves[ 44 ][ 2 ].push_back( 20 );
    RookMoves[ 44 ][ 2 ].push_back( 12 );
    RookMoves[ 44 ][ 2 ].push_back( 4 );
    RookMoves[ 44 ][ 3 ].push_back( 52 );
    RookMoves[ 44 ][ 3 ].push_back( 60 );
    RookMoves[ 45 ].resize( 4 );
    RookMoves[ 45 ][ 0 ].push_back( 44 );
    RookMoves[ 45 ][ 0 ].push_back( 43 );
    RookMoves[ 45 ][ 0 ].push_back( 42 );
    RookMoves[ 45 ][ 0 ].push_back( 41 );
    RookMoves[ 45 ][ 0 ].push_back( 40 );
    RookMoves[ 45 ][ 1 ].push_back( 46 );
    RookMoves[ 45 ][ 1 ].push_back( 47 );
    RookMoves[ 45 ][ 2 ].push_back( 37 );
    RookMoves[ 45 ][ 2 ].push_back( 29 );
    RookMoves[ 45 ][ 2 ].push_back( 21 );
    RookMoves[ 45 ][ 2 ].push_back( 13 );
    RookMoves[ 45 ][ 2 ].push_back( 5 );
    RookMoves[ 45 ][ 3 ].push_back( 53 );
    RookMoves[ 45 ][ 3 ].push_back( 61 );
    RookMoves[ 46 ].resize( 4 );
    RookMoves[ 46 ][ 0 ].push_back( 45 );
    RookMoves[ 46 ][ 0 ].push_back( 44 );
    RookMoves[ 46 ][ 0 ].push_back( 43 );
    RookMoves[ 46 ][ 0 ].push_back( 42 );
    RookMoves[ 46 ][ 0 ].push_back( 41 );
    RookMoves[ 46 ][ 0 ].push_back( 40 );
    RookMoves[ 46 ][ 1 ].push_back( 47 );
    RookMoves[ 46 ][ 2 ].push_back( 38 );
    RookMoves[ 46 ][ 2 ].push_back( 30 );
    RookMoves[ 46 ][ 2 ].push_back( 22 );
    RookMoves[ 46 ][ 2 ].push_back( 14 );
    RookMoves[ 46 ][ 2 ].push_back( 6 );
    RookMoves[ 46 ][ 3 ].push_back( 54 );
    RookMoves[ 46 ][ 3 ].push_back( 62 );
    RookMoves[ 47 ].resize( 3 );
    RookMoves[ 47 ][ 0 ].push_back( 46 );
    RookMoves[ 47 ][ 0 ].push_back( 45 );
    RookMoves[ 47 ][ 0 ].push_back( 44 );
    RookMoves[ 47 ][ 0 ].push_back( 43 );
    RookMoves[ 47 ][ 0 ].push_back( 42 );
    RookMoves[ 47 ][ 0 ].push_back( 41 );
    RookMoves[ 47 ][ 0 ].push_back( 40 );
    RookMoves[ 47 ][ 1 ].push_back( 39 );
    RookMoves[ 47 ][ 1 ].push_back( 31 );
    RookMoves[ 47 ][ 1 ].push_back( 23 );
    RookMoves[ 47 ][ 1 ].push_back( 15 );
    RookMoves[ 47 ][ 1 ].push_back( 7 );
    RookMoves[ 47 ][ 2 ].push_back( 55 );
    RookMoves[ 47 ][ 2 ].push_back( 63 );

    RookMoves[ 48 ].resize( 3 );
    RookMoves[ 48 ][ 0 ].push_back( 49 );
    RookMoves[ 48 ][ 0 ].push_back( 50 );
    RookMoves[ 48 ][ 0 ].push_back( 51 );
    RookMoves[ 48 ][ 0 ].push_back( 52 );
    RookMoves[ 48 ][ 0 ].push_back( 53 );
    RookMoves[ 48 ][ 0 ].push_back( 54 );
    RookMoves[ 48 ][ 0 ].push_back( 55 );
    RookMoves[ 48 ][ 1 ].push_back( 40 );
    RookMoves[ 48 ][ 1 ].push_back( 32 );
    RookMoves[ 48 ][ 1 ].push_back( 24 );
    RookMoves[ 48 ][ 1 ].push_back( 16 );
    RookMoves[ 48 ][ 1 ].push_back( 8 );
    RookMoves[ 48 ][ 1 ].push_back( 0 );
    RookMoves[ 48 ][ 2 ].push_back( 56 );
    RookMoves[ 49 ].resize( 4 );
    RookMoves[ 49 ][ 0 ].push_back( 48 );
    RookMoves[ 49 ][ 1 ].push_back( 50 );
    RookMoves[ 49 ][ 1 ].push_back( 51 );
    RookMoves[ 49 ][ 1 ].push_back( 52 );
    RookMoves[ 49 ][ 1 ].push_back( 53 );
    RookMoves[ 49 ][ 1 ].push_back( 54 );
    RookMoves[ 49 ][ 1 ].push_back( 55 );
    RookMoves[ 49 ][ 2 ].push_back( 41 );
    RookMoves[ 49 ][ 2 ].push_back( 33 );
    RookMoves[ 49 ][ 2 ].push_back( 25 );
    RookMoves[ 49 ][ 2 ].push_back( 17 );
    RookMoves[ 49 ][ 2 ].push_back( 9 );
    RookMoves[ 49 ][ 2 ].push_back( 1 );
    RookMoves[ 49 ][ 3 ].push_back( 57 );
    RookMoves[ 50 ].resize( 4 );
    RookMoves[ 50 ][ 0 ].push_back( 49 );
    RookMoves[ 50 ][ 0 ].push_back( 48 );
    RookMoves[ 50 ][ 1 ].push_back( 51 );
    RookMoves[ 50 ][ 1 ].push_back( 52 );
    RookMoves[ 50 ][ 1 ].push_back( 53 );
    RookMoves[ 50 ][ 1 ].push_back( 54 );
    RookMoves[ 50 ][ 1 ].push_back( 55 );
    RookMoves[ 50 ][ 2 ].push_back( 42 );
    RookMoves[ 50 ][ 2 ].push_back( 34 );
    RookMoves[ 50 ][ 2 ].push_back( 26 );
    RookMoves[ 50 ][ 2 ].push_back( 18 );
    RookMoves[ 50 ][ 2 ].push_back( 10 );
    RookMoves[ 50 ][ 2 ].push_back( 2 );
    RookMoves[ 50 ][ 3 ].push_back( 58 );
    RookMoves[ 51 ].resize( 4 );
    RookMoves[ 51 ][ 0 ].push_back( 50 );
    RookMoves[ 51 ][ 0 ].push_back( 49 );
    RookMoves[ 51 ][ 0 ].push_back( 48 );
    RookMoves[ 51 ][ 1 ].push_back( 52 );
    RookMoves[ 51 ][ 1 ].push_back( 53 );
    RookMoves[ 51 ][ 1 ].push_back( 54 );
    RookMoves[ 51 ][ 1 ].push_back( 55 );
    RookMoves[ 51 ][ 2 ].push_back( 43 );
    RookMoves[ 51 ][ 2 ].push_back( 35 );
    RookMoves[ 51 ][ 2 ].push_back( 27 );
    RookMoves[ 51 ][ 2 ].push_back( 19 );
    RookMoves[ 51 ][ 2 ].push_back( 11 );
    RookMoves[ 51 ][ 2 ].push_back( 3 );
    RookMoves[ 51 ][ 3 ].push_back( 59 );
    RookMoves[ 52 ].resize( 4 );
    RookMoves[ 52 ][ 0 ].push_back( 51 );
    RookMoves[ 52 ][ 0 ].push_back( 50 );
    RookMoves[ 52 ][ 0 ].push_back( 49 );
    RookMoves[ 52 ][ 0 ].push_back( 48 );
    RookMoves[ 52 ][ 1 ].push_back( 53 );
    RookMoves[ 52 ][ 1 ].push_back( 54 );
    RookMoves[ 52 ][ 1 ].push_back( 55 );
    RookMoves[ 52 ][ 2 ].push_back( 44 );
    RookMoves[ 52 ][ 2 ].push_back( 36 );
    RookMoves[ 52 ][ 2 ].push_back( 28 );
    RookMoves[ 52 ][ 2 ].push_back( 20 );
    RookMoves[ 52 ][ 2 ].push_back( 12 );
    RookMoves[ 52 ][ 2 ].push_back( 4 );
    RookMoves[ 52 ][ 3 ].push_back( 60 );
    RookMoves[ 53 ].resize( 4 );
    RookMoves[ 53 ][ 0 ].push_back( 52 );
    RookMoves[ 53 ][ 0 ].push_back( 51 );
    RookMoves[ 53 ][ 0 ].push_back( 50 );
    RookMoves[ 53 ][ 0 ].push_back( 49 );
    RookMoves[ 53 ][ 0 ].push_back( 48 );
    RookMoves[ 53 ][ 1 ].push_back( 54 );
    RookMoves[ 53 ][ 1 ].push_back( 55 );
    RookMoves[ 53 ][ 2 ].push_back( 45 );
    RookMoves[ 53 ][ 2 ].push_back( 37 );
    RookMoves[ 53 ][ 2 ].push_back( 29 );
    RookMoves[ 53 ][ 2 ].push_back( 21 );
    RookMoves[ 53 ][ 2 ].push_back( 13 );
    RookMoves[ 53 ][ 2 ].push_back( 5 );
    RookMoves[ 53 ][ 3 ].push_back( 61 );
    RookMoves[ 54 ].resize( 4 );
    RookMoves[ 54 ][ 0 ].push_back( 53 );
    RookMoves[ 54 ][ 0 ].push_back( 52 );
    RookMoves[ 54 ][ 0 ].push_back( 51 );
    RookMoves[ 54 ][ 0 ].push_back( 50 );
    RookMoves[ 54 ][ 0 ].push_back( 49 );
    RookMoves[ 54 ][ 0 ].push_back( 48 );
    RookMoves[ 54 ][ 1 ].push_back( 55 );
    RookMoves[ 54 ][ 2 ].push_back( 46 );
    RookMoves[ 54 ][ 2 ].push_back( 38 );
    RookMoves[ 54 ][ 2 ].push_back( 30 );
    RookMoves[ 54 ][ 2 ].push_back( 22 );
    RookMoves[ 54 ][ 2 ].push_back( 14 );
    RookMoves[ 54 ][ 2 ].push_back( 6 );
    RookMoves[ 54 ][ 3 ].push_back( 62 );
    RookMoves[ 55 ].resize( 3 );
    RookMoves[ 55 ][ 0 ].push_back( 54 );
    RookMoves[ 55 ][ 0 ].push_back( 53 );
    RookMoves[ 55 ][ 0 ].push_back( 52 );
    RookMoves[ 55 ][ 0 ].push_back( 51 );
    RookMoves[ 55 ][ 0 ].push_back( 50 );
    RookMoves[ 55 ][ 0 ].push_back( 49 );
    RookMoves[ 55 ][ 0 ].push_back( 48 );
    RookMoves[ 55 ][ 1 ].push_back( 47 );
    RookMoves[ 55 ][ 1 ].push_back( 39 );
    RookMoves[ 55 ][ 1 ].push_back( 31 );
    RookMoves[ 55 ][ 1 ].push_back( 23 );
    RookMoves[ 55 ][ 1 ].push_back( 15 );
    RookMoves[ 55 ][ 1 ].push_back( 7 );
    RookMoves[ 55 ][ 2 ].push_back( 63 );

    RookMoves[ 56 ].resize( 2 );
    RookMoves[ 56 ][ 0 ].push_back( 57 );
    RookMoves[ 56 ][ 0 ].push_back( 58 );
    RookMoves[ 56 ][ 0 ].push_back( 59 );
    RookMoves[ 56 ][ 0 ].push_back( 60 );
    RookMoves[ 56 ][ 0 ].push_back( 61 );
    RookMoves[ 56 ][ 0 ].push_back( 62 );
    RookMoves[ 56 ][ 0 ].push_back( 63 );
    RookMoves[ 56 ][ 1 ].push_back( 48 );
    RookMoves[ 56 ][ 1 ].push_back( 40 );
    RookMoves[ 56 ][ 1 ].push_back( 32 );
    RookMoves[ 56 ][ 1 ].push_back( 24 );
    RookMoves[ 56 ][ 1 ].push_back( 16 );
    RookMoves[ 56 ][ 1 ].push_back( 8 );
    RookMoves[ 56 ][ 1 ].push_back( 0 );
    RookMoves[ 57 ].resize( 3 );
    RookMoves[ 57 ][ 0 ].push_back( 56 );
    RookMoves[ 57 ][ 1 ].push_back( 58 );
    RookMoves[ 57 ][ 1 ].push_back( 59 );
    RookMoves[ 57 ][ 1 ].push_back( 60 );
    RookMoves[ 57 ][ 1 ].push_back( 61 );
    RookMoves[ 57 ][ 1 ].push_back( 62 );
    RookMoves[ 57 ][ 1 ].push_back( 63 );
    RookMoves[ 57 ][ 2 ].push_back( 49 );
    RookMoves[ 57 ][ 2 ].push_back( 41 );
    RookMoves[ 57 ][ 2 ].push_back( 33 );
    RookMoves[ 57 ][ 2 ].push_back( 25 );
    RookMoves[ 57 ][ 2 ].push_back( 17 );
    RookMoves[ 57 ][ 2 ].push_back( 9 );
    RookMoves[ 57 ][ 2 ].push_back( 1 );
    RookMoves[ 58 ].resize( 3 );
    RookMoves[ 58 ][ 0 ].push_back( 57 );
    RookMoves[ 58 ][ 0 ].push_back( 56 );
    RookMoves[ 58 ][ 1 ].push_back( 59 );
    RookMoves[ 58 ][ 1 ].push_back( 60 );
    RookMoves[ 58 ][ 1 ].push_back( 61 );
    RookMoves[ 58 ][ 1 ].push_back( 62 );
    RookMoves[ 58 ][ 1 ].push_back( 63 );
    RookMoves[ 58 ][ 2 ].push_back( 50 );
    RookMoves[ 58 ][ 2 ].push_back( 42 );
    RookMoves[ 58 ][ 2 ].push_back( 34 );
    RookMoves[ 58 ][ 2 ].push_back( 26 );
    RookMoves[ 58 ][ 2 ].push_back( 18 );
    RookMoves[ 58 ][ 2 ].push_back( 10 );
    RookMoves[ 58 ][ 2 ].push_back( 2 );
    RookMoves[ 59 ].resize( 3 );
    RookMoves[ 59 ][ 0 ].push_back( 58 );
    RookMoves[ 59 ][ 0 ].push_back( 57 );
    RookMoves[ 59 ][ 0 ].push_back( 56 );
    RookMoves[ 59 ][ 1 ].push_back( 60 );
    RookMoves[ 59 ][ 1 ].push_back( 61 );
    RookMoves[ 59 ][ 1 ].push_back( 62 );
    RookMoves[ 59 ][ 1 ].push_back( 63 );
    RookMoves[ 59 ][ 2 ].push_back( 51 );
    RookMoves[ 59 ][ 2 ].push_back( 43 );
    RookMoves[ 59 ][ 2 ].push_back( 35 );
    RookMoves[ 59 ][ 2 ].push_back( 27 );
    RookMoves[ 59 ][ 2 ].push_back( 19 );
    RookMoves[ 59 ][ 2 ].push_back( 11 );
    RookMoves[ 59 ][ 2 ].push_back( 3 );
    RookMoves[ 60 ].resize( 3 );
    RookMoves[ 60 ][ 0 ].push_back( 59 );
    RookMoves[ 60 ][ 0 ].push_back( 58 );
    RookMoves[ 60 ][ 0 ].push_back( 57 );
    RookMoves[ 60 ][ 0 ].push_back( 56 );
    RookMoves[ 60 ][ 1 ].push_back( 61 );
    RookMoves[ 60 ][ 1 ].push_back( 62 );
    RookMoves[ 60 ][ 1 ].push_back( 63 );
    RookMoves[ 60 ][ 2 ].push_back( 52 );
    RookMoves[ 60 ][ 2 ].push_back( 44 );
    RookMoves[ 60 ][ 2 ].push_back( 36 );
    RookMoves[ 60 ][ 2 ].push_back( 28 );
    RookMoves[ 60 ][ 2 ].push_back( 20 );
    RookMoves[ 60 ][ 2 ].push_back( 12 );
    RookMoves[ 60 ][ 2 ].push_back( 4 );
    RookMoves[ 61 ].resize( 3 );
    RookMoves[ 61 ][ 0 ].push_back( 60 );
    RookMoves[ 61 ][ 0 ].push_back( 59 );
    RookMoves[ 61 ][ 0 ].push_back( 58 );
    RookMoves[ 61 ][ 0 ].push_back( 57 );
    RookMoves[ 61 ][ 0 ].push_back( 56 );
    RookMoves[ 61 ][ 1 ].push_back( 62 );
    RookMoves[ 61 ][ 1 ].push_back( 63 );
    RookMoves[ 61 ][ 2 ].push_back( 53 );
    RookMoves[ 61 ][ 2 ].push_back( 45 );
    RookMoves[ 61 ][ 2 ].push_back( 37 );
    RookMoves[ 61 ][ 2 ].push_back( 29 );
    RookMoves[ 61 ][ 2 ].push_back( 21 );
    RookMoves[ 61 ][ 2 ].push_back( 13 );
    RookMoves[ 61 ][ 2 ].push_back( 5 );
    RookMoves[ 62 ].resize( 3 );
    RookMoves[ 62 ][ 0 ].push_back( 61 );
    RookMoves[ 62 ][ 0 ].push_back( 60 );
    RookMoves[ 62 ][ 0 ].push_back( 59 );
    RookMoves[ 62 ][ 0 ].push_back( 58 );
    RookMoves[ 62 ][ 0 ].push_back( 57 );
    RookMoves[ 62 ][ 0 ].push_back( 56 );
    RookMoves[ 62 ][ 1 ].push_back( 63 );
    RookMoves[ 62 ][ 2 ].push_back( 54 );
    RookMoves[ 62 ][ 2 ].push_back( 46 );
    RookMoves[ 62 ][ 2 ].push_back( 38 );
    RookMoves[ 62 ][ 2 ].push_back( 30 );
    RookMoves[ 62 ][ 2 ].push_back( 22 );
    RookMoves[ 62 ][ 2 ].push_back( 14 );
    RookMoves[ 62 ][ 2 ].push_back( 6 );
    RookMoves[ 63 ].resize( 2 );
    RookMoves[ 63 ][ 0 ].push_back( 62 );
    RookMoves[ 63 ][ 0 ].push_back( 61 );
    RookMoves[ 63 ][ 0 ].push_back( 60 );
    RookMoves[ 63 ][ 0 ].push_back( 59 );
    RookMoves[ 63 ][ 0 ].push_back( 58 );
    RookMoves[ 63 ][ 0 ].push_back( 57 );
    RookMoves[ 63 ][ 0 ].push_back( 56 );
    RookMoves[ 63 ][ 1 ].push_back( 55 );
    RookMoves[ 63 ][ 1 ].push_back( 47 );
    RookMoves[ 63 ][ 1 ].push_back( 39 );
    RookMoves[ 63 ][ 1 ].push_back( 31 );
    RookMoves[ 63 ][ 1 ].push_back( 23 );
    RookMoves[ 63 ][ 1 ].push_back( 15 );
    RookMoves[ 63 ][ 1 ].push_back( 7 );
}



void MoveListGenerator::DeleteStatics()
{
	// KnightMoves, KingMoves, RookMoves, BishopMoves mustn't to be cleaned up, 
	// because so does the destructor of STL's vector
}



void MoveListGenerator::ResetIterator()
{
	// Set to 1st element of the vector
	MovesIt = Moves.begin();
}



bool MoveListGenerator::Find( Move *mov )
{
    assert ( mov != NULL );
	
	for( MovesIt = Moves.begin(); MovesIt != Moves.end(); MovesIt++ ) 
		if ( mov->Equals( &(*MovesIt) ) )
			return true;
	
    return false;
}



Move *MoveListGenerator::FindMoveForSquares( int source, int dest )
{
    for( MovesIt = Moves.begin(); MovesIt != Moves.end(); MovesIt++ )
		if ( ( MovesIt->SourceSquare == source ) && ( MovesIt->DestinationSquare == dest ) )
			return &(*MovesIt);
    return NULL;
}




Move *MoveListGenerator::Next()
{
	if ( MovesIt != Moves.end() )
		return &(*MovesIt++);
   
	return NULL;
}




bool MoveListGenerator::ComputeLegalMoves( Board *theBoard )
{
	assert( theBoard != NULL );
	
	// First, clean up the old list of moves, if any
    Moves.erase( Moves.begin(), Moves.end() );

	assert( Moves.size() == 0 );

    // Now, compute the moves, one piece type at a time
    if ( theBoard->GetCurrentPlayer() == Player::SIDE_WHITE ) {
		// Clean up the data structures indicating that the last white move
		// was a castling, if any
		if ( theBoard->GetExtraKings( Player::SIDE_WHITE ) != 0 )
			theBoard->ClearExtraKings( Player::SIDE_WHITE );
		// Check for white moves, one piece type at a time
		// if any one type can capture the king, stop the work immediately
		// because the board position is illegal
		if ( !ComputeWhiteQueenMoves( theBoard ) ) return false;
		if ( !ComputeWhiteKingMoves( theBoard ) ) return false;
		if ( !ComputeWhiteRookMoves( theBoard, Board::WHITE_ROOK ) ) return false;
		if ( !ComputeWhiteBishopMoves( theBoard, Board::WHITE_BISHOP ) ) return false;
		if ( !ComputeWhiteKnightMoves( theBoard ) ) return false;
		if ( !ComputeWhitePawnMoves( theBoard ) ) return false;
    } else {
		// Compute Black's moves
		if ( theBoard->GetExtraKings( Player::SIDE_BLACK ) != 0 )
			theBoard->ClearExtraKings( Player::SIDE_BLACK );
		if ( !ComputeBlackQueenMoves( theBoard ) ) return false;
		if ( !ComputeBlackKingMoves( theBoard ) ) return false;
		if ( !ComputeBlackRookMoves( theBoard, Board::BLACK_ROOK ) ) return false;
		if ( !ComputeBlackBishopMoves( theBoard, Board::BLACK_BISHOP ) ) return false;
		if ( !ComputeBlackKnightMoves( theBoard ) ) return false;
		if ( !ComputeBlackPawnMoves( theBoard ) ) return false;
    }
		
	// if we captured the king this move is illegal, because
	// the move before left the king in check!
	for ( vector<Move>::iterator j = Moves.begin(); j != Moves.end() ; j++ ) {
		if ( ( j->CapturedPiece == Board::WHITE_KING ) || 
				( j->CapturedPiece == Board::BLACK_KING ) )
				return false;
	}
			
	// And finally, if there are no pseudo-legal moves at all, we have an
    // obvious error ( there are no pieces on the board! ); flag the condition
    if ( Moves.size() == 0 )
		return false;
    else {
		MovesIt = Moves.begin();
		return true;
    }
}

bool MoveListGenerator::isAttacking( Board* theBoard, int sourceField, int destField ) {
	ComputeLegalMoves( theBoard );
	return ( FindMoveForSquares( sourceField, destField ) != NULL );  
}


bool MoveListGenerator::ComputeQuiescenceMoves( Board *theBoard )
{
	assert( theBoard != NULL );
	
	// First, clean up the old list of moves, if any
    Moves.erase( Moves.begin(), Moves.end() );

	assert( Moves.size() == 0 );

    // Now, compute the moves, one piece type at a time
    if ( theBoard->GetCurrentPlayer() == Player::SIDE_WHITE ) {
		// Clean up the data structures indicating that the last white move
		// was a castling, if any
		if ( theBoard->GetExtraKings( Player::SIDE_WHITE ) != 0 )
			theBoard->ClearExtraKings( Player::SIDE_WHITE );
		// Check for white moves, one piece type at a time
		// if any one type can capture the king, stop the work immediately
		// because the board position is illegal
		if ( !ComputeWhiteQuiescenceQueenMoves( theBoard ) ) return false;
		if ( !ComputeWhiteQuiescenceKingMoves( theBoard ) ) return false;
		if ( !ComputeWhiteQuiescenceRookMoves( theBoard, Board::WHITE_ROOK ) ) return false;
		if ( !ComputeWhiteQuiescenceBishopMoves( theBoard, Board::WHITE_BISHOP ) ) return false;
		if ( !ComputeWhiteQuiescenceKnightMoves( theBoard ) ) return false;
		if ( !ComputeWhiteQuiescencePawnMoves( theBoard ) ) return false;
    } else {
		// Compute Black's moves
		if ( theBoard->GetExtraKings( Player::SIDE_BLACK ) != 0 )
			theBoard->ClearExtraKings( Player::SIDE_BLACK );
		if ( !ComputeBlackQuiescenceQueenMoves( theBoard ) ) return false;
		if ( !ComputeBlackQuiescenceKingMoves( theBoard ) ) return false;
		if ( !ComputeBlackQuiescenceRookMoves( theBoard, Board::BLACK_ROOK ) ) return false;
		if ( !ComputeBlackQuiescenceBishopMoves( theBoard, Board::BLACK_BISHOP ) ) return false;
		if ( !ComputeBlackQuiescenceKnightMoves( theBoard ) ) return false;
		if ( !ComputeBlackQuiescencePawnMoves( theBoard ) ) return false;
    }
		
	// if we captured the king this move is illegal, because
	// the move before left the king in check!
	for ( vector<Move>::iterator j = Moves.begin(); j != Moves.end() ; j++ ) {
		if ( ( j->CapturedPiece == Board::WHITE_KING ) || 
				( j->CapturedPiece == Board::BLACK_KING ) )
				return false;
	}
			
	// And finally, if there are no pseudo-legal moves at all, we have an
    // obvious error ( there are no pieces on the board! ); flag the condition
    if ( Moves.size() == 0 )
		return false;
    else {
		MovesIt = Moves.begin();
		return true;
    }


// old and slow version:
/*
	//    assert( theBoard != NULL );

	if ( theBoard != NULL )
		ComputeLegalMoves( theBoard );
		else
		Moves.erase( Moves.begin(), Moves.end() );

	ResetIterator();

	while(  MovesIt != Moves.end() ) {
		if ( ( MovesIt->MoveType != Move::MOVE_CAPTURE_ORDINARY ) &&
			 ( MovesIt->MoveType != Move::MOVE_CAPTURE_EN_PASSANT ) &&
			 ( MovesIt != Moves.end() ) )
			MovesIt = Moves.erase( MovesIt ); // erase() automatically increases the iterator
			else
			MovesIt++;
    }

	ResetIterator();

	return( Moves.size() > 0 );
*/
}



void MoveListGenerator::Print()
{
    vector<Move>::iterator myMoveIt;

    for( myMoveIt = Moves.begin(); myMoveIt != Moves.end(); myMoveIt++ )
		myMoveIt->Print();
}




bool MoveListGenerator::ComputeWhiteQueenMoves( Board *theBoard )
{
	assert( theBoard != NULL );
	
	if ( !ComputeWhiteBishopMoves( theBoard, Board::WHITE_QUEEN ) ) return false;
	if ( !ComputeWhiteRookMoves  ( theBoard, Board::WHITE_QUEEN ) ) return false;
  
	return true;
}




bool MoveListGenerator::ComputeWhiteKingMoves( Board *theBoard )
{
	assert( theBoard != NULL );

	// Fetch the bitboard containing position of the king
	__int64 pieces = theBoard->GetBitBoard( Board::WHITE_KING );

	// Find it!  There is only one king, so look for it and stop
	int square;
	for( square = 0; square < 64; square++ ) {
		if ( ( Board::SquareBits[ square ] & pieces ) != 0i64 )
			break;
	}

	// Maybe there's no king left. That happens if we made
	// an illegal move with the king where he will be captured.
	// This failure will be handeled here!
	if ( square == 64 )
		return false;
	
	// Find its moves
	for( int i = 0; i < KingMoves[ square ].size(); i++ ) {
		// Get the destination square
		int dest = KingMoves[ square ][ i ];

		// Is it occupied by a friendly piece?  If so, can't move there
		if ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) 
			                        & Board::SquareBits[ dest ] ) != 0i64 )
			continue;

		// Otherwise, the move is legal, so we must prepare to add it
		Move mov;
		mov.SourceSquare = square;
		mov.DestinationSquare = dest;
		mov.MovingPiece = Board::WHITE_KING;

		// Is the destination occupied by an enemy?  If so, we have a capture
		if ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
			                        & Board::SquareBits[ dest ] ) != 0i64 ) {
			mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
			mov.CapturedPiece = theBoard->FindBlackPiece( dest );

			// If the piece we find is a king, abort because the board
			// position is illegal!
		if ( mov.CapturedPiece == Board::BLACK_KING )
			return false;
		} else { // otherwise, it is a simple move
			mov.MoveType = Move::MOVE_NORMAL;
			mov.CapturedPiece = Board::EMPTY_SQUARE;
		}

		// And we add the move to the list
		Moves.push_back( mov );

	}

	// Now, let's consider castling...
	// Kingside first
	if ( theBoard->GetCastlingStatus( Board::CASTLE_KINGSIDE + Player::SIDE_WHITE ) ) {
		// First, check whether there are empty squares between king and rook
		if ( ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) 
			                          & Board::EMPTYSQUARES_WHITE_KINGSIDE ) == 0i64 ) &&
			 ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
			                          & Board::EMPTYSQUARES_WHITE_KINGSIDE ) == 0i64 ) ) {
			Move mov;
			mov.MovingPiece = Board::WHITE_KING;
			mov.SourceSquare = 60;
			mov.DestinationSquare = 62;
			mov.MoveType = Move::MOVE_CASTLING_KINGSIDE;
			mov.CapturedPiece = Board::EMPTY_SQUARE;
			Moves.push_back( mov );
		}
	}
	if ( theBoard->GetCastlingStatus( Board::CASTLE_QUEENSIDE + Player::SIDE_WHITE ) ) {
		if ( ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) 
			                          & Board::EMPTYSQUARES_WHITE_QUEENSIDE ) == 0i64 ) &&
			 ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
			                          & Board::EMPTYSQUARES_WHITE_QUEENSIDE ) == 0i64 ) ) {
			Move mov;
			mov.MovingPiece = Board::WHITE_KING;
			mov.SourceSquare = 60;
			mov.DestinationSquare = 58;
			mov.MoveType = Move::MOVE_CASTLING_QUEENSIDE;
			mov.CapturedPiece = Board::EMPTY_SQUARE;
			Moves.push_back( mov );
		}
	}
	return true;
}




bool MoveListGenerator::ComputeWhiteRookMoves( Board *theBoard, int pieceType )
{
     // Fetch the bitboard containing positions of these pieces
     __int64 pieces = theBoard->GetBitBoard( pieceType );

     // If there are no pieces of this type, no need to work very hard!
     if ( pieces == 0i64 )
		return true;

     // This is a white piece, so let's start looking at the bottom
     // of the board
     for( int square = 63; square >= 0; square-- ) {
		if ( ( pieces & Board::SquareBits[ square ] ) != 0i64 ) {
			// There is a piece here; find its moves
			for( int ray = 0; ray < RookMoves[ square ].size(); ray++ ) {
				for( int i = 0; i < RookMoves[ square ][ ray ].size(); i++ ) {
					// Get the destination square
					int dest = RookMoves[ square ][ ray ][ i ];

					// Is it occupied by a friendly piece?  If so, can't move there
					// AND we must discontinue the current ray
					if ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) 
						                        & Board::SquareBits[ dest ] ) != 0i64 )
						break;

					// Otherwise, the move is legal, so we must prepare to add it
					Move mov;
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = pieceType;

					// Is the destination occupied by an enemy?  If so, we have a capture
					if ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
						                        & Board::SquareBits[ dest ] ) != 0i64 ) {
						mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
						mov.CapturedPiece = theBoard->FindBlackPiece( dest );

						// If the piece we find is a king, abort because the board
						// position is illegal!
						if ( mov.CapturedPiece == Board::BLACK_KING ) 
							return false;

						Moves.push_back( mov );
						break;
					} else {  // otherwise, it is a simple move
            
						mov.MoveType = Move::MOVE_NORMAL;
						mov.CapturedPiece = Board::EMPTY_SQUARE;
						Moves.push_back( mov );
					}
				}
			}
			// Turn off the bit in the temporary bitboard; this way, we can
			// detect whether we have found the last of this type of piece
			// and short-circuit the loop
			pieces ^= Board::SquareBits[ square ];
			if ( pieces == 0i64 )
				return true;
		 }
    }

    // We should never get here, but the return statement is added to prevent
    // obnoxious compiler warnings
	return true;
}



bool MoveListGenerator::ComputeWhiteBishopMoves( Board *theBoard, int pieceType )
{
    // Fetch the bitboard containing positions of these pieces
    __int64 pieces = theBoard->GetBitBoard( pieceType );

    // If there are no pieces of this type, no need to work very hard!
	if ( pieces == 0i64 )
		return true;

    // This is a white piece, so let's start looking at the bottom
    // of the board
    for( int square = 63; square >= 0; square-- ) {
		if ( ( pieces & Board::SquareBits[ square ] ) != 0i64 ) {
			// There is a piece here; find its moves
			for( int ray = 0; ray < BishopMoves[ square ].size(); ray++ ) {
				for( int i = 0; i < BishopMoves[ square ][ ray ].size(); i++ ) {
					// Get the destination square
					int dest = BishopMoves[ square ][ ray ][ i ];

					// Is it occupied by a friendly piece?  If so, can't move there
					// AND we must discontinue the current ray
					if ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) 
						                        & Board::SquareBits[ dest ] ) != 0i64 )
						break;

					// Otherwise, the move is legal, so we must prepare to add it
					Move mov;
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = pieceType;

					// Is the destination occupied by an enemy?  If so, we have a capture
					if ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
						                        & Board::SquareBits[ dest ] ) != 0i64 ) {
						mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
						mov.CapturedPiece = theBoard->FindBlackPiece( dest );

						// If the piece we find is a king, abort because the board
						// position is illegal!
						if ( mov.CapturedPiece == Board::BLACK_KING ) 
							return false;

						Moves.push_back( mov );
						break;
					} else { // otherwise, it is a simple move
						mov.MoveType = Move::MOVE_NORMAL;
						mov.CapturedPiece = Board::EMPTY_SQUARE;
						Moves.push_back( mov );
					}
				}
			}
			// Turn off the bit in the temporary bitboard; this way, we can
			// detect whether we have found the last of this type of piece
			// and short-circuit the loop
			pieces ^= Board::SquareBits[ square ];
			if ( pieces == 0i64 )
				return true;
		}
	}

    // We should never get here, but the return statement is added to prevent
    // obnoxious compiler warnings
    return true;
}



bool MoveListGenerator::ComputeWhiteKnightMoves( Board *theBoard )
{
     // Fetch the bitboard containing positions of these pieces
     __int64 pieces = theBoard->GetBitBoard( Board::WHITE_KNIGHT );

     // If there are no pieces of this type, no need to work very hard!
     if ( pieces == 0i64 )
		return true;

     // This is a white piece, so let's start looking at the bottom
     // of the board
     for( int square = 63; square >= 0; square-- ) {
		if ( ( pieces & Board::SquareBits[ square ] ) != 0 ) {
			// There is a piece here; find its moves
			for( int i = 0; i < KnightMoves[ square ].size(); i++ ) {
				// Get the destination square
				int dest = KnightMoves[ square ][ i ];

				// Is it occupied by a friendly piece?  If so, can't move there
				if ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) 
					                        & Board::SquareBits[ dest ] ) != 0i64 )
					continue;

				// Otherwise, the move is legal, so we must prepare to add it
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::WHITE_KNIGHT;

				// Is the destination occupied by an enemy?  If so, we have a capture
				if ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
					                        & Board::SquareBits[ dest ] ) != 0i64 ) {
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );

					// If the piece we find is a king, abort because the board
					// position is illegal!
					if ( mov.CapturedPiece == Board::BLACK_KING ) {
						return false;
					}
				} else { // otherwise, it is a simple move
					mov.MoveType = Move::MOVE_NORMAL;
					mov.CapturedPiece = Board::EMPTY_SQUARE;
				}

				// And we add the move to the list
				Moves.push_back( mov );
			}

			// Turn off the bit in the temporary bitboard; this way, we can
			// detect whether we have found the last of this type of piece
			// and short-circuit the loop
			pieces ^= Board::SquareBits[ square ];
			if ( pieces == 0i64 )
				return true;
		}
	}

    // We should never get here, but the return statement is added to prevent
    // obnoxious compiler warnings
    return true;
}



bool MoveListGenerator::ComputeWhitePawnMoves( Board *theBoard )
{
	// Fetch the bitboard containing positions of these pieces
    __int64 pieces = theBoard->GetBitBoard( Board::WHITE_PAWN );

    // If there are no pieces of this type, no need to work very hard!
    if ( pieces == 0i64 )
		return true;

    // a small optimization
    __int64 allPieces = theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) |
                        theBoard->GetBitBoard( Board::ALL_WHITE_PIECES );

    // This is a white piece, so let's start looking at the bottom
    // of the Board::.. But only consider positions where a pawn can
    // actually dwell!
    int dest;
    for( int square = 55; square >= 8; square-- ) {
		if ( ( pieces & Board::SquareBits[ square ] ) == 0i64 )
			continue;

		// First, try a normal pawn pushing
		dest = square - 8;
		if ( ( allPieces & Board::SquareBits[ dest ] ) == 0i64 ) {
			// Unless this push results in a promotion...
			if ( square > 15 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::WHITE_PAWN;
				mov.MoveType = Move::MOVE_NORMAL;
				Moves.push_back( mov );

				// Is there a chance to perform a double push? Only if the piece
				// is in its original square
				if ( square >= 48 ) {
					dest -= 8;
					if ( ( allPieces & Board::SquareBits[ dest ] ) == 0i64 ) {
						mov.SourceSquare = square;
						mov.DestinationSquare = dest;
						mov.MovingPiece = Board::WHITE_PAWN;
						mov.MoveType = Move::MOVE_NORMAL;
						Moves.push_back( mov );
					}
				}
			} else { 
				// if square < 16
				// We are now looking at pawn promotion!
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::WHITE_PAWN;
				mov.MoveType = Move::MOVE_PROMOTION_QUEEN + Move::MOVE_NORMAL;
				Moves.push_back( mov );
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::WHITE_PAWN;
				mov.MoveType = Move::MOVE_PROMOTION_KNIGHT + Move::MOVE_NORMAL;
				Moves.push_back( mov );
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::WHITE_PAWN;
				mov.MoveType = Move::MOVE_PROMOTION_ROOK + Move::MOVE_NORMAL;
				Moves.push_back( mov );
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::WHITE_PAWN;
				mov.MoveType = Move::MOVE_PROMOTION_BISHOP + Move::MOVE_NORMAL;
				Moves.push_back( mov );
			}
		}

		// Now, let's try a capture
		// Three cases: the pawn is on the 1st file, the 8th file, or elsewhere
		if ( ( square % 8 ) == 0 ) {
			dest = square - 7;
			// Try an ordinary capture first
			if ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
				                        & Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::WHITE_PAWN;
				mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
				if ( dest < 8 )
					mov.MoveType += Move::MOVE_PROMOTION_QUEEN;
				mov.CapturedPiece = theBoard->FindBlackPiece( dest );
				Moves.push_back( mov );

				// Other promotion captures
				if ( dest < 8 ) {
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::WHITE_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_KNIGHT;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::WHITE_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_BISHOP;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::WHITE_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_ROOK;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );
					Moves.push_back( mov );
				}
			}
			// Now, try an en passant capture
			else if ( ( theBoard->GetEnPassantPawn() & Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::WHITE_PAWN;
				mov.MoveType = Move::MOVE_CAPTURE_EN_PASSANT;
				mov.CapturedPiece = Board::BLACK_PAWN;
				Moves.push_back( mov );
			}
		} else if ( ( square % 8 ) == 7 ) {
			dest = square - 9;
			// Try an ordinary capture first
			if ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
				                        & Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
				if ( dest < 8 )
					mov.MoveType += Move::MOVE_PROMOTION_QUEEN;
				mov.MovingPiece = Board::WHITE_PAWN;
				mov.CapturedPiece = theBoard->FindBlackPiece( dest );
				Moves.push_back( mov );
				// Other promotion captures
				if ( dest < 8 ) {
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::WHITE_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_KNIGHT;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::WHITE_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_BISHOP;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::WHITE_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_ROOK;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );
					Moves.push_back( mov );
				}
			}
			// Now, try an en passant capture
			else if ( ( theBoard->GetEnPassantPawn() & Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MoveType = Move::MOVE_CAPTURE_EN_PASSANT;
				mov.MovingPiece = Board::WHITE_PAWN;
				mov.CapturedPiece = Board::BLACK_PAWN;
				Moves.push_back( mov );
			}
		} else {
			dest = square - 7;
			// Try an ordinary capture first
			if ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
				                        & Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::WHITE_PAWN;
				mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
				if ( dest < 8 )
					mov.MoveType += Move::MOVE_PROMOTION_QUEEN;
				mov.CapturedPiece = theBoard->FindBlackPiece( dest );
				Moves.push_back( mov );

				// Other promotion captures
				if ( dest < 8 ) {
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::WHITE_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_KNIGHT;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::WHITE_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_BISHOP;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::WHITE_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_ROOK;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );
					Moves.push_back( mov );
				}
			}
			// Now, try an en passant capture
			else if ( ( theBoard->GetEnPassantPawn() & Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::WHITE_PAWN;
				mov.MoveType = Move::MOVE_CAPTURE_EN_PASSANT;
				mov.CapturedPiece = Board::BLACK_PAWN;
				Moves.push_back( mov );
			}
			dest = square - 9;
			// Try an ordinary capture first
			if ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
				                        & Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
				if ( dest < 8 )
					mov.MoveType += Move::MOVE_PROMOTION_QUEEN;
				mov.MovingPiece = Board::WHITE_PAWN;
				mov.CapturedPiece = theBoard->FindBlackPiece( dest );
				Moves.push_back( mov );
				// Other promotion captures
				if ( dest < 8 ) {
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::WHITE_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_KNIGHT;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::WHITE_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_BISHOP;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::WHITE_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_ROOK;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );
					Moves.push_back( mov );
				}
			}
			// Now, try an en passant capture
			else if ( ( theBoard->GetEnPassantPawn() & Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MoveType = Move::MOVE_CAPTURE_EN_PASSANT;
				mov.MovingPiece = Board::WHITE_PAWN;
				mov.CapturedPiece = Board::BLACK_PAWN;
				Moves.push_back( mov );
			}
		}

		// And perform the usual trick to abort the loop when we no longer
		// have any pieces to look for
		pieces ^= Board::SquareBits[ square ];
		if ( pieces == 0i64 )
			return true;

	}
	return true;
}



bool MoveListGenerator::ComputeBlackQueenMoves( Board *theBoard )
{
     if ( !ComputeBlackRookMoves  ( theBoard, Board::BLACK_QUEEN ) ) return false;
     if ( !ComputeBlackBishopMoves( theBoard, Board::BLACK_QUEEN ) ) return false;
     return true;
}



bool MoveListGenerator::ComputeBlackKingMoves( Board *theBoard )
{
	static cnt = 0;
	
	cnt++;

	// Fetch the bitboard containing position of the king
	__int64 piecepos = theBoard->GetBitBoard( Board::BLACK_KING );

	// Find it!  There is only one king, so look for it and stop
	int square;
	for( square = 0; square < 64; square++ ) {
		if ( ( Board::SquareBits[ square ] & piecepos ) != 0i64 )
			break;
	}

	// Maybe there's no king left. That happens if we made
	// an illegal move with the king where he will be captured.
	// This failure will be handeled here!
	if ( square == 64 )
		return false;
		
	// Find its moves
	for( int i = 0; i < KingMoves[ square ].size(); i++ ) {
		// Get the destination square
		int dest = KingMoves[ square ][ i ];

		// Is it occupied by a friendly piece?  If so, can't move there
		if ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
			                        & Board::SquareBits[ dest ] ) != 0i64 )
			continue;

		// Otherwise, the move is legal, so we must prepare to add it
		Move mov;
		mov.SourceSquare = square;
		mov.DestinationSquare = dest;
		mov.MovingPiece = Board::BLACK_KING;

		// Is the destination occupied by an enemy?  If so, we have a capture
		if ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) 
			                        & Board::SquareBits[ dest ] ) != 0i64 ) {
			mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
			mov.CapturedPiece = theBoard->FindWhitePiece( dest );

			// If the piece we find is a king, abort because the board
			// position is illegal!
			if ( mov.CapturedPiece == Board::WHITE_KING )
				return false;
		} else { // otherwise, it is a simple move
				
			mov.MoveType = Move::MOVE_NORMAL;
			mov.CapturedPiece = Board::EMPTY_SQUARE;
		}

		// And we add the move to the list
		Moves.push_back( mov );
	}

	// Now, let's consider castling...
	// Kingside first
	if ( theBoard->GetCastlingStatus( Board::CASTLE_KINGSIDE + Player::SIDE_BLACK ) ) {
		// First, check whether there are empty squares between king and rook
		if ( ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
			                          & Board::EMPTYSQUARES_BLACK_KINGSIDE ) == 0i64 ) &&
			 ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) 
			                          & Board::EMPTYSQUARES_BLACK_KINGSIDE ) == 0i64 ) ) {
			Move mov;
			mov.MovingPiece = Board::BLACK_KING;
			mov.SourceSquare = 4;
			mov.DestinationSquare = 6;
			mov.MoveType = Move::MOVE_CASTLING_KINGSIDE;
			mov.CapturedPiece = Board::EMPTY_SQUARE;
			Moves.push_back( mov );
			}
		}
	if ( theBoard->GetCastlingStatus( Board::CASTLE_QUEENSIDE + Player::SIDE_BLACK ) ) {
		if ( ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
			                          & Board::EMPTYSQUARES_BLACK_QUEENSIDE ) == 0i64 ) &&
			 ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) 
			                          & Board::EMPTYSQUARES_BLACK_QUEENSIDE ) == 0i64 ) ) {
			Move mov;
			mov.MovingPiece = Board::BLACK_KING;
			mov.SourceSquare = 4;
			mov.DestinationSquare = 2;
			mov.MoveType = Move::MOVE_CASTLING_QUEENSIDE;
			mov.CapturedPiece = Board::EMPTY_SQUARE;
			Moves.push_back( mov );
		}
	}
	return true;
}



bool MoveListGenerator::ComputeBlackRookMoves( Board *theBoard, int pieceType )
{
    // Fetch the bitboard containing positions of these pieces
    __int64 pieces = theBoard->GetBitBoard( pieceType );

    // If there are no pieces of this type, no need to work very hard!
    if ( pieces == 0i64 )
		return true;

    // This is a black piece, so let's start looking at the top
    // of the board
    for( int square = 0; square < 64; square++ ) {
		if ( ( pieces & Board::SquareBits[ square ] ) != 0i64 ) {
			// There is a piece here; find its moves
			for( int ray = 0; ray < RookMoves[ square ].size(); ray++ ) {
				for( int i = 0; i < RookMoves[ square ][ ray ].size(); i++ ) {
					// Get the destination square
					int dest = RookMoves[ square ][ ray ][ i ];

					// Is it occupied by a friendly piece?  If so, can't move there
					// AND we must discontinue the current ray
					if ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
						                        & Board::SquareBits[ dest ] ) != 0i64 )
						break;

					// Otherwise, the move is legal, so we must prepare to add it
					Move mov;
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = pieceType;

					// Is the destination occupied by an enemy?  If so, we have a capture
					if ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) 
						                        & Board::SquareBits[ dest ] ) != 0i64 ) {
						mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
						mov.CapturedPiece = theBoard->FindWhitePiece( dest );

						// If the piece we find is a king, abort because the board
						// position is illegal!
						if ( mov.CapturedPiece == Board::WHITE_KING )
							return false;

						Moves.push_back( mov );
						break;
					} else { // otherwise, it is a simple move
						mov.MoveType = Move::MOVE_NORMAL;
						mov.CapturedPiece = Board::EMPTY_SQUARE;
						Moves.push_back( mov );
					}
				}
			}
			// Turn off the bit in the temporary bitboard; this way, we can
			// detect whether we have found the last of this type of piece
			// and short-circuit the loop
			pieces ^= Board::SquareBits[ square ];
			if ( pieces == 0i64 )
				return true;
		}
	}

    // We should never get here, but the return statement is added to prevent
    // obnoxious compiler warnings
    return true;
}



bool MoveListGenerator::ComputeBlackBishopMoves( Board *theBoard, int pieceType )
{
    // Fetch the bitboard containing positions of these pieces
    __int64 pieces = theBoard->GetBitBoard( pieceType );

    // If there are no pieces of this type, no need to work very hard!
    if ( pieces == 0i64 )
		return true;

    // This is a black piece, so let's start looking at the top
    // of the board
    for( int square = 0; square < 64; square++ ) {
       if ( ( pieces & Board::SquareBits[ square ] ) != 0i64 ) {
			// There is a piece here; find its moves
			for( int ray = 0; ray < BishopMoves[ square ].size(); ray++ ) {
				for( int i = 0; i < BishopMoves[ square ][ ray ].size(); i++ ) {
					// Get the destination square
					int dest = BishopMoves[ square ][ ray ][ i ];

					// Is it occupied by a friendly piece?  If so, can't move there
					// AND we must discontinue the current ray
					if ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
						                        & Board::SquareBits[ dest ] ) != 0i64 )
					break;

					// Otherwise, the move is legal, so we must prepare to add it
					Move mov;
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = pieceType;

					// Is the destination occupied by an enemy?  If so, we have a capture
					if ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) 
						                        & Board::SquareBits[ dest ] ) != 0i64 ) {
						mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
						mov.CapturedPiece = theBoard->FindWhitePiece( dest );

					// If the piece we find is a king, abort because the board
					// position is illegal!
					if ( mov.CapturedPiece == Board::WHITE_KING )
						return false;

					// Otherwise, add the move to the list and interrupt the ray
					Moves.push_back( mov );
					break;
				} else {
					mov.MoveType = Move::MOVE_NORMAL;
					mov.CapturedPiece = Board::EMPTY_SQUARE;
					Moves.push_back( mov );
				}
			}
		}
        // Turn off the bit in the temporary bitboard; this way, we can
        // detect whether we have found the last of this type of piece
        // and short-circuit the loop
        pieces ^= Board::SquareBits[ square ];
        if ( pieces == 0i64 )
			return true;
		}
	}

    // We should never get here, but the return statement is added to prevent
    // obnoxious compiler warnings
    return true;
}



bool MoveListGenerator::ComputeBlackKnightMoves( Board *theBoard )
{
    // Fetch the bitboard containing positions of these pieces
    __int64 pieces = theBoard->GetBitBoard( Board::BLACK_KNIGHT );

    // If there are no pieces of this type, no need to work very hard!
    if ( pieces == 0i64 )
		return true;

    // This is a black piece, so let's start looking at the top
    // of the board
    for( int square = 0; square < 64; square++ ) {
		if ( ( pieces & Board::SquareBits[ square ] ) != 0i64 ) {
			// There is a piece here; find its moves
			for( int i = 0; i < KnightMoves[ square ].size(); i++ ) {
				// Get the destination square
				int dest = KnightMoves[ square ][ i ];

				// Is it occupied by a friendly piece?  If so, can't move there
				if ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) & 
					                          Board::SquareBits[ dest ] ) != 0i64 )
					continue;

				// Otherwise, the move is legal, so we must prepare to add it
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::BLACK_KNIGHT;

				// Is the destination occupied by an enemy?  If so, we have a capture
				if ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) &
					                          Board::SquareBits[ dest ] ) != 0i64 ) {
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );

					// If the piece we find is a king, abort because the board
					// position is illegal!
					if ( mov.CapturedPiece == Board::WHITE_KING )
						return false;
				} else { // otherwise, it is a simple move
					mov.MoveType = Move::MOVE_NORMAL;
					mov.CapturedPiece = Board::EMPTY_SQUARE;
				}

				// And we add the move to the list
				Moves.push_back( mov );
			}

		// Turn off the bit in the temporary bitboard; this way, we can
        // detect whether we have found the last of this type of piece
        // and short-circuit the loop
        pieces ^= Board::SquareBits[ square ];
        if ( pieces == 0i64 )
			return true;
		}
	}

    // We should never get here, but the return statement is added to prevent
    // obnoxious compiler warnings
    return true;
}



bool MoveListGenerator::ComputeBlackPawnMoves( Board *theBoard )
{
    // Fetch the bitboard containing positions of these pieces
    __int64 pieces = theBoard->GetBitBoard( Board::BLACK_PAWN );

    // If there are no pieces of this type, no need to work very hard!
    if ( pieces == 0i64 )
		return true;

    // a small optimization
    __int64 allPieces = theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) |
                        theBoard->GetBitBoard( Board::ALL_WHITE_PIECES );

    // This is a black piece, so let's start looking at the top
    // of the Board::.. But only consider positions where a pawn can
    // actually dwell!
    int dest;
    for( int square = 8; square < 56; square++ ) {
		if ( ( pieces & Board::SquareBits[ square ] ) == 0i64 )
			continue;

		// First, try a normal pawn pushing
		dest = square + 8;
		if ( ( allPieces & Board::SquareBits[ dest ] ) == 0i64 ) {
			// Unless this push results in a promotion...
			if ( square < 48 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::BLACK_PAWN;
				mov.MoveType = Move::MOVE_NORMAL;
				Moves.push_back( mov );

				// Is there a chance to perform a double push? Only if the piece
				// is in its original square
				if ( square < 16 ) {
					dest += 8;
					if ( ( allPieces & Board::SquareBits[ dest ] ) == 0i64 ) {
						mov.SourceSquare = square;
						mov.DestinationSquare = dest;
						mov.MovingPiece = Board::BLACK_PAWN;
						mov.MoveType = Move::MOVE_NORMAL;
						Moves.push_back( mov );
					}
				}
			} else { // if square >= 48
				// We are now looking at pawn promotion!
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::BLACK_PAWN;
				mov.MoveType = Move::MOVE_PROMOTION_QUEEN + Move::MOVE_NORMAL;
				Moves.push_back( mov );
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::BLACK_PAWN;
				mov.MoveType = Move::MOVE_PROMOTION_KNIGHT + Move::MOVE_NORMAL;
				Moves.push_back( mov );
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::BLACK_PAWN;
				mov.MoveType = Move::MOVE_PROMOTION_ROOK + Move::MOVE_NORMAL;
				Moves.push_back( mov );
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::BLACK_PAWN;
				mov.MoveType = Move::MOVE_PROMOTION_BISHOP + Move::MOVE_NORMAL;
				Moves.push_back( mov );
			}
		}

		// Now, let's try a capture
		// Three cases: the pawn is on the 1st file, the 8th file, or elsewhere
		if ( ( square % 8 ) == 0 ) {
			dest = square + 9;
			// Try an ordinary capture first
			if ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES )	
										& Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::BLACK_PAWN;
				mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
				if ( dest >= 56 )
					mov.MoveType += Move::MOVE_PROMOTION_QUEEN;
				mov.CapturedPiece = theBoard->FindWhitePiece( dest );
				Moves.push_back( mov );

				// Other promotion captures
				if ( dest >= 56 ) {
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::BLACK_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_KNIGHT;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::BLACK_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_BISHOP;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::BLACK_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_ROOK;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );
					Moves.push_back( mov );
				}
			}
			// Now, try an en passant capture
			else if ( ( theBoard->GetEnPassantPawn() & Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::BLACK_PAWN;
				mov.MoveType = Move::MOVE_CAPTURE_EN_PASSANT;
				mov.CapturedPiece = Board::WHITE_PAWN;
				Moves.push_back( mov );
			}
		} else if ( ( square % 8 ) == 7 ) {
			dest = square + 7;
			// Try an ordinary capture first
			if ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) 
										& Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
				if ( dest >= 56 )
					mov.MoveType += Move::MOVE_PROMOTION_QUEEN;
				mov.MovingPiece = Board::BLACK_PAWN;
				mov.CapturedPiece = theBoard->FindWhitePiece( dest );
				Moves.push_back( mov );
				// Other promotion captures
				if ( dest >= 56 ) {
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::BLACK_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_KNIGHT;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::BLACK_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_BISHOP;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::BLACK_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_ROOK;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );
					Moves.push_back( mov );
				}
			}
			// Now, try an en passant capture
			else if ( ( theBoard->GetEnPassantPawn() & Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MoveType = Move::MOVE_CAPTURE_EN_PASSANT;
				mov.MovingPiece = Board::BLACK_PAWN;
				mov.CapturedPiece = Board::WHITE_PAWN;
				Moves.push_back( mov );
			}
		} else {
			dest = square + 9;
			// Try an ordinary capture first
			if ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) 
										& Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::BLACK_PAWN;
				mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
				if ( dest >= 56 )
					mov.MoveType += Move::MOVE_PROMOTION_QUEEN;
				mov.CapturedPiece = theBoard->FindWhitePiece( dest );
				Moves.push_back( mov );
				// Other promotion captures
				if ( dest >= 56 ) {
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::BLACK_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_KNIGHT;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::BLACK_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_BISHOP;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::BLACK_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_ROOK;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );
					Moves.push_back( mov );
				}
			}
			// Now, try an en passant capture
			else if ( ( theBoard->GetEnPassantPawn() & Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MoveType = Move::MOVE_CAPTURE_EN_PASSANT;
				mov.MovingPiece = Board::BLACK_PAWN;
				mov.CapturedPiece = Board::WHITE_PAWN;
				Moves.push_back( mov );
			}
			dest = square + 7;
			// Try an ordinary capture first
			if ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) 
										& Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::BLACK_PAWN;
				mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
				if ( dest >= 56 )
					mov.MoveType += Move::MOVE_PROMOTION_QUEEN;
				mov.CapturedPiece = theBoard->FindWhitePiece( dest );
				Moves.push_back( mov );
				// Other promotion captures
				if ( dest >= 56 ) {
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::BLACK_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_KNIGHT;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::BLACK_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_BISHOP;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::BLACK_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_ROOK;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );
					Moves.push_back( mov );
				}
			}
			// Now, try an en passant capture
			else if ( ( theBoard->GetEnPassantPawn() & Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MoveType = Move::MOVE_CAPTURE_EN_PASSANT;
				mov.MovingPiece = Board::BLACK_PAWN;
				mov.CapturedPiece = Board::WHITE_PAWN;
				Moves.push_back( mov );
			}
		}

		// And perform the usual trick to abort the loop when we no longer
		// have any pieces to look for
		pieces ^= Board::SquareBits[ square ];
		if ( pieces == 0i64 )
			return true;
		}

    return true;
}



/* sorts the moves in a stable way in descendung order
   using the static histroytable ( hidden in operator < in Move */
void MoveListGenerator::Sort(){       
	// descending order ->rbegin & rend;
	stable_sort( Moves.rbegin(), Moves.rend() );
}







bool MoveListGenerator::ComputeWhiteQuiescenceQueenMoves( Board *theBoard )
{
	assert( theBoard != NULL );
	
	if ( !ComputeWhiteQuiescenceBishopMoves( theBoard, Board::WHITE_QUEEN ) ) return false;
	if ( !ComputeWhiteQuiescenceRookMoves  ( theBoard, Board::WHITE_QUEEN ) ) return false;
  
	return true;
}




bool MoveListGenerator::ComputeWhiteQuiescenceKingMoves( Board *theBoard )
{
	assert( theBoard != NULL );

	// Fetch the bitboard containing position of the king
	__int64 pieces = theBoard->GetBitBoard( Board::WHITE_KING );

	// Find it!  There is only one king, so look for it and stop
	int square;
	for( square = 0; square < 64; square++ ) {
		if ( ( Board::SquareBits[ square ] & pieces ) != 0i64 )
			break;
	}

	// Maybe there's no king left. That happens if we made
	// an illegal move with the king where he will be captured.
	// This failure will be handeled here!
	if ( square == 64 )
		return false;
	
	// Find its moves
	for( int i = 0; i < KingMoves[ square ].size(); i++ ) {
		// Get the destination square
		int dest = KingMoves[ square ][ i ];

		// Is it occupied by a friendly piece?  If so, can't move there
		if ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) 
			                        & Board::SquareBits[ dest ] ) != 0i64 )
			continue;

		// Otherwise, the move is legal, so we must prepare to add it
		Move mov;
		mov.SourceSquare = square;
		mov.DestinationSquare = dest;
		mov.MovingPiece = Board::WHITE_KING;

		// Is the destination occupied by an enemy?  If so, we have a capture
		if ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
			                        & Board::SquareBits[ dest ] ) != 0i64 ) {
			mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
			mov.CapturedPiece = theBoard->FindBlackPiece( dest );

			// If the piece we find is a king, abort because the board
			// position is illegal!
			if ( mov.CapturedPiece == Board::BLACK_KING )
				return false;
		} else { // otherwise, it is a simple move
			continue; 
		}

		// And we add the move to the list
		Moves.push_back( mov );

	}

	return true;
}




bool MoveListGenerator::ComputeWhiteQuiescenceRookMoves( Board *theBoard, int pieceType )
{
     // Fetch the bitboard containing positions of these pieces
     __int64 pieces = theBoard->GetBitBoard( pieceType );

     // If there are no pieces of this type, no need to work very hard!
     if ( pieces == 0i64 )
		return true;

     // This is a white piece, so let's start looking at the bottom
     // of the board
     for( int square = 63; square >= 0; square-- ) {
		if ( ( pieces & Board::SquareBits[ square ] ) != 0i64 ) {
			// There is a piece here; find its moves
			for( int ray = 0; ray < RookMoves[ square ].size(); ray++ ) {
				for( int i = 0; i < RookMoves[ square ][ ray ].size(); i++ ) {
					// Get the destination square
					int dest = RookMoves[ square ][ ray ][ i ];

					// Is it occupied by a friendly piece?  If so, can't move there
					// AND we must discontinue the current ray
					if ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) 
						                        & Board::SquareBits[ dest ] ) != 0i64 )
						break;

					// Otherwise, the move is legal, so we must prepare to add it
					Move mov;
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = pieceType;

					// Is the destination occupied by an enemy?  If so, we have a capture
					if ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
						                        & Board::SquareBits[ dest ] ) != 0i64 ) {
						mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
						mov.CapturedPiece = theBoard->FindBlackPiece( dest );

						// If the piece we find is a king, abort because the board
						// position is illegal!
						if ( mov.CapturedPiece == Board::BLACK_KING ) 
							return false;

						Moves.push_back( mov );
						break;
					} else {  // otherwise, it is a simple move
						continue;
					}
				}
			}
			// Turn off the bit in the temporary bitboard; this way, we can
			// detect whether we have found the last of this type of piece
			// and short-circuit the loop
			pieces ^= Board::SquareBits[ square ];
			if ( pieces == 0i64 )
				return true;
		 }
    }

    // We should never get here, but the return statement is added to prevent
    // obnoxious compiler warnings
	return true;
}



bool MoveListGenerator::ComputeWhiteQuiescenceBishopMoves( Board *theBoard, int pieceType )
{
    // Fetch the bitboard containing positions of these pieces
    __int64 pieces = theBoard->GetBitBoard( pieceType );

    // If there are no pieces of this type, no need to work very hard!
	if ( pieces == 0i64 )
		return true;

    // This is a white piece, so let's start looking at the bottom
    // of the board
    for( int square = 63; square >= 0; square-- ) {
		if ( ( pieces & Board::SquareBits[ square ] ) != 0i64 ) {
			// There is a piece here; find its moves
			for( int ray = 0; ray < BishopMoves[ square ].size(); ray++ ) {
				for( int i = 0; i < BishopMoves[ square ][ ray ].size(); i++ ) {
					// Get the destination square
					int dest = BishopMoves[ square ][ ray ][ i ];

					// Is it occupied by a friendly piece?  If so, can't move there
					// AND we must discontinue the current ray
					if ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) 
						                        & Board::SquareBits[ dest ] ) != 0i64 )
						break;

					// Otherwise, the move is legal, so we must prepare to add it
					Move mov;
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = pieceType;

					// Is the destination occupied by an enemy?  If so, we have a capture
					if ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
						                        & Board::SquareBits[ dest ] ) != 0i64 ) {
						mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
						mov.CapturedPiece = theBoard->FindBlackPiece( dest );

						// If the piece we find is a king, abort because the board
						// position is illegal!
						if ( mov.CapturedPiece == Board::BLACK_KING ) 
							return false;

						Moves.push_back( mov );
						break;
					} else { // otherwise, it is a simple move
						continue;
					}
				}
			}
			// Turn off the bit in the temporary bitboard; this way, we can
			// detect whether we have found the last of this type of piece
			// and short-circuit the loop
			pieces ^= Board::SquareBits[ square ];
			if ( pieces == 0i64 )
				return true;
		}
	}

    // We should never get here, but the return statement is added to prevent
    // obnoxious compiler warnings
    return true;
}



bool MoveListGenerator::ComputeWhiteQuiescenceKnightMoves( Board *theBoard )
{
     // Fetch the bitboard containing positions of these pieces
     __int64 pieces = theBoard->GetBitBoard( Board::WHITE_KNIGHT );

     // If there are no pieces of this type, no need to work very hard!
     if ( pieces == 0i64 )
		return true;

     // This is a white piece, so let's start looking at the bottom
     // of the board
     for( int square = 63; square >= 0; square-- ) {
		if ( ( pieces & Board::SquareBits[ square ] ) != 0 ) {
			// There is a piece here; find its moves
			for( int i = 0; i < KnightMoves[ square ].size(); i++ ) {
				// Get the destination square
				int dest = KnightMoves[ square ][ i ];

				// Is it occupied by a friendly piece?  If so, can't move there
				if ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) 
					                        & Board::SquareBits[ dest ] ) != 0i64 )
					continue;

				// Otherwise, the move is legal, so we must prepare to add it
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::WHITE_KNIGHT;

				// Is the destination occupied by an enemy?  If so, we have a capture
				if ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
					                        & Board::SquareBits[ dest ] ) != 0i64 ) {
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );

					// If the piece we find is a king, abort because the board
					// position is illegal!
					if ( mov.CapturedPiece == Board::BLACK_KING ) {
						return false;
					}
				} else { // otherwise, it is a simple move
					continue;
				}

				// And we add the move to the list
				Moves.push_back( mov );
			}

			// Turn off the bit in the temporary bitboard; this way, we can
			// detect whether we have found the last of this type of piece
			// and short-circuit the loop
			pieces ^= Board::SquareBits[ square ];
			if ( pieces == 0i64 )
				return true;
		}
	}

    // We should never get here, but the return statement is added to prevent
    // obnoxious compiler warnings
    return true;
}



bool MoveListGenerator::ComputeWhiteQuiescencePawnMoves( Board *theBoard )
{
	// Fetch the bitboard containing positions of these pieces
    __int64 pieces = theBoard->GetBitBoard( Board::WHITE_PAWN );

    // If there are no pieces of this type, no need to work very hard!
    if ( pieces == 0i64 )
		return true;

    // a small optimization
    __int64 allPieces = theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) |
                        theBoard->GetBitBoard( Board::ALL_WHITE_PIECES );

    // This is a white piece, so let's start looking at the bottom
    // of the Board::.. But only consider positions where a pawn can
    // actually dwell!
    int dest;
    for( int square = 55; square >= 8; square-- ) {
		if ( ( pieces & Board::SquareBits[ square ] ) == 0i64 )
			continue;

		// Now, let's try a capture
		// Three cases: the pawn is on the 1st file, the 8th file, or elsewhere
		if ( ( square % 8 ) == 0 ) {
			dest = square - 7;
			// Try an ordinary capture first
			if ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
				                        & Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::WHITE_PAWN;
				mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
				if ( dest < 8 )
					mov.MoveType += Move::MOVE_PROMOTION_QUEEN;
				mov.CapturedPiece = theBoard->FindBlackPiece( dest );
				Moves.push_back( mov );

				// Other promotion captures
				if ( dest < 8 ) {
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::WHITE_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_KNIGHT;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::WHITE_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_BISHOP;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::WHITE_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_ROOK;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );
					Moves.push_back( mov );
				}
			}
			// Now, try an en passant capture
			else if ( ( theBoard->GetEnPassantPawn() & Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::WHITE_PAWN;
				mov.MoveType = Move::MOVE_CAPTURE_EN_PASSANT;
				mov.CapturedPiece = Board::BLACK_PAWN;
				Moves.push_back( mov );
			}
		} else if ( ( square % 8 ) == 7 ) {
			dest = square - 9;
			// Try an ordinary capture first
			if ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
				                        & Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
				if ( dest < 8 )
					mov.MoveType += Move::MOVE_PROMOTION_QUEEN;
				mov.MovingPiece = Board::WHITE_PAWN;
				mov.CapturedPiece = theBoard->FindBlackPiece( dest );
				Moves.push_back( mov );
				// Other promotion captures
				if ( dest < 8 ) {
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::WHITE_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_KNIGHT;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::WHITE_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_BISHOP;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::WHITE_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_ROOK;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );
					Moves.push_back( mov );
				}
			}
			// Now, try an en passant capture
			else if ( ( theBoard->GetEnPassantPawn() & Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MoveType = Move::MOVE_CAPTURE_EN_PASSANT;
				mov.MovingPiece = Board::WHITE_PAWN;
				mov.CapturedPiece = Board::BLACK_PAWN;
				Moves.push_back( mov );
			}
		} else {
			dest = square - 7;
			// Try an ordinary capture first
			if ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
				                        & Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::WHITE_PAWN;
				mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
				if ( dest < 8 )
					mov.MoveType += Move::MOVE_PROMOTION_QUEEN;
				mov.CapturedPiece = theBoard->FindBlackPiece( dest );
				Moves.push_back( mov );

				// Other promotion captures
				if ( dest < 8 ) {
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::WHITE_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_KNIGHT;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::WHITE_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_BISHOP;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::WHITE_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_ROOK;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );
					Moves.push_back( mov );
				}
			}
			// Now, try an en passant capture
			else if ( ( theBoard->GetEnPassantPawn() & Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::WHITE_PAWN;
				mov.MoveType = Move::MOVE_CAPTURE_EN_PASSANT;
				mov.CapturedPiece = Board::BLACK_PAWN;
				Moves.push_back( mov );
			}
			dest = square - 9;
			// Try an ordinary capture first
			if ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
				                        & Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
				if ( dest < 8 )
					mov.MoveType += Move::MOVE_PROMOTION_QUEEN;
				mov.MovingPiece = Board::WHITE_PAWN;
				mov.CapturedPiece = theBoard->FindBlackPiece( dest );
				Moves.push_back( mov );
				// Other promotion captures
				if ( dest < 8 ) {
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::WHITE_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_KNIGHT;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::WHITE_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_BISHOP;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::WHITE_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_ROOK;
					mov.CapturedPiece = theBoard->FindBlackPiece( dest );
					Moves.push_back( mov );
				}
			}
			// Now, try an en passant capture
			else if ( ( theBoard->GetEnPassantPawn() & Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MoveType = Move::MOVE_CAPTURE_EN_PASSANT;
				mov.MovingPiece = Board::WHITE_PAWN;
				mov.CapturedPiece = Board::BLACK_PAWN;
				Moves.push_back( mov );
			}
		}

		// And perform the usual trick to abort the loop when we no longer
		// have any pieces to look for
		pieces ^= Board::SquareBits[ square ];
		if ( pieces == 0i64 )
			return true;

	}
	return true;
}



bool MoveListGenerator::ComputeBlackQuiescenceQueenMoves( Board *theBoard )
{
     if ( !ComputeBlackQuiescenceRookMoves  ( theBoard, Board::BLACK_QUEEN ) ) return false;
     if ( !ComputeBlackQuiescenceBishopMoves( theBoard, Board::BLACK_QUEEN ) ) return false;
     return true;
}



bool MoveListGenerator::ComputeBlackQuiescenceKingMoves( Board *theBoard )
{
	static cnt = 0;
	
	cnt++;

	// Fetch the bitboard containing position of the king
	__int64 piecepos = theBoard->GetBitBoard( Board::BLACK_KING );

	// Find it!  There is only one king, so look for it and stop
	int square;
	for( square = 0; square < 64; square++ ) {
		if ( ( Board::SquareBits[ square ] & piecepos ) != 0i64 )
			break;
	}

	// Maybe there's no king left. That happens if we made
	// an illegal move with the king where he will be captured.
	// This failure will be handeled here!
	if ( square == 64 )
		return false;
		
	// Find its moves
	for( int i = 0; i < KingMoves[ square ].size(); i++ ) {
		// Get the destination square
		int dest = KingMoves[ square ][ i ];

		// Is it occupied by a friendly piece?  If so, can't move there
		if ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
			                        & Board::SquareBits[ dest ] ) != 0i64 )
			continue;

		// Otherwise, the move is legal, so we must prepare to add it
		Move mov;
		mov.SourceSquare = square;
		mov.DestinationSquare = dest;
		mov.MovingPiece = Board::BLACK_KING;

		// Is the destination occupied by an enemy?  If so, we have a capture
		if ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) 
			                        & Board::SquareBits[ dest ] ) != 0i64 ) {
			mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
			mov.CapturedPiece = theBoard->FindWhitePiece( dest );

			// If the piece we find is a king, abort because the board
			// position is illegal!
			if ( mov.CapturedPiece == Board::WHITE_KING )
				return false;
		} else { // otherwise, it is a simple move
			continue;
		}

		// And we add the move to the list
		Moves.push_back( mov );
	}

	return true;
}



bool MoveListGenerator::ComputeBlackQuiescenceRookMoves( Board *theBoard, int pieceType )
{
    // Fetch the bitboard containing positions of these pieces
    __int64 pieces = theBoard->GetBitBoard( pieceType );

    // If there are no pieces of this type, no need to work very hard!
    if ( pieces == 0i64 )
		return true;

    // This is a black piece, so let's start looking at the top
    // of the board
    for( int square = 0; square < 64; square++ ) {
		if ( ( pieces & Board::SquareBits[ square ] ) != 0i64 ) {
			// There is a piece here; find its moves
			for( int ray = 0; ray < RookMoves[ square ].size(); ray++ ) {
				for( int i = 0; i < RookMoves[ square ][ ray ].size(); i++ ) {
					// Get the destination square
					int dest = RookMoves[ square ][ ray ][ i ];

					// Is it occupied by a friendly piece?  If so, can't move there
					// AND we must discontinue the current ray
					if ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
						                        & Board::SquareBits[ dest ] ) != 0i64 )
						break;

					// Otherwise, the move is legal, so we must prepare to add it
					Move mov;
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = pieceType;

					// Is the destination occupied by an enemy?  If so, we have a capture
					if ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) 
						                        & Board::SquareBits[ dest ] ) != 0i64 ) {
						mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
						mov.CapturedPiece = theBoard->FindWhitePiece( dest );

						// If the piece we find is a king, abort because the board
						// position is illegal!
						if ( mov.CapturedPiece == Board::WHITE_KING )
							return false;

						Moves.push_back( mov );
						break;
					} else { // otherwise, it is a simple move
						continue;
					}
				}
			}
			// Turn off the bit in the temporary bitboard; this way, we can
			// detect whether we have found the last of this type of piece
			// and short-circuit the loop
			pieces ^= Board::SquareBits[ square ];
			if ( pieces == 0i64 )
				return true;
		}
	}

    // We should never get here, but the return statement is added to prevent
    // obnoxious compiler warnings
    return true;
}



bool MoveListGenerator::ComputeBlackQuiescenceBishopMoves( Board *theBoard, int pieceType )
{
    // Fetch the bitboard containing positions of these pieces
    __int64 pieces = theBoard->GetBitBoard( pieceType );

    // If there are no pieces of this type, no need to work very hard!
    if ( pieces == 0i64 )
		return true;

    // This is a black piece, so let's start looking at the top
    // of the board
    for( int square = 0; square < 64; square++ ) {
       if ( ( pieces & Board::SquareBits[ square ] ) != 0i64 ) {
			// There is a piece here; find its moves
			for( int ray = 0; ray < BishopMoves[ square ].size(); ray++ ) {
				for( int i = 0; i < BishopMoves[ square ][ ray ].size(); i++ ) {
					// Get the destination square
					int dest = BishopMoves[ square ][ ray ][ i ];

					// Is it occupied by a friendly piece?  If so, can't move there
					// AND we must discontinue the current ray
					if ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) 
						                        & Board::SquareBits[ dest ] ) != 0i64 )
					break;

					// Otherwise, the move is legal, so we must prepare to add it
					Move mov;
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = pieceType;

					// Is the destination occupied by an enemy?  If so, we have a capture
					if ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) 
						                        & Board::SquareBits[ dest ] ) != 0i64 ) {
						mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
						mov.CapturedPiece = theBoard->FindWhitePiece( dest );

					// If the piece we find is a king, abort because the board
					// position is illegal!
					if ( mov.CapturedPiece == Board::WHITE_KING )
						return false;

					// Otherwise, add the move to the list and interrupt the ray
					Moves.push_back( mov );
					break;
				} else {
					continue;
				}
			}
		}
        // Turn off the bit in the temporary bitboard; this way, we can
        // detect whether we have found the last of this type of piece
        // and short-circuit the loop
        pieces ^= Board::SquareBits[ square ];
        if ( pieces == 0i64 )
			return true;
		}
	}

    // We should never get here, but the return statement is added to prevent
    // obnoxious compiler warnings
    return true;
}



bool MoveListGenerator::ComputeBlackQuiescenceKnightMoves( Board *theBoard )
{
    // Fetch the bitboard containing positions of these pieces
    __int64 pieces = theBoard->GetBitBoard( Board::BLACK_KNIGHT );

    // If there are no pieces of this type, no need to work very hard!
    if ( pieces == 0i64 )
		return true;

    // This is a black piece, so let's start looking at the top
    // of the board
    for( int square = 0; square < 64; square++ ) {
		if ( ( pieces & Board::SquareBits[ square ] ) != 0i64 ) {
			// There is a piece here; find its moves
			for( int i = 0; i < KnightMoves[ square ].size(); i++ ) {
				// Get the destination square
				int dest = KnightMoves[ square ][ i ];

				// Is it occupied by a friendly piece?  If so, can't move there
				if ( ( theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) & 
					                          Board::SquareBits[ dest ] ) != 0i64 )
					continue;

				// Otherwise, the move is legal, so we must prepare to add it
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::BLACK_KNIGHT;

				// Is the destination occupied by an enemy?  If so, we have a capture
				if ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) &
					                          Board::SquareBits[ dest ] ) != 0i64 ) {
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );

					// If the piece we find is a king, abort because the board
					// position is illegal!
					if ( mov.CapturedPiece == Board::WHITE_KING )
						return false;
				} else { // otherwise, it is a simple move
					continue;
				}

				// And we add the move to the list
				Moves.push_back( mov );
			}

		// Turn off the bit in the temporary bitboard; this way, we can
        // detect whether we have found the last of this type of piece
        // and short-circuit the loop
        pieces ^= Board::SquareBits[ square ];
        if ( pieces == 0i64 )
			return true;
		}
	}

    // We should never get here, but the return statement is added to prevent
    // obnoxious compiler warnings
    return true;
}



bool MoveListGenerator::ComputeBlackQuiescencePawnMoves( Board *theBoard )
{
    // Fetch the bitboard containing positions of these pieces
    __int64 pieces = theBoard->GetBitBoard( Board::BLACK_PAWN );

    // If there are no pieces of this type, no need to work very hard!
    if ( pieces == 0i64 )
		return true;

    // a small optimization
    __int64 allPieces = theBoard->GetBitBoard( Board::ALL_BLACK_PIECES ) |
                        theBoard->GetBitBoard( Board::ALL_WHITE_PIECES );

    // This is a black piece, so let's start looking at the top
    // of the Board::.. But only consider positions where a pawn can
    // actually dwell!
    int dest;
    for( int square = 8; square < 56; square++ ) {
		if ( ( pieces & Board::SquareBits[ square ] ) == 0i64 )
			continue;

		// Now, let's try a capture
		// Three cases: the pawn is on the 1st file, the 8th file, or elsewhere
		if ( ( square % 8 ) == 0 ) {
			dest = square + 9;
			// Try an ordinary capture first
			if ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES )	
										& Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::BLACK_PAWN;
				mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
				if ( dest >= 56 )
					mov.MoveType += Move::MOVE_PROMOTION_QUEEN;
				mov.CapturedPiece = theBoard->FindWhitePiece( dest );
				Moves.push_back( mov );

				// Other promotion captures
				if ( dest >= 56 ) {
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::BLACK_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_KNIGHT;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::BLACK_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_BISHOP;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::BLACK_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_ROOK;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );
					Moves.push_back( mov );
				}
			}
			// Now, try an en passant capture
			else if ( ( theBoard->GetEnPassantPawn() & Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::BLACK_PAWN;
				mov.MoveType = Move::MOVE_CAPTURE_EN_PASSANT;
				mov.CapturedPiece = Board::WHITE_PAWN;
				Moves.push_back( mov );
			}
		} else if ( ( square % 8 ) == 7 ) {
			dest = square + 7;
			// Try an ordinary capture first
			if ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) 
										& Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
				if ( dest >= 56 )
					mov.MoveType += Move::MOVE_PROMOTION_QUEEN;
				mov.MovingPiece = Board::BLACK_PAWN;
				mov.CapturedPiece = theBoard->FindWhitePiece( dest );
				Moves.push_back( mov );
				// Other promotion captures
				if ( dest >= 56 ) {
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::BLACK_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_KNIGHT;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::BLACK_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_BISHOP;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::BLACK_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_ROOK;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );
					Moves.push_back( mov );
				}
			}
			// Now, try an en passant capture
			else if ( ( theBoard->GetEnPassantPawn() & Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MoveType = Move::MOVE_CAPTURE_EN_PASSANT;
				mov.MovingPiece = Board::BLACK_PAWN;
				mov.CapturedPiece = Board::WHITE_PAWN;
				Moves.push_back( mov );
			}
		} else {
			dest = square + 9;
			// Try an ordinary capture first
			if ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) 
										& Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::BLACK_PAWN;
				mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
				if ( dest >= 56 )
					mov.MoveType += Move::MOVE_PROMOTION_QUEEN;
				mov.CapturedPiece = theBoard->FindWhitePiece( dest );
				Moves.push_back( mov );
				// Other promotion captures
				if ( dest >= 56 ) {
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::BLACK_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_KNIGHT;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::BLACK_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_BISHOP;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::BLACK_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_ROOK;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );
					Moves.push_back( mov );
				}
			}
			// Now, try an en passant capture
			else if ( ( theBoard->GetEnPassantPawn() & Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MoveType = Move::MOVE_CAPTURE_EN_PASSANT;
				mov.MovingPiece = Board::BLACK_PAWN;
				mov.CapturedPiece = Board::WHITE_PAWN;
				Moves.push_back( mov );
			}
			dest = square + 7;
			// Try an ordinary capture first
			if ( ( theBoard->GetBitBoard( Board::ALL_WHITE_PIECES ) 
										& Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MovingPiece = Board::BLACK_PAWN;
				mov.MoveType = Move::MOVE_CAPTURE_ORDINARY;
				if ( dest >= 56 )
					mov.MoveType += Move::MOVE_PROMOTION_QUEEN;
				mov.CapturedPiece = theBoard->FindWhitePiece( dest );
				Moves.push_back( mov );
				// Other promotion captures
				if ( dest >= 56 ) {
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::BLACK_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_KNIGHT;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::BLACK_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_BISHOP;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );
					Moves.push_back( mov );
					mov.SourceSquare = square;
					mov.DestinationSquare = dest;
					mov.MovingPiece = Board::BLACK_PAWN;
					mov.MoveType = Move::MOVE_CAPTURE_ORDINARY + Move::MOVE_PROMOTION_ROOK;
					mov.CapturedPiece = theBoard->FindWhitePiece( dest );
					Moves.push_back( mov );
				}
			}
			// Now, try an en passant capture
			else if ( ( theBoard->GetEnPassantPawn() & Board::SquareBits[ dest ] ) != 0i64 ) {
				Move mov;
				mov.SourceSquare = square;
				mov.DestinationSquare = dest;
				mov.MoveType = Move::MOVE_CAPTURE_EN_PASSANT;
				mov.MovingPiece = Board::BLACK_PAWN;
				mov.CapturedPiece = Board::WHITE_PAWN;
				Moves.push_back( mov );
			}
		}

		// And perform the usual trick to abort the loop when we no longer
		// have any pieces to look for
		pieces ^= Board::SquareBits[ square ];
		if ( pieces == 0i64 )
			return true;
		}

    return true;
}
